VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMediaInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
' -------------------------------------------------------------------------------
'
'   AVStoDVD - by MrC
'   File: clsMediaInfo.cls
'   Purpose: Class that handle MediaInfo
'   Requires: modUtil.bas
'
' -------------------------------------------------------------------------------


' Define class Enum

#If MEDIAINFO_NO_ENUMS Then
#Else

Private Enum MediaInfo_stream_C
    MediaInfo_Stream_General
    MediaInfo_Stream_Video
    MediaInfo_Stream_Audio
    MediaInfo_Stream_Text
    MediaInfo_Stream_Chapters
    MediaInfo_Stream_Image
    MediaInfo_Stream_Menu
    MediaInfo_Stream_Max
End Enum

Private Enum MediaInfo_info_C
    MediaInfo_Info_Name
    MediaInfo_Info_Text
    MediaInfo_Info_Measure
    MediaInfo_Info_Options
    MediaInfo_Info_Name_Text
    MediaInfo_Info_Measure_Text
    MediaInfo_Info_Info
    MediaInfo_Info_HowTo
    MediaInfo_Info_Max
End Enum

#End If


' Define class Type

Private Type GeneralMediaInfoType
    MediaInfoVersion As String
    PathName As String
    Filename As String
    FileExt As String
    FileSize As String
    Format As String
    VideoTracksCount As String
    AudioTracksCount As String
    TextTracksCount As String
    Time As String
End Type

Private Type VideoMediaInfoType
    Time As String
    Compression As String
    BitRateMode As String
    AvgBitRate As String
    MinBitRate As String
    MaxBitRate As String
    Width As String
    Height As String
    DisplayAspectRatio As String
    PixelAspectRatio As String
    FrameAspectRatio As String
    Standard As String
    FrameRateMode As String
    FPS As String
    FrameCount As String
    ScanType As String
    ScanOrder As String
End Type

Private Type AudioMediaInfoType
    ID(0 To 99) As String
    Time(0 To 99) As String
    Compression(0 To 99) As String
    BitRateMode(0 To 99) As String
    AvgBitRate(0 To 99) As String
    Channels(0 To 99) As String
    SampleRate(0 To 99) As String
    Resolution(0 To 99) As String
    Language(0 To 99) As String
    Delay(0 To 99) As String
End Type

Private Type TextMediaInfoType
    ID(0 To 99) As String
    Format(0 To 99) As String
    Language(0 To 99) As String
    Title(0 To 99) As String
End Type

Private Type ChaptersMediaInfoType
    List As String
End Type


' Define class Variables

Private GeneralInfo As GeneralMediaInfoType
Private VideoInfo As VideoMediaInfoType
Private AudioInfo As AudioMediaInfoType
Private TextInfo As TextMediaInfoType
Private ChaptersInfo As ChaptersMediaInfoType


' APIs

Private Declare Sub MediaInfo_Close Lib "MediaInfo.dll" (ByVal Handle As Long)
Private Declare Sub MediaInfo_Delete Lib "MediaInfo.dll" (ByVal Handle As Long)
'Private Declare Function MediaInfo_Count_Get Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal StreamKind As MediaInfo_stream_C, ByVal StreamNumber As Long) As Long
Private Declare Function MediaInfo_Get Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal StreamKind As MediaInfo_stream_C, ByVal StreamNumber As Long, ByVal Parameter As Long, ByVal InfoKind As MediaInfo_info_C, ByVal SearchKind As MediaInfo_info_C) As Long
Private Declare Function MediaInfo_GetI Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal StreamKind As MediaInfo_stream_C, ByVal StreamNumber As Long, ByVal Parameter As Long, ByVal InfoKind As MediaInfo_info_C) As Long
'Private Declare Function MediaInfo_Inform Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal Reserved As Long) As Long
Private Declare Function MediaInfo_New Lib "MediaInfo.dll" () As Long
'Private Declare Function MediaInfo_New_Quick Lib "MediaInfo.dll" (ByVal File As Long, ByVal Options As Long) As Long
Private Declare Function MediaInfo_Open Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal File As Long) As Long
'Private Declare Function MediaInfo_Open_Buffer Lib "MediaInfo.dll" (ByVal Handle As Long, Begin As Any, ByVal Begin_Size As Long, End_ As Any, ByVal End_Size As Long) As Long
Private Declare Function MediaInfo_Option Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal Option_ As Long, ByVal value As Long) As Long
'Private Declare Function MediaInfo_Save Lib "MediaInfo.dll" (ByVal Handle As Long) As Long
'Private Declare Function MediaInfo_Set Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal ToSet As Long, ByVal StreamKind As MediaInfo_stream_C, ByVal StreamNumber As Long, ByVal Parameter As Long, ByVal OldParameter As Long) As Long
'Private Declare Function MediaInfo_SetI Lib "MediaInfo.dll" (ByVal Handle As Long, ByVal ToSet As Long, ByVal StreamKind As MediaInfo_stream_C, ByVal StreamNumber As Long, ByVal Parameter As Long, ByVal OldParameter As Long) As Long
'Private Declare Function MediaInfo_State_Get Lib "MediaInfo.dll" (ByVal Handle As Long) As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal ms As Long)



Public Function ReadMediaInfo(MediaPathName As String, _
                              Optional MediaInfoPath As String, _
                              Optional bErrDisplay As Boolean = True, _
                              Optional bReadVideo As Boolean = True, _
                              Optional bReadAudio As Boolean = True, _
                              Optional bReadText As Boolean = True, _
                              Optional bReadChapters As Boolean = True) As Boolean

    Dim Handle As Long
    Dim OrigCurDir As String
    Dim OrigMousePointer As MousePointerConstants
    Dim jj As Integer
    Dim Str As String
    Dim FPSOrig As String
    
    On Error GoTo Err_Handling
    
    OrigMousePointer = Screen.MousePointer
    Screen.MousePointer = vbHourglass
    
    ReadMediaInfo = True
    OrigCurDir = CurDir
    If MediaInfoPath = "" Then MediaInfoPath = App.Path & "\Lib"
    ChDrive Left(MediaInfoPath, 2)
    ChDir MediaInfoPath
    
    ' Open MediaInfo handle
    Handle = MediaInfo_New()
    Call MediaInfo_Open(Handle, StrPtr(MediaPathName))
    
    ' Read General info
    With GeneralInfo
        .MediaInfoVersion = bstr(MediaInfo_Option(0, StrPtr("Info_Version"), StrPtr("")))
        .PathName = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("CompleteName"), MediaInfo_Info_Text, MediaInfo_Info_Name))
        .Filename = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("FileName"), MediaInfo_Info_Text, MediaInfo_Info_Name))
        .FileExt = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("FileExtension"), MediaInfo_Info_Text, MediaInfo_Info_Name))
        .FileSize = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("FileSize"), MediaInfo_Info_Text, MediaInfo_Info_Name))
        .Format = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("Format"), MediaInfo_Info_Text, MediaInfo_Info_Name))
        .VideoTracksCount = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("VideoCount"), MediaInfo_Info_Text, MediaInfo_Info_Name))
        .AudioTracksCount = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("AudioCount"), MediaInfo_Info_Text, MediaInfo_Info_Name))
        If Val(.AudioTracksCount) > 99 Then .AudioTracksCount = 99
        .TextTracksCount = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("TextCount"), MediaInfo_Info_Text, MediaInfo_Info_Name))
        ' Handle MediaInfo reading errors
        If .Filename = "" Then
            ReadMediaInfo = False
            If bErrDisplay = True Then MsgBox "Error reading '" & .PathName & "'. Please check the following list and then retry:" & vbCrLf & vbCrLf & "- AviSynth is not (correctly) installed" & vbCrLf & "- MediaInfo.dll is not found" & vbCrLf & "- Filename contains non-standard characters.", vbExclamation + vbOKOnly, App.Title & " (MediaInfo.dll)"
        ElseIf Format = "" Then
            ReadMediaInfo = False
            If bErrDisplay = True Then MsgBox "Error reading '" & MediaPathName & "'." & vbCrLf & vbCrLf & "File format not recognized.", vbExclamation + vbOKOnly, App.Title & " (MediaInfo.dll)"
        End If
        If ReadMediaInfo = False Then GoTo Exit_Handling
    End With
    
    If bReadVideo = True Then
        ' Read Video info
        With VideoInfo
            .Time = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("Duration"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                If .Time = "" Then .Time = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("Duration"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .Compression = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("Codec/String"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .BitRateMode = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("BitRate_Mode"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .AvgBitRate = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("BitRate"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                If .AvgBitRate = "" Then .AvgBitRate = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("BitRate_Nominal"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                If Val(.AvgBitRate) < 0 Then .AvgBitRate = ""
            .MinBitRate = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("BitRate_Minimum"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .MaxBitRate = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("BitRate_Maximum"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .Width = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("Width"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .Height = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("Height"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .DisplayAspectRatio = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("DisplayAspectRatio"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .PixelAspectRatio = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("PixelAspectRatio"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                If .PixelAspectRatio = "" Then .PixelAspectRatio = "1"
            .FrameAspectRatio = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("DisplayAspectRatio_Original"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                If .FrameAspectRatio = "" And .Width <> "" And .Height <> "" Then .FrameAspectRatio = Replace(Round(Val(.Width) / Val(.Height), 3), ",", ".")
            .Standard = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("Standard"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .FrameRateMode = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("FrameRate_Mode"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                If .FrameRateMode = "" Then .FrameRateMode = "CFR"   'otherwise it is "VFR"
            FPSOrig = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("FrameRate_Original"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .FPS = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("FrameRate"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            If bErrDisplay = True Then
                If Val(.FPS) > 0 Then
                    If Val(FPSOrig) > 0 And Val(.FPS) <> Val(FPSOrig) Then
                        If MsgBox("Warning! MediaInfo has detected 2 different FrameRate tags:" & vbCrLf & vbCrLf & _
                                  "FrameRate: " & Val(.FPS) & " fps" & vbCrLf & _
                                  "Original FrameRate: " & Val(FPSOrig) & " fps" & vbCrLf & vbCrLf & _
                                  "Press 'OK' to use " & .FPS & "   or   'Cancel' to use " & FPSOrig & vbCrLf & _
                                  "(Press 'OK' if you do not know)", vbQuestion + vbOKCancel, App.Title & " (MediaInfo.dll)") = vbCancel Then
                            .FPS = FPSOrig
                        End If
                    End If
                Else
                    If Val(FPSOrig) > 0 Then
                        .FPS = FPSOrig
                    Else
                        Do
                            .FPS = InputBox("Warning! FrameRate value detected is invalid." & vbCrLf & vbCrLf & "Please insert it manually.", App.Title & " (MediaInfo.dll)", .FPS)
                        Loop Until Val(.FPS) > 0
                        .FPS = Replace(.FPS, ",", ".")
                    End If
                End If
            End If
            .FrameCount = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("FrameCount"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                If .FrameCount = "" Then .FrameCount = Round(Val(.Time) / 1000 * Val(.FPS), 0)
            .ScanType = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("ScanType"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            .ScanOrder = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("ScanOrder"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            ' Adjusting mpeg2 avgbitrate MediaInfo readings
            If InStr(1, UCase(.Compression), "MPEG-2") <> 0 And GeneralInfo.FileSize <> "" And .Time <> "" Then
                If .BitRateMode = "CBR" Then
                    Str = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Video, 0, StrPtr("BitRate_Nominal"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                    If Str <> "" Then .AvgBitRate = Str
                End If
            End If
        End With
    End If
    
    ' Read Audio info
    If bReadAudio = True And Val(GeneralInfo.AudioTracksCount) > 0 Then
        For jj = 0 To Val(GeneralInfo.AudioTracksCount) - 1
            With AudioInfo
                .ID(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("ID"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .Time(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("Duration"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                    If .Time(jj) = "" Then .Time(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("Duration"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .Compression(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("Codec/String"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .AvgBitRate(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("BitRate"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                    If .AvgBitRate(jj) = "" Then bstr (MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("BitRate_Nominal"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .BitRateMode(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("BitRate_Mode"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                    If .BitRateMode(jj) = "" Then .BitRateMode(jj) = "CBR"
                .Channels(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("Channel(s)"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .SampleRate(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("SamplingRate"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .Resolution(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("Resolution"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .Language(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("Language"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .Delay(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Audio, jj, StrPtr("Video_Delay"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                ' Question on abnormal delay reading
                If Abs(Val(.Delay(jj))) > 5000 Then
                    If MsgBox("Warning! MediaInfo has detected an abnormal Audio track delay:" & vbCrLf & vbCrLf & _
                              "Delay: " & Round(Val(.Delay(jj)) / 1000, 3) & " s" & vbCrLf & vbCrLf & _
                              "Press 'OK' to reset it   or   'Cancel' to use that value anyway" & vbCrLf & _
                              "(Press 'OK' if you do not know)", vbQuestion + vbOKCancel, App.Title & " (MediaInfo.dll)") = vbOK Then
                        .Delay(jj) = ""
                    End If
                End If
                ' Adjust dts bitrate MediaInfo readings
                If UCase(.Compression(jj)) = "DTS" Then
                    Select Case .AvgBitRate(jj)
                    Case "1509750"
                        .AvgBitRate(jj) = "1536000"
                    Case "754500"
                        .AvgBitRate(jj) = "768000"
                    End Select
                End If
            End With
        Next jj
    End If

    ' Read Text (Subs) info
    If bReadText = True And Val(GeneralInfo.TextTracksCount) > 0 Then
        For jj = 0 To Val(GeneralInfo.TextTracksCount) - 1
            With TextInfo
                .ID(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Text, jj, StrPtr("ID"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .Format(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Text, jj, StrPtr("Format"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .Language(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Text, jj, StrPtr("Language"), MediaInfo_Info_Text, MediaInfo_Info_Name))
                .Title(jj) = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Text, jj, StrPtr("Title"), MediaInfo_Info_Text, MediaInfo_Info_Name))
            End With
        Next jj
    End If

    ' Read Chapters Info (up to 99 chapters positions)
    If bReadChapters = True Then
        With ChaptersInfo
            For jj = Val(bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Menu, 0, StrPtr("Chapters_Pos_Begin"), MediaInfo_Info_Text, MediaInfo_Info_Name))) + 1 To Val(bstr(MediaInfo_Get(Handle, MediaInfo_Stream_Menu, 0, StrPtr("Chapters_Pos_End"), MediaInfo_Info_Text, MediaInfo_Info_Name)))
                Str = bstr(MediaInfo_GetI(Handle, MediaInfo_Stream_Menu, 0, jj, MediaInfo_Info_Name))
                If Str <> "" Then
                    .List = .List & Str & " "
                End If
            Next jj
            If Right(.List, 1) = " " Then .List = Left(.List, Len(.List) - 1)
        End With
    End If
    
    ' Calculating Time
    With GeneralInfo
        .Time = bstr(MediaInfo_Get(Handle, MediaInfo_Stream_General, 0, StrPtr("Duration"), MediaInfo_Info_Text, MediaInfo_Info_Name))
        If Val(.Time) <= 0 Then
            If AudioInfo.Time(0) <> "" Then .Time = AudioInfo.Time(0)
            If VideoInfo.Time <> "" Then .Time = VideoInfo.Time
        End If
        If Val(.Time) <= 0 Then
            ReadMediaInfo = False
            If bErrDisplay = True Then
                If MsgBox("Error reading '" & MediaPathName & "'." & vbCrLf & vbCrLf & "Cannot detect Duration." & vbCrLf & vbCrLf & "Do you want to insert Duration manually?", vbExclamation + vbYesNo, App.Title & " (MediaInfo.dll)") = vbYes Then
                    Do
                        .Time = InputBox("Insert Duration [seconds]:" & vbCrLf & vbCrLf & "(1 hour is 3600 seconds)", App.Title & " (MediaInfo.dll)", "3600")
                        If Val(.Time) > 0 Then
                            .Time = .Time * 1000
                            If bReadVideo = True Then VideoInfo.Time = .Time
                            If bReadAudio = True Then AudioInfo.Time(0) = .Time
                            ReadMediaInfo = True
                        ElseIf .Time <> "" Then
                            MsgBox "Warning! PlayTime format not valid.", vbCritical, App.Title & " (MediaInfo.dll)"
                        End If
                    Loop Until ReadMediaInfo = True Or Val(.Time) > 0
                End If
            End If
        End If
    End With
    
    ' Close MediaInfo handle
    Call MediaInfo_Close(Handle)
    Call MediaInfo_Delete(Handle)
    
    GoTo Exit_Handling
        
Err_Handling:
Select Case Err.Number
Case 9999
    Resume
Case Else
    If bErrDisplay = True Then MsgBox "Error " & Err.Number & vbCrLf & vbCrLf & Err.Description, vbCritical, App.Title & " (MediaInfo.dll)"
    ReadMediaInfo = False
End Select

Exit_Handling:
If Mid(OrigCurDir, 2, 1) = ":" Then
    ChDrive Left(OrigCurDir, 2)
End If
ChDir OrigCurDir
Screen.MousePointer = OrigMousePointer

End Function


Public Function ReadAVSInfo(MediaPathName As String, _
                            Optional TempPath As String, _
                            Optional FFmpegPath As String, _
                            Optional A2DInfoLibPath As String, _
                            Optional IsAviSynthScript As Boolean = True, _
                            Optional bErrDisplay As Boolean = True) As Boolean

    Const TimeOut = 60 'seconds
    
    Dim NumFile As Integer
    Dim StrAVS As String
    Dim StrTXT As String
    Dim StrMedia As String
    Dim TimeStart As Long
    Dim FFmpegPathName As String
    
    On Error GoTo Err_Handling
    
    Screen.MousePointer = vbHourglass

    If TempPath = "" Then TempPath = Environ("TEMP")
    If FFmpegPath = "" Then FFmpegPath = App.Path & "\FFmpeg"
    If A2DInfoLibPath = "" Then A2DInfoLibPath = App.Path & "\Lib"
    FFmpegPathName = FFmpegPath & "\ffmpeg.exe"
    
    If Dir(TempPath & "\AVSInfo.bat") <> "" Then Kill TempPath & "\AVSInfo.bat"
    If Dir(TempPath & "\AVSInfo.avs") <> "" Then Kill TempPath & "\AVSInfo.avs"
    If Dir(TempPath & "\AVSInfo.txt") <> "" Then Kill TempPath & "\AVSInfo.txt"
    
    StrAVS = "Import(""" & A2DInfoLibPath & "\A2DInfo.avsi"")" & vbCrLf & _
             "A2DInfo(""" & MediaPathName & """, """ & TempPath & "\AVSInfo.txt""" & ", " & IIf(IsAviSynthScript = True, "true", "false") & ")"
    NumFile = FreeFile
    Open TempPath & "\AVSInfo.avs" For Output As #NumFile
        Print #NumFile, StrAVS
    Close #NumFile
    NumFile = FreeFile
    Open TempPath & "\AVSInfo.bat" For Output As #NumFile
        Print #NumFile, """" & FFmpegPathName & """ -i """ & TempPath & "\AVSInfo.avs""" & " -f rawvideo -y NUL"
    Close #NumFile
    DoEvents
    Sleep 500
    If Dir(TempPath & "\AVSInfo.bat") <> "" Then
        ReadAVSInfo = CBool(Shell(TempPath & "\AVSInfo.bat", vbHide))
        If ReadAVSInfo = False Then
            If bErrDisplay = True Then MsgBox "Error reading '" & MediaPathName & "'." & vbCrLf & vbCrLf & "Cannot run AVSInfo.bat", vbExclamation + vbOKOnly, App.Title & " (AVSInfo.avsi)"
            GoTo Exit_Handling
        Else
            TimeStart = Timer
            Do
                If Timer - TimeStart > TimeOut Then
                    Exit Do
                End If
                Sleep 500
            Loop Until modUtil.FindRunningProcess(FFmpegPathName) = 0 And Dir(TempPath & "\AVSInfo.txt") <> ""
        End If
    End If
    DoEvents
    modUtil.KillRunningProcess FFmpegPathName
    NumFile = FreeFile
    StrTXT = ""
    If Dir(TempPath & "\AVSInfo.txt") <> "" Then
        Open TempPath & "\AVSInfo.txt" For Input As #NumFile
            Do Until EOF(NumFile)
                StrTXT = StrTXT & Input(1, #NumFile)
            Loop
        Close #NumFile
    End If
    If InStr(1, StrTXT, "ASCII file generated by A2DInfo") <> 0 Then
        ReadAVSInfo = True
        NumFile = FreeFile
        Open MediaPathName For Input As #NumFile
            Do Until EOF(NumFile)
                StrMedia = StrMedia & Input(1, #NumFile)
            Loop
        Close #NumFile
        With GeneralInfo
            .PathName = MediaPathName
            .Filename = Dir(MediaPathName)
            'FileExt
            'FileSize
            .Format = IIf(IsAviSynthScript = True, "AVS", "Media")
            .MediaInfoVersion = "A2DInfo.avsi"
        End With
        If Load_Str(StrTXT, "HasVideo") = "1" Then
            GeneralInfo.VideoTracksCount = "1"
            With VideoInfo
                .Time = Load_Str(StrTXT, "VideoTime")
                .Compression = IIf(IsAviSynthScript = True, "AviSynth", "Video")
                .AvgBitRate = Load_Str(StrMedia, "#VideoAvgBitRate", .AvgBitRate)
                .Width = Load_Str(StrTXT, "Width")
                .Height = Load_Str(StrTXT, "Height")
                If Val(.Height) > 0 Then .FrameAspectRatio = Val(.Width) / Val(.Height)
                .DisplayAspectRatio = Load_Str(StrMedia, "#DisplayAspectRatio", .DisplayAspectRatio)
                If .DisplayAspectRatio = "" Then .DisplayAspectRatio = .FrameAspectRatio
                If Val(.FrameAspectRatio) > 0 Then .PixelAspectRatio = Val(.DisplayAspectRatio) / Val(.FrameAspectRatio)
                .FrameRateMode = "CFR"
                .FPS = CStr(Round(Val(Load_Str(StrTXT, "Framerate")), 3))
                .FrameCount = Load_Str(StrTXT, "Framecount")
                .ScanType = Load_Str(StrMedia, "#ScanType", .ScanType)
                .ScanOrder = Load_Str(StrMedia, "#ScanOrder", .ScanOrder)
                If .Compression = "" Then
                    ReadAVSInfo = False
                    If bErrDisplay = True Then MsgBox "Error reading '" & MediaPathName & "'." & vbCrLf & vbCrLf & "Cannot detect Video Stream.", vbExclamation + vbOKOnly, App.Title & " (AVSInfo.avsi)"
                End If
            End With
        End If
        If Load_Str(StrTXT, "HasAudio") = "1" Then
            GeneralInfo.AudioTracksCount = "1"
            With AudioInfo
                .Time(0) = Load_Str(StrTXT, "AudioTime")
                .Compression(0) = IIf(IsAviSynthScript = True, "AviSynth", "Audio")
                .AvgBitRate(0) = Load_Str(StrMedia, "#AudioAvgBitRate", .AvgBitRate(0))
                .BitRateMode(0) = "CBR"
                .Channels(0) = Load_Str(StrTXT, "AudioChannels")
                .SampleRate(0) = Load_Str(StrTXT, "AudioRate")
                If .Compression(0) = "" Then
                    ReadAVSInfo = False
                    If bErrDisplay = True Then MsgBox "Error reading '" & MediaPathName & "'." & vbCrLf & vbCrLf & "Cannot detect Audio Stream.", vbExclamation + vbOKOnly, App.Title & " (AVSInfo.avsi)"
                End If
                .Delay(0) = ""
            End With
        End If
        With GeneralInfo
            If AudioInfo.Time(0) <> "" Then .Time = AudioInfo.Time(0)
            If VideoInfo.Time <> "" Then .Time = VideoInfo.Time
            If Val(.Time) <= 0 Then
                ReadAVSInfo = False
                If bErrDisplay = True Then
                    If MsgBox("Error reading '" & MediaPathName & "'." & vbCrLf & vbCrLf & "Cannot detect Duration." & vbCrLf & vbCrLf & "Do you want to insert Duration manually?", vbExclamation + vbYesNo, App.Title & " (AVSInfo.avsi)") = vbYes Then
                        Do
                            .Time = InputBox("Insert Duration [ms]:" & vbCrLf & vbCrLf & "(1 hour is 3600000 ms)", App.Title & " (AVSInfo.avsi)", "5400000")
                            If Val(.Time) > 0 Then
                                VideoInfo.Time = .Time
                                AudioInfo.Time(0) = .Time
                                ReadAVSInfo = True
                            ElseIf .Time <> "" Then
                                MsgBox "Warning! PlayTime format not valid.", vbCritical, App.Title & " (AVSInfo.avsi)"
                            End If
                        Loop Until ReadAVSInfo = True Or Val(.Time) > 0
                    End If
                End If
            End If
        End With
    Else
        ReadAVSInfo = False
        If bErrDisplay = True Then MsgBox "Error reading '" & MediaPathName & "'." & vbCrLf & vbCrLf & "Cannot find '" & TempPath & "\AVSInfo.txt' (Timeout " & TimeOut & " seconds).", vbExclamation + vbOKOnly, App.Title & " (AVSInfo.avsi)"
    End If

    GoTo Exit_Handling

Err_Handling:
If bErrDisplay = True Then MsgBox "Error " & Err.Number & vbCrLf & vbCrLf & Err.Description, vbCritical, App.Title & " (AVSInfo.avsi)"
ReadAVSInfo = False
'Resume

Exit_Handling:
If ReadAVSInfo = False And bErrDisplay = True Then
    MsgBox "Error reading '" & MediaPathName & "'." & vbCrLf & vbCrLf & "Cannot read Media.", vbExclamation + vbOKOnly, App.Title & " (AVSInfo.avsi)"
End If
If Dir(TempPath & "\AVSInfo.bat") <> "" Then Kill TempPath & "\AVSInfo.bat"
If Dir(TempPath & "\AVSInfo.avs") <> "" Then Kill TempPath & "\AVSInfo.avs"
If Dir(TempPath & "\AVSInfo.txt") <> "" Then Kill TempPath & "\AVSInfo.txt"
Screen.MousePointer = vbDefault

End Function

' Erase all class properties
Public Sub Clear()

    Dim GeneralInfoNull As GeneralMediaInfoType
    Dim VideoInfoNull As VideoMediaInfoType
    Dim AudioInfoNull As AudioMediaInfoType
    Dim TextInfoNull As TextMediaInfoType
    Dim ChaptersInfoNull As ChaptersMediaInfoType
    
    GeneralInfo = GeneralInfoNull
    VideoInfo = VideoInfoNull
    If Val(AudioTracksCount) > 0 Then
        AudioInfo = AudioInfoNull
    End If
    If Val(TextTracksCount) > 0 Then
        TextInfo = TextInfoNull
    End If
    ChaptersInfo = ChaptersInfoNull
    
End Sub

Private Function Load_Str(Str As String, Object As String, Optional ByVal Default As String) As String

    ' Get string object (Object) from string (Str). If no Object is found, Default is returned
    
    Dim Inizio As Integer
    Dim Fine As Integer

    On Error GoTo Err_Handling
        
    If InStr(1, Str, Object, vbTextCompare) <> 0 Then
        Inizio = InStr(1, Str, Object, vbTextCompare) + Len(Object) + 2
        Fine = InStr(Inizio, Str, Chr(13), vbTextCompare)
        Load_Str = Mid(Str, Inizio, Fine - Inizio)
    End If
    If Load_Str = "" Then
        Load_Str = Default
    End If
    
    Exit Function

Err_Handling:
Load_Str = Default

End Function

Public Property Get MediaInfoVersion() As String

    MediaInfoVersion = GeneralInfo.MediaInfoVersion
    
End Property

Public Property Get PathName() As String

    PathName = GeneralInfo.PathName
    
End Property

Public Property Get Filename() As String

    Filename = GeneralInfo.Filename
    
End Property

Public Property Get FileExt() As String

    FileExt = GeneralInfo.FileExt
    
End Property

Public Property Get FileSize() As String

    FileSize = GeneralInfo.FileSize
    
End Property

Public Property Get Format() As String

    Format = GeneralInfo.Format
    
End Property

Public Property Get VideoTracksCount() As String

    VideoTracksCount = GeneralInfo.VideoTracksCount
    
End Property

Public Property Get AudioTracksCount() As String

    AudioTracksCount = GeneralInfo.AudioTracksCount
    
End Property

Public Property Get TextTracksCount() As String

    TextTracksCount = GeneralInfo.TextTracksCount
    
End Property

Public Property Get Time() As String

    Time = GeneralInfo.Time
    
End Property

Public Property Get VideoTime() As String

    VideoTime = VideoInfo.Time
    
End Property

Public Property Get VideoCompression() As String

    VideoCompression = VideoInfo.Compression
    
End Property

Public Property Get VideoBitRateMode() As String

    VideoBitRateMode = VideoInfo.BitRateMode
    
End Property

Public Property Get VideoAvgBitRate() As String

    VideoAvgBitRate = VideoInfo.AvgBitRate
    
End Property

Public Property Get VideoMinBitRate() As String

    VideoMinBitRate = VideoInfo.MinBitRate
    
End Property

Public Property Get VideoMaxBitRate() As String

    VideoMaxBitRate = VideoInfo.MaxBitRate
    
End Property

Public Property Get VideoWidth() As String

    VideoWidth = VideoInfo.Width
    
End Property

Public Property Get VideoHeight() As String

    VideoHeight = VideoInfo.Height
    
End Property

Public Property Get VideoDAR() As String

    VideoDAR = VideoInfo.DisplayAspectRatio
    
End Property

Public Property Get VideoPAR() As String

    VideoPAR = VideoInfo.PixelAspectRatio
    
End Property

Public Property Get VideoFAR() As String

    VideoFAR = VideoInfo.FrameAspectRatio

End Property

Public Property Get VideoStandard() As String

    VideoStandard = VideoInfo.Standard
    
End Property

Public Property Get VideoFrameRateMode() As String

    VideoFrameRateMode = VideoInfo.FrameRateMode
    
End Property

Public Property Get VideoFPS() As String

    VideoFPS = VideoInfo.FPS
    
End Property

Public Property Get VideoFrameCount() As String

    VideoFrameCount = VideoInfo.FrameCount
    
End Property

Public Property Get VideoScanType() As String

    VideoScanType = VideoInfo.ScanType
    
End Property

Public Property Get VideoScanOrder() As String

    VideoScanOrder = VideoInfo.ScanOrder
    
End Property

Public Property Get AudioID(AudioTrack As Integer) As String

    AudioID = AudioInfo.ID(AudioTrack)
    
End Property

Public Property Get AudioTime(AudioTrack As Integer) As String

    AudioTime = AudioInfo.Time(AudioTrack)
    
End Property

Public Property Get AudioCompression(AudioTrack As Integer) As String

    AudioCompression = AudioInfo.Compression(AudioTrack)
    
End Property

Public Property Get AudioAvgBitRate(AudioTrack As Integer) As String

    AudioAvgBitRate = AudioInfo.AvgBitRate(AudioTrack)
    
End Property

Public Property Get AudioBitRateMode(AudioTrack As Integer) As String

    AudioBitRateMode = AudioInfo.BitRateMode(AudioTrack)
    
End Property

Public Property Get AudioChannels(AudioTrack As Integer) As String

    AudioChannels = AudioInfo.Channels(AudioTrack)
    
End Property

Public Property Get AudioSampleRate(AudioTrack As Integer) As String

    AudioSampleRate = AudioInfo.SampleRate(AudioTrack)
    
End Property

Public Property Get AudioResolution(AudioTrack As Integer) As String

    AudioResolution = AudioInfo.Resolution(AudioTrack)
    
End Property

Public Property Get AudioLanguage(AudioTrack As Integer) As String

    AudioLanguage = AudioInfo.Language(AudioTrack)
    
End Property

Public Property Get AudioDelay(AudioTrack As Integer) As String

    AudioDelay = AudioInfo.Delay(AudioTrack)
    
End Property

Public Property Get TextID(TextTrack As Integer) As String

    TextID = TextInfo.ID(TextTrack)
    
End Property

Public Property Get TextFormat(TextTrack As Integer) As String

    TextFormat = TextInfo.Format(TextTrack)
    
End Property

Public Property Get TextLanguage(TextTrack As Integer) As String

    TextLanguage = TextInfo.Language(TextTrack)
    
End Property

Public Property Get TextTitle(TextTrack As Integer) As String

    TextTitle = TextInfo.Title(TextTrack)
    
End Property

Public Property Get ChaptersList() As String

    ChaptersList = ChaptersInfo.List
    
End Property

