VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTitleAudioInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'   AVStoDVD - by MrC
'   File: clsTitleAudioInfo.cls
'   Purpose: Class that handle Title Info properties
'   Requires: clsMediaInfo.cls, modStr.bas
'
' -------------------------------------------------------------------------------


Option Explicit
Option Compare Binary
Option Base 0


Public Enum DVD_Audio_Compl
    Not_Audio_Compl
    DTS_Compl
    AC3_Compl
    MP2_Compl
    WAV_Compl
End Enum


Private AudioID As String
Private AudioTrackID As String
Private AudioTime As String
Private AudioCompression As String
Private AudioBitRateMode As String
Private AudioAvgBitRate As String
Private AudioChannels As String
Private AudioSampleRate As String
Private AudioResolution As String
Private AudioLanguage As String
Private AudioDelay As String


Public Function Initialize(SourceMediaInfo As clsMediaInfo, Optional AudioTrack As Integer) As Boolean

    With SourceMediaInfo
        AudioID = .AudioID(AudioTrack)
        If Val(.VideoTracksCount) = 0 Then
            AudioTrackID = "0"
        Else
            Select Case LCase(.Format)
            Case "matroska"
                AudioTrackID = Val(AudioID) - 1
            Case "avi"
                AudioTrackID = AudioID
            Case Else
                AudioTrackID = AudioTrack + 1
            End Select
        End If
        AudioTime = .AudioTime(AudioTrack)
        AudioCompression = .AudioCompression(AudioTrack)
        AudioBitRateMode = .AudioBitRateMode(AudioTrack)
        AudioAvgBitRate = .AudioAvgBitRate(AudioTrack)
        AudioChannels = .AudioChannels(AudioTrack)
        AudioSampleRate = .AudioSampleRate(AudioTrack)
        AudioResolution = .AudioResolution(AudioTrack)
        AudioLanguage = .AudioLanguage(AudioTrack)
        AudioDelay = .AudioDelay(AudioTrack)
    End With
    Initialize = CBool(Len(AudioCompression))

End Function

Public Property Get ID() As String

    ID = AudioID

End Property
    
Public Property Let ID(value As String)

    AudioID = value
    
End Property

Public Property Get TrackID() As String

    TrackID = AudioTrackID

End Property
    
Public Property Let TrackID(value As String)

    AudioTrackID = value
    
End Property

Public Property Get Time() As String

    Time = AudioTime

End Property
    
Public Property Let Time(value As String)

    AudioTime = value
    
End Property

Public Property Get Compression() As String

    Compression = AudioCompression

End Property
    
Public Property Let Compression(value As String)

    AudioCompression = value
    
End Property

Public Property Get BitRateMode() As String

    BitRateMode = AudioBitRateMode

End Property
    
Public Property Let BitRateMode(value As String)

    AudioBitRateMode = value
    
End Property

Public Property Get AvgBitRate() As String

    AvgBitRate = AudioAvgBitRate

End Property
    
Public Property Let AvgBitRate(value As String)

    AudioAvgBitRate = value
    
End Property

Public Property Get Channels() As String

    Channels = AudioChannels

End Property
    
Public Property Let Channels(value As String)

    AudioChannels = value
    
End Property

Public Property Get SampleRate() As String

    SampleRate = AudioSampleRate

End Property
    
Public Property Let SampleRate(value As String)

    AudioSampleRate = value
    
End Property

Public Property Get Resolution() As String

    Resolution = AudioResolution

End Property
    
Public Property Let Resolution(value As String)

    AudioResolution = value
    
End Property

Public Property Get Language() As String

    Language = AudioLanguage

End Property
    
Public Property Let Language(value As String)

    AudioLanguage = value
    
End Property

Public Property Get Delay() As String

    Delay = AudioDelay

End Property
    
Public Property Let Delay(value As String)

    AudioDelay = value
    
End Property

Public Property Get Summary() As String
                        
    If AudioCompression <> "" Then
        Summary = AudioCompression & " - " & _
                  Int(Val(AudioAvgBitRate) / 1000) & " kbps - " & _
                  AudioBitRateMode & " - " & _
                  AudioChannels & " ch - " & _
                  AudioSampleRate & " Hz - " & _
                  IIf(AudioResolution = "", "", AudioResolution & " bit - ") & _
                  VisualTime(Int(Val(AudioTime) / 1000)) & " (" & _
                  Int(Val(AudioDelay)) & " ms delay)" & _
                  IIf(AudioLanguage = "", "", " - " & UCase(AudioLanguage))
    End If
    
End Property
                        
Public Property Get SummaryLong() As String
                        
    Dim Str As String
    
    If AudioCompression <> "" Then
        If AudioID <> "" Then
            Str = " (0x" & Hex(Int(Val(AudioID))) & ")"
        End If
        SummaryLong = "ID: " & Int(Val(AudioTrackID)) & Str & vbCrLf & _
                      "Time: " & VisualTime(Int(Val(AudioTime / 1000))) & vbCrLf & _
                      "Compression: " & AudioCompression & vbCrLf & _
                      "BitRate Mode: " & AudioBitRateMode & vbCrLf & _
                      "Avg BitRate: " & Round(Val(AudioAvgBitRate) / 1000) & " kbps" & vbCrLf & _
                      "Channels: " & AudioChannels & vbCrLf & _
                      "SampleRate: " & AudioSampleRate & " Hz" & vbCrLf & _
                      "Resolution: " & IIf(AudioResolution = "", "", AudioResolution & " bit") & vbCrLf & _
                      "Language: " & AudioLanguage & vbCrLf & _
                      "Delay: " & IIf(AudioDelay = "", "", AudioDelay & " ms")
    End If

End Property

Public Property Get DVDCompliant() As DVD_Audio_Compl

    Dim BitRate_Array As Variant
    Dim jj As Integer
    Dim Flag As Boolean
    
    If Val(AudioSampleRate) = 48000 And AudioBitRateMode = "CBR" Then
        Select Case UCase(Extension)
        'Case "WAV"
            'BitRate_Array = Array(1536)
            'DVDCompliant = WAV_Compl
        Case "DTS"
            If AudioChannels = "6" Then
                If AudioResolution = "16" Or AudioResolution = "20" Then
                    BitRate_Array = Array(768, 1536)
                    DVDCompliant = DTS_Compl
                End If
            End If
        Case "AC3"
            If AudioChannels = "1" Or AudioChannels = "2" Or AudioChannels = "6" Then
                BitRate_Array = Array(64, 96, 128, 160, 192, 224, 256, 384, 448)
                DVDCompliant = AC3_Compl
            End If
        Case "MP2"
            If AudioChannels = "1" Or AudioChannels = "2" Then
                BitRate_Array = Array(64, 96, 128, 160, 192, 224, 256)
                DVDCompliant = MP2_Compl
            End If
        End Select
        If IsEmpty(BitRate_Array) = False Then
            For jj = LBound(BitRate_Array) To UBound(BitRate_Array)
                If Int(Val(AudioAvgBitRate) / 1000) = Val(BitRate_Array(jj)) Then
                    Flag = True
                End If
            Next jj
        End If
        If Flag = False Then DVDCompliant = Not_Audio_Compl
    End If
    
End Property

Public Property Get Extension() As String

    Dim sCompr As String
    
        sCompr = UCase(AudioCompression)
        If InStr(1, sCompr, "AAC") <> 0 Then
            Extension = "aac"
        ElseIf InStr(1, sCompr, "MPEG") <> 0 And InStr(1, sCompr, "LAYER 2") <> 0 Then
            Extension = "mp2"
        ElseIf InStr(1, sCompr, "MPEG") <> 0 And InStr(1, sCompr, "LAYER 3") <> 0 Then
            Extension = "mp3"
        ElseIf InStr(1, sCompr, "PCM") <> 0 Then
            Extension = "wav"
        ElseIf InStr(1, sCompr, "AMR") <> 0 Then
            Extension = "amr"
        ElseIf InStr(1, sCompr, "VORBIS") <> 0 Then
            Extension = "ogg"
        ElseIf InStr(1, sCompr, "AC3") <> 0 Then
            Extension = "ac3"
        ElseIf InStr(1, sCompr, "DTS") <> 0 Then
            Extension = "dts"
        Else
            Extension = LCase(sCompr)
        End If

End Function


