VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTitleSubsInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'   AVStoDVD - by MrC
'   File: clsTitleSubsInfo.cls
'   Purpose: Class that handle Subs Title Info properties
'   Requires: clsMediaInfo.cls
'
' -------------------------------------------------------------------------------


Option Explicit
Option Compare Binary
Option Base 0


Private SubsID As String
Private SubsTrackID As String
Private SubsFormat As String
Private SubsLanguage As String
Private SubsTitle As String

Public Function Initialize(SourceMediaInfo As clsMediaInfo, Optional TextTrack As Integer) As Boolean

    With SourceMediaInfo
        SubsID = .TextID(TextTrack)
        If Val(.VideoTracksCount) = 0 Then
            SubsTrackID = "0"
        Else
            Select Case LCase(.Format)
            Case "matroska"
                SubsTrackID = Val(SubsID) - 1
            Case Else
                SubsTrackID = TextTrack + 1
            End Select
        End If
        SubsFormat = .TextFormat(TextTrack)
        SubsTitle = .TextTitle(TextTrack)
        SubsLanguage = .TextLanguage(TextTrack)
    End With
    Initialize = CBool(Len(SubsFormat))

End Function

Public Property Get ID() As String

    ID = SubsID

End Property
    
Public Property Let ID(value As String)

    SubsID = value
    
End Property

Public Property Get TrackID() As String

    TrackID = SubsTrackID

End Property
    
Public Property Let TrackID(value As String)

    SubsTrackID = value
    
End Property

Public Property Get Format() As String

    Select Case UCase(SubsFormat)
    Case "VOBSUB"
        Format = "VobSub"
    Case "UTF-8"
        Format = "SubRip"
    Case "SSA"
        Format = "SubStation Alpha"
    Case "ASS"
        Format = "Advanced SubStation"
    Case "SUP"
        Format = "IfoEdit"
    Case "SST"
        Format = "Scenarist"
    Case Else
        Format = SubsFormat
    End Select

End Property
    
Public Property Let Format(value As String)

    Select Case UCase(value)
    Case "VOBSUB"
        SubsFormat = "VobSub"
    Case "SUBRIP"
        SubsFormat = "UTF-8"
    Case "SUBSTATION ALPHA"
        SubsFormat = "SSA"
    Case "ADVANCED SUBSTATION"
        SubsFormat = "ASS"
    Case "IFOEDIT"
        SubsFormat = "SUP"
    Case "SCENARIST"
        SubsFormat = "SST"
    Case Else
        SubsFormat = value
    End Select
    
End Property

Public Property Get Title() As String

    Title = SubsTitle

End Property
    
Public Property Let Title(value As String)

    SubsTitle = value
    
End Property

Public Property Get Language() As String

    Language = SubsLanguage

End Property
    
Public Property Let Language(value As String)

    SubsLanguage = value
    
End Property

Public Property Get Summary() As String

    If SubsFormat <> "" Then
        Summary = Format & " (" & UCase(Extension) & ")" & _
                  IIf(SubsTitle = "", "", " - " & SubsTitle) & _
                  IIf(SubsLanguage = "", "", " - " & UCase(SubsLanguage))
    End If

End Property

Public Property Get SummaryLong() As String

    Dim Str As String
    
    If SubsFormat <> "" Then
        If SubsID <> "" Then
            Str = " (0x" & Hex(Int(Val(SubsID))) & ")"
        End If
        SummaryLong = "ID: " & Int(Val(SubsTrackID)) & Str & vbCrLf & _
                      "Format: " & Format & " (" & UCase(Extension) & ")" & vbCrLf & _
                      "Title: " & SubsTitle & vbCrLf & _
                      "Language: " & SubsLanguage
    End If

End Property

Public Property Get Extension() As String

    Select Case UCase(SubsFormat)
    Case "VOBSUB"
        Extension = "idx"
    Case "UTF-8"
        Extension = "srt"
    Case Else                                           'i.e. ASS, SSA
        Extension = LCase(SubsFormat)
    End Select

End Function

