VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsTitleVideoInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' -------------------------------------------------------------------------------
'
'   AVStoDVD - by MrC
'   File: clsTitleVideoInfo.cls
'   Purpose: Class that handle Title Info properties
'   Requires: clsMediaInfo.cls, modStr.bas
'
' -------------------------------------------------------------------------------


Option Explicit
Option Compare Binary
Option Base 0

Public Enum DVD_Video_Compl
    Not_Video_Compl
    PAL_Full_D1
    PAL_Half_D1
    PAL_VCD
    NTSC_Full_D1
    NTSC_Half_D1
    NTSC_VCD
End Enum

Private VideoTime As String
Private VideoCompression As String
Private VideoBitRateMode As String
Private VideoAvgBitRate As String
Private VideoMinBitRate As String
Private VideoMaxBitRate As String
Private VideoWidth As String
Private VideoHeight As String
Private VideoDAR As String
Private VideoPAR As String
Private VideoFAR As String
Private VideoFrameRateMode As String
Private VideoFPS As String
Private VideoFrameCount As String
Private VideoScanType As String
Private VideoScanOrder As String

Public Function Initialize(SourceMediaInfo As clsMediaInfo) As Boolean

    With SourceMediaInfo
        VideoTime = .Time
        VideoCompression = .VideoCompression
        VideoBitRateMode = .VideoBitRateMode
        VideoAvgBitRate = .VideoAvgBitRate
        VideoMinBitRate = .VideoMinBitRate
        VideoMaxBitRate = .VideoMaxBitRate
        VideoWidth = .VideoWidth
        VideoHeight = .VideoHeight
        VideoDAR = .VideoDAR
        VideoPAR = .VideoPAR
        VideoFAR = .VideoFAR
        VideoFrameRateMode = .VideoFrameRateMode
        VideoFPS = .VideoFPS
        VideoFrameCount = .VideoFrameCount
        VideoScanType = .VideoScanType
        VideoScanOrder = .VideoScanOrder
    End With
    Initialize = CBool(Len(VideoCompression))

End Function

Public Property Get Time() As String

    Time = VideoTime

End Property
    
Public Property Let Time(Value As String)

    VideoTime = Value
    
End Property
    
Public Property Get Compression() As String

    Compression = VideoCompression

End Property
    
Public Property Let Compression(Value As String)

    VideoCompression = Value
    
End Property

Public Property Get BitRateMode() As String

    BitRateMode = VideoBitRateMode

End Property
    
Public Property Let BitRateMode(Value As String)

    VideoBitRateMode = Value
    
End Property

Public Property Get AvgBitRate() As String

    AvgBitRate = VideoAvgBitRate

End Property
    
Public Property Let AvgBitRate(Value As String)

    VideoAvgBitRate = Value
    
End Property

Public Property Get MinBitRate() As String

    MinBitRate = VideoMinBitRate

End Property
    
Public Property Let MinBitRate(Value As String)

    VideoMinBitRate = Value
    
End Property
    
Public Property Get MaxBitRate() As String

    MaxBitRate = VideoMaxBitRate

End Property
    
Public Property Let MaxBitRate(Value As String)

    VideoMaxBitRate = Value
    
End Property
    
Public Property Get Width() As String

    Width = VideoWidth

End Property
    
Public Property Let Width(Value As String)

    VideoWidth = Value
    
End Property
    
Public Property Get Height() As String

    Height = VideoHeight

End Property
    
Public Property Let Height(Value As String)

    VideoHeight = Value
    
End Property
    
Public Property Get DAR() As String

    DAR = VideoDAR

End Property
    
Public Property Let DAR(Value As String)

    VideoDAR = Value
    
End Property
    
Public Property Get PAR() As String

    PAR = VideoPAR

End Property
    
Public Property Let PAR(Value As String)

    VideoPAR = Value
    
End Property
    
Public Property Get FAR() As String

    FAR = VideoFAR

End Property
    
Public Property Let FAR(Value As String)

    VideoFAR = Value
    
End Property
    
Public Property Get FrameRateMode() As String

    FrameRateMode = VideoFrameRateMode

End Property
    
Public Property Let FrameRateMode(Value As String)

    VideoFrameRateMode = Value
    
End Property
    
Public Property Get FPS() As String

    FPS = VideoFPS

End Property
    
Public Property Let FPS(Value As String)

    VideoFPS = Value
    
End Property
    
Public Property Get FrameCount() As String

    FrameCount = VideoFrameCount

End Property
    
Public Property Let FrameCount(Value As String)

    VideoFrameCount = Value
    
End Property
    
Public Property Get ScanType() As String

    ScanType = VideoScanType

End Property
    
Public Property Let ScanType(Value As String)

    VideoScanType = Value
    
End Property
    
Public Property Get ScanOrder() As String

    ScanOrder = VideoScanOrder

End Property
    
Public Property Let ScanOrder(Value As String)

    VideoScanOrder = Value
    
End Property

Public Property Get Summary() As String

    If VideoCompression <> "" Then
        Summary = VideoCompression & " - " & _
                            Int(Val(VideoAvgBitRate) / 1000) & " kbps - " & _
                            VideoWidth & "x" & VideoHeight & _
                            " - DAR " & Round(Val(VideoDAR), 3) & " - " & _
                            Round(Val(VideoFPS), 3) & " fps (" & VideoFrameRateMode & ")" & IIf(VideoScanType <> "", " - " & VideoScanType, "") & IIf(VideoScanOrder <> "", " (" & VideoScanOrder & ")", "") & " - " & _
                            VisualTime(Int(Val(VideoTime) / 1000)) & " - " & _
                            VideoFrameCount & " frames"
    End If

End Property

Public Property Get SummaryLong() As String

    If VideoCompression <> "" Then
        SummaryLong = "Time: " & VisualTime(Int(Val(VideoTime) / 1000)) & vbCrLf & _
                      "Compression: " & VideoCompression & vbCrLf & _
                      "BitRate Mode: " & VideoBitRateMode & vbCrLf & _
                      "Avg BitRate: " & IIf(VideoAvgBitRate = "", "", Round(Val(VideoAvgBitRate) / 1000) & " kbps") & vbCrLf & _
                      "Min BitRate: " & IIf(VideoMinBitRate = "", "", Round(Val(VideoMinBitRate) / 1000) & " kbps") & vbCrLf & _
                      "Max BitRate: " & IIf(VideoMaxBitRate = "", "", Round(Val(VideoMaxBitRate) / 1000) & " kbps") & vbCrLf & _
                      "Resolution: " & VideoWidth & "x" & VideoHeight & vbCrLf & _
                      "Display AspectRatio: " & Round(Val(VideoDAR), 3) & vbCrLf & _
                      "Pixel AspectRatio: " & Round(Val(VideoPAR), 3) & vbCrLf & _
                      "Frame AspectRatio: " & Round(Val(VideoFAR), 3) & vbCrLf & _
                      "FrameRate Mode: " & VideoFrameRateMode & vbCrLf & _
                      "FrameRate: " & Round(Val(VideoFPS), 3) & " fps" & vbCrLf & _
                      "Frame Count: " & VideoFrameCount & vbCrLf & _
                      "Scan Type: " & VideoScanType & vbCrLf & _
                      "Field Order: " & VideoScanOrder & vbCrLf & _
                      "DVD Compliance: " & DVDCompliant
    End If

End Property

Public Property Get DVDCompliant() As DVD_Video_Compl

    Dim TentativeVideoStandard As Byte    ' 0->None 1->PAL 2->NTSC
    
    If InStr(1, VideoCompression, "MPEG-2 Video") <> 0 Then
        If VideoDAR = "1.333" Or VideoDAR = "1.778" Then
            Select Case Val(VideoFPS)
            Case 24
                If LCase(VideoScanOrder) = "2:2:2:2:2:2:2:2:2:2:2:3 pulldown" Then TentativeVideoStandard = 1
            Case 25
                TentativeVideoStandard = 1
            Case 23.976
                If LCase(VideoScanOrder) = "2:3 pulldown" Then TentativeVideoStandard = 2
            Case 29.97
                TentativeVideoStandard = 2
            End Select
            If TentativeVideoStandard = 1 Then
                If Val(VideoHeight) = 576 Then
                    If Val(VideoWidth) = 720 Or Val(VideoWidth) = 704 Then
                        DVDCompliant = PAL_Full_D1
                    ElseIf Val(VideoWidth) = 352 Then
                        DVDCompliant = PAL_Half_D1
                    End If
                ElseIf Val(VideoHeight) = 288 Then
                    If Val(VideoWidth) = 352 Then
                        DVDCompliant = PAL_VCD
                    End If
                End If
            ElseIf TentativeVideoStandard = 2 Then
                If Val(VideoHeight) = 480 Then
                    If Val(VideoWidth) = 720 Or Val(VideoWidth) = 704 Then
                        DVDCompliant = NTSC_Full_D1
                    ElseIf Val(VideoWidth) = 352 Then
                        DVDCompliant = NTSC_Half_D1
                    End If
                ElseIf Val(VideoHeight) = 240 Then
                    If Val(VideoWidth) = 352 Then
                        DVDCompliant = NTSC_VCD
                    End If
                End If
            End If
            If Val(VideoAvgBitRate) / 1000 > 9500 Then
                DVDCompliant = Not_Video_Compl
            End If
        End If
    End If
    
End Property

