Attribute VB_Name = "modMain"
' -------------------------------------------------------------------------------
'
'   AVStoDVD - by MrC
'   File: modMain.bas
'   Purpose: Main, startup
'
' -------------------------------------------------------------------------------


Option Explicit
Option Compare Binary
Option Base 0


Public Sub Main()

    Dim jj As Integer
    Dim CL() As String
    Dim Str As String
    Dim RegStr() As String

    On Error Resume Next
    
    ' Detect Windows version, NT5 minimum
    If SysInfo.OSIsNT5 = False Then
        If MsgBox("Windows 2000 or higher is required in order to use AVStoDVD." & vbCrLf & vbCrLf & "Do you want to continue anyway?", vbQuestion + vbYesNo) = vbNo Then End
    End If
    
    ' Delete temporary AVStoDVD garbage
    If Dir(Preferences.TempPath & "\A2D*.cache") <> "" Then
        Kill Preferences.TempPath & "\A2D*.cache"
    End If
    modFS.DeleteIfExist Preferences.TempPath & "\AviSynthP.avs"
    modFS.DeleteIfExist Preferences.TempPath & "\AviSynthD.avs"
    
    ' Useful AVStoDVD Stuff (part 1)
    AVStoDVD_RegKey = "HKEY_CURRENT_USER\SOFTWARE\AVStoDVD"
    App.HelpFile = App.Path & "\Docs\AVStoDVD_Help.chm"
    UserSID = modReg.SubKeysArray("HKEY_CURRENT_USER\Software\Microsoft\Protected Storage System Provider")
    SpecialChars = "\ / : * ? "" < > |"
    
    ' Define Video/Audio standards
    With BitRates(AC3)
        .add 64
        .add 96
        .add 128
        .add 160
        .add 192
        .add 224
        .add 256
        .add 384
        .add 448
    End With
    With BitRates(MP2)
        .add 64
        .add 96
        .add 128
        .add 160
        .add 192
        .add 224
        .add 256
    End With
    With BitRates(WAV)
        .add 1536
    End With
    With BitRates(DTS)
        .add 768
        .add 1536
    End With
    
    ' Find Web Browser pathname
    RegStr = Split(modReg.EmiLeggiChiaveStringa("HKEY_CLASSES_ROOT\http\shell\open\command", ""), """")
    If modFS.EsisteFile(RegStr(1)) = True And LCase(modFS.ExtOf(RegStr(1))) = "exe" Then
        WebBrowserPathName = RegStr(1)
    End If
    
    ' Search for ImgBurn.exe
    ImgBurnPathName = modReg.EmiLeggiChiaveStringa("HKEY_CURRENT_USER\SOFTWARE\ImgBurn", "InstallDirectory", "") & "\ImgBurn.exe"
    If modFS.EsisteFile(ImgBurnPathName) = False Then
        ImgBurnPathName = SysInfo.PathPrograms & "\ImgBurn\ImgBurn.exe"
        If modFS.EsisteFile(ImgBurnPathName) = False Then
            ImgBurnPathName = ""
        End If
    End If
    
    ' Search for ffdshow.ax
    ffdshow.PathName = modReg.EmiLeggiChiaveStringa("HKEY_CLASSES_ROOT\CLSID\{04FE9017-F873-410E-871E-AB91661A4EF7}\InprocServer32", "", "")
    If modFS.EsisteFile(ffdshow.PathName) = False Then
        ffdshow.PathName = SysInfo.PathPrograms & "\ffdshow\ffdshow.ax"
        If modFS.EsisteFile(ffdshow.PathName) = False Then
            ffdshow.PathName = ""
        End If
    End If
    
    ' Erase AVStoDVD registry key if current Release has different Major+Minor
    RegRelease = modStr.PadLeft(modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "ReleaseMajor", ""), "0", 2) & _
                 modStr.PadLeft(modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "ReleaseMinor", ""), "0", 2) & _
                 modStr.PadLeft(modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "ReleaseRevision", ""), "0", 2) & _
                 modStr.PadLeft(modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "ReleaseBuild", ""), "0", 6)
    CurRelease = modStr.PadLeft(App.Major, "0", 2) & _
                 modStr.PadLeft(App.Minor, "0", 2) & _
                 modStr.PadLeft(App.Revision, "0", 2) & _
                 Right(App.Comments, 6)
    If Val(RegRelease) < 20200090511# Or Val(CurRelease) - Val(RegRelease) > 100000000 Then
        modReg.CancellaChiave AVStoDVD_RegKey & "\DVDMenu"
        modReg.CancellaChiave AVStoDVD_RegKey
    End If
    
    ' Setup AVStoDVD registry key
    modReg.CreaChiave AVStoDVD_RegKey
    
    ' Load General Preferences
    modMain.Reg_GeneralPreferences_Load
    
    ' Setup Language
    Set Language = modMain.Load_Language(Preferences.Language)
    If Language.Count = 0 Then End
    
    ' Useful AVStoDVD stuff (part 2)
    AVStoDVD_Picture = App.Path & "\Graphics\AVStoDVD_Splash_" & Preferences.SplashScreenName & "_Large.jpg"
    If modFS.EsisteFile(AVStoDVD_Picture) = False Then
        AVStoDVD_Picture = App.Path & "\Graphics\AVStoDVD_Splash_Default_Large.jpg"
    End If
    With Msgs
        .FileExistsOverwrite = modStr.DefaultStr(Language("000100"), "File already existing. Overwrite?")
        .CreateSuccess = modStr.DefaultStr(Language("000110"), "File successfully created.")
        .FileNotFound = modStr.DefaultStr(Language("000150"), "Warning! File not found.")
        .InvalidValue = modStr.DefaultStr(Language("000200"), "Warning! Inserted value is invalid.")
    End With
    
    ' Load Quick StartUp Tutorial form
    If modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "TutorialExecuted", -1) = -1 Then
        Load frmTutorial
        frmTutorial.Show 1
    End If
    
    ' Load main forms and display release
    Load frmMain
    With frmMain
        .StatusBar.Panels("Release").Text = "AVStoDVD Release " & App.Major & "." & App.Minor & "." & App.Revision
        If InStr(1, LCase(App.Comments), "final") = 0 Then
            .StatusBar.Panels("Release").Text = .StatusBar.Panels("Release").Text & " " & App.Comments
        End If
    End With
    Load frmJobsList
    
    ' Display the splash screen while checking system files
    If LCase(Preferences.SplashScreenName) <> "none" Then
        Load frmSplash
        With frmSplash
            .Show
            .Refresh
            .FadeIn
            modMain.Check_Software "frmSplash"
            .Hide
        End With
        Unload frmSplash
    Else
        modMain.Check_Software
    End If
    
    ' ffdshow settings check
    If Preferences.ffdshowRuntime = True And ffdshow.PathName <> "" Then
        ffdshow.RegKey = "HKEY_CURRENT_USER\Software\GNU\ffdshow"
        ffdshow.MixerBackup = modReg.EmiLeggiChiaveNumero(ffdshow.RegKey & "_audio\default", "mixerOut", 1)
        ffdshow.RawVideoBackup = modReg.EmiLeggiChiaveNumero(ffdshow.RegKey, "rawv", 1)
        ffdshow.RawAudioBackup = modReg.EmiLeggiChiaveNumero(ffdshow.RegKey & "_audio", "rawa", 4)
    End If
    
    ' Display Main form
    frmMain.Show
    
    ' Initialize AVStoDVD
    modMain.Reset_Project
    modMain.Save_Log_Video frmMain.StatusBar.Panels("Release").Text & " loaded!"
    
    ' Check AviSynth presence
    If InStr(1, modReg.EmiLeggiChiaveStringa("HKEY_LOCAL_MACHINE\SOFTWARE\AviSynth", ""), "AviSynth") <> 0 Then
        Str = modFileVersion.GetFileVersion(SysInfo.PathSystem & "\avisynth.dll", , True)
        modMain.Save_Log_Video "AviSynth " & Str & " is installed (""" & modReg.EmiLeggiChiaveStringa("HKEY_LOCAL_MACHINE\SOFTWARE\AviSynth", "") & """)."
        ' Check version
        Str = Replace(Str, ".", "")
        If Val(Str) < 257 Then
            modMain.Save_Log_Video "Warning! AviSynth release 2.5.7 or higher is required. Some encoding routines will not work.", , True
        End If
    Else
        modMain.Save_Log_Video "Warning! AviSynth is NOT installed. Most of encoding routines will not work.", , True
    End If
    
    ' Check ffdshow presence
    If ffdshow.PathName <> "" Then
        Str = modFileVersion.GetFileVersion(ffdshow.PathName, , True)
        modMain.Save_Log_Video "ffdshow " & Str & " 32bit is installed (""" & ffdshow.PathName & """)."
    Else
        modMain.Save_Log_Video "Warning! ffdshow 32bit is NOT installed. Some Video and Audio streams will not be decoded."
    End If
    With frmMain
        .Menu_Codecs_ffdshow_Video.Enabled = CBool(Len(ffdshow.PathName))
        .Menu_Codecs_ffdshow_Audio.Enabled = .Menu_Codecs_ffdshow_Video.Enabled
    End With
        
    ' Check ImgBurn presence
    If ImgBurnPathName <> "" Then
        Str = modFileVersion.GetFileVersion(ImgBurnPathName, , True)
        modMain.Save_Log_Video "ImgBurn " & Str & " is installed (""" & ImgBurnPathName & """)."
    Else
        modMain.Save_Log_Video "Warning! ImgBurn is NOT installed. ISO Image building and DVD burning disabled."
    End If
    With frmMain
        .Menu_Options_ISO.Enabled = CBool(Len(ImgBurnPathName))
        .Menu_Options_Burn_DVD.Enabled = .Menu_Options_ISO.Enabled
        With .Toolbar.Buttons("Output_Setup")
            .ButtonMenus("ISO").Enabled = CBool(Len(ImgBurnPathName))
            .ButtonMenus("Burn_DVD").Enabled = .ButtonMenus("ISO").Enabled
        End With
    End With
        
    ' Check Preferences Paths
    If modFS.EsisteDir(Preferences.OutputPath) = False Then
        modMain.Save_Log_Video "Warning! Cannot locate 'DVD Output Path'. Check 'Preferences'/'Paths'.", , True
    ElseIf modFS.EsisteDir(Preferences.AssetsPath) = False Then
        modMain.Save_Log_Video "Warning! Cannot locate 'DVD Asset Path'. Check 'Preferences'/'Paths'.", , True
    ElseIf modFS.EsisteDir(Preferences.TempPath) = False Then
        modMain.Save_Log_Video "Warning! Cannot locate 'Temporary Files Path'. Check 'Preferences'/'Paths'.", , True
    ElseIf modFS.EsisteDir(Preferences.MenuTemplatesPath) = False Then
        modMain.Save_Log_Video "Warning! Cannot locate 'DVD Menu Templates Path'. Check 'Preferences'/'Paths'.", , True
    Else
        'modMain.Save_Log_Video "Preferences Paths check passed."
    End If
    
    ' Welcome
    modMain.Save_Log_Video "New AVStoDVD Project started!"
    
    ' Handle Command Line
    If Command <> "" Then
        CL = Split(modStr.RemoveCharBegEnd(Command, """"), """ """)
        For jj = LBound(CL) To UBound(CL)
            If modFS.EsisteFile(CL(jj)) = True Then
                If LCase(modFS.ExtOf(CL(jj))) = "a2d" Then
                    Call frmMain.Open_Project(CL(jj))
                    Exit Sub
                Else
                    If InStr(1, FilterList.VideoFiles, "." & LCase(modFS.ExtOf(CL(jj)))) <> 0 Then
                        Call frmMain.Add_Title(CL(jj))
                    Else
                        MsgBox "Warning! Unrecognized or unsupported file format for title:" & vbCrLf & vbCrLf & CL(jj) & vbCrLf & vbCrLf & _
                               "AVStoDVD supports following formats:" & vbCrLf & vbCrLf & FilterList.SupportedVideoFormats, vbExclamation, App.Title
                    End If
                End If
            End If
         Next jj
    End If
    
End Sub


Public Sub Quit(Shutdown As Boolean)
    
    Dim jj As Integer
    Dim frm As Form
    
    On Error GoTo Err_Handling
    
    ' Unload Forms
    For Each frm In Forms
        Unload frm
    Next frm
    
    ' Restore ffdshow mixer setting
    If Preferences.ffdshowRuntime = True And modReg.EmiLeggiChiaveNumero("HKEY_CURRENT_USER\Software\GNU\ffdshow_audio\default", "mixerOut", 999) <> 999 Then
        modReg.ScriviChiaveNumero "HKEY_CURRENT_USER\Software\GNU\ffdshow_audio\default", "mixerOut", ffdshow.MixerBackup
    End If
    
    ' Check Shutdown
    If Shutdown = True Then
        Call SysInfo.WinShutdown(60, "AVStoDVD has completed the job. Shutdown in progress...")
    End If
    
    ' Clear Variables
    For jj = AC3 To DTS
        Set BitRates(jj) = Nothing
    Next jj
    Set FilterList = Nothing
    If Preferences.UnloadDShow = True Then
        Set DShow = Nothing
    End If
    Set Drives = Nothing
    Set SysInfo = Nothing
    Erase Title
    
    ' Delete files
    With Preferences
        If Dir(.TempPath & "\A2D*.cache") <> "" Then
            Kill .TempPath & "\A2D*.cache"
        End If
        If Dir(.TempPath & "\AviSynth*.avs") <> "" Then
            Kill .TempPath & "\AviSynth*.avs"
        End If
        modFS.DeleteIfExist Preferences.TempPath & "\AutoCrop001.bmp"
    End With
    
Err_Handling:
Screen.MousePointer = vbDefault
End
    
End Sub


Public Sub Reg_GeneralPreferences_Update()

    modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AppTitle", App.Title
    modReg.ScriviChiaveStringa AVStoDVD_RegKey, "Release", App.Major & "." & App.Minor & "." & App.Revision
    modReg.ScriviChiaveStringa AVStoDVD_RegKey, "ReleaseMajor", App.Major
    modReg.ScriviChiaveStringa AVStoDVD_RegKey, "ReleaseMinor", App.Minor
    modReg.ScriviChiaveStringa AVStoDVD_RegKey, "ReleaseRevision", App.Revision
    modReg.ScriviChiaveStringa AVStoDVD_RegKey, "ReleaseBuild", Right(App.Comments, 6)
    modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AppPath", App.Path
    
    With Preferences
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "MultiThread", -CInt(.MultiThread)
        
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "InputPath", .InputPath
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "OutputPath", .OutputPath
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AssetsPath", .AssetsPath
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "TempPath", .TempPath
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "MenuTemplatesPath", .MenuTemplatesPath
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "PreviewerPathName", .PreviewerPathName
        
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AVSVideoInput", .AVSVideoInput
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AVSAudioInput", .AVSAudioInput
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AVSUpSize", .AVSUpSize
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AVSDownSize", .AVSDownSize
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "AVSAdjustFrame", .AVSAdjustFrame
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "PALSpeedUp", .PALSpeedUp
        
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "KeepOrigVideo", -CInt(.KeepOrigVideo)
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "VideoStandard", .VideoStandard
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "VideoResolution", .VideoResolution
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "VideoProfileLevel1", .VideoProfileLevel1
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "VideoProfileLevel2", .VideoProfileLevel2
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "VideoMinAvgBitRate", .VideoMinAvgBitRate
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "VideoMaxAvgBitRate", .VideoMaxAvgBitRate
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "VideoMaxBitRate", .VideoMaxBitRate
        
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "KeepOrigAudio", -CInt(.KeepOrigAudio)
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "AC3AudioEncoder", .AC3AudioEncoder
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "ForceFFmpeg4GB", .ForceFFmpeg4GB
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "AudioFormat", .AudioFormat
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AudioBitRate", .AudioBitRate
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "AudioNormalize", -CInt(.AudioNormalize)
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AudioNormalizeVal", .AudioNormalizeVal
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "AudioDelayAuto", -CInt(.AudioDelayAuto)
        
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AudioLanguage", .AudioLanguage
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "AudioLanguage2", .AudioLanguage2
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "SubsLanguage", .SubsLanguage
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "SubsLanguage2", .SubsLanguage2
        With .SubsFont
            modReg.ScriviChiaveStringa AVStoDVD_RegKey, "SubsFontName", .Name
            modReg.ScriviChiaveNumero AVStoDVD_RegKey, "SubsFontHeight", .Height
            modReg.ScriviChiaveNumero AVStoDVD_RegKey, "SubsFontBold", -CInt(.Bold)
            modReg.ScriviChiaveNumero AVStoDVD_RegKey, "SubsFontItalic", -CInt(.Italic)
            modReg.ScriviChiaveNumero AVStoDVD_RegKey, "SubsFontColor", .Color
        End With
        With .SubsPos
            modReg.ScriviChiaveNumero AVStoDVD_RegKey, "SubsPosLeft", .Left
            modReg.ScriviChiaveNumero AVStoDVD_RegKey, "SubsPosBottom", .Bottom
            modReg.ScriviChiaveNumero AVStoDVD_RegKey, "SubsPosWidth", .Width
        End With
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "ChaptersInterval", .ChaptersInterval
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "ChaptersUseSource", -CInt(.ChaptersUseSource)
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "DVDBurningDrive", .DVDBurningDrive
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "DVDBurningSpeed", .DVDBurningSpeed
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "DVDAutoErase", -CInt(.DVDAutoErase)
        
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "SplashScreenName", .SplashScreenName
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "EncodingPriority", .EncodingPriority
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "EncodingWindowStyle", .EncodingWindowStyle
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "UnloadDShow", -CInt(.UnloadDShow)
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "ffdshowRuntime", -CInt(.ffdshowRuntime)
        modReg.ScriviChiaveNumero AVStoDVD_RegKey, "SaveSettings", -CInt(.SaveSettings)
        
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "Language", .Language
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "Skin", .Skin
    
        'DefaultCustomDVDSize, RecentProject1-5 and RecentTitle1-5 are stored during their runtime sections and they do not have a Preferences user-type variable
    
    End With

End Sub


Public Sub Reg_GeneralPreferences_Load()

    Dim jj As Integer
    Dim BurningDrive As String
    Dim Templates As New Collection
    Dim VideoUserPath As String
    
    On Error Resume Next
    
    For jj = 0 To Drives.driveCount - 1
        BurningDrive = Drives.driveLetter(jj) & ":\"
        If Drives.driveWriteDVD(jj) = True Then
            Exit For
        End If
    Next jj
    
    With Preferences
        .MultiThread = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "MultiThread", 1))
        
        VideoUserPath = SysInfo.SpecialPath(CSIDL_USER_VIDEOS)
        If Len(VideoUserPath) < 3 Then VideoUserPath = SysInfo.SpecialPath(CSIDL_COMMON_VIDEOS)
        If Len(VideoUserPath) < 3 Then VideoUserPath = SysInfo.SpecialPath(CSIDL_USER_DOCUMENTS)
        .InputPath = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "InputPath", VideoUserPath)
            If modFS.EsisteDir(.InputPath) = False Then .InputPath = VideoUserPath
        .OutputPath = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "OutputPath", VideoUserPath)
            If modFS.EsisteDir(.OutputPath) = False Then .OutputPath = VideoUserPath
        .AssetsPath = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AssetsPath", VideoUserPath)
            If modFS.EsisteDir(.AssetsPath) = False Then .AssetsPath = VideoUserPath
        .TempPath = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "TempPath", Environ("TEMP"))
            If modFS.EsisteDir(.TempPath) = False Then .TempPath = Environ("TEMP")
        .MenuTemplatesPath = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "MenuTemplatesPath", App.Path & "\Menu\Templates")
            Set Templates = modFS.FileList(.MenuTemplatesPath, "*.*", vbDirectory)
            If Templates.Count = 0 Then .MenuTemplatesPath = App.Path & "\Menu\Templates"
        .PreviewerPathName = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "PreviewerPathName", "")
    
        .AVSVideoInput = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AVSVideoInput", "")
        If .AVSVideoInput = "" Then .AVSVideoInput = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AVSInput", "A2DSource")
        .AVSAudioInput = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AVSAudioInput", "")
        If .AVSAudioInput = "" Then .AVSAudioInput = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AVSInput", "A2DSource")
        .AVSUpSize = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AVSUpSize", "Lanczos4Resize")
        .AVSDownSize = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AVSDownSize", "Spline16Resize")
        .AVSAdjustFrame = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "AVSAdjustFrame", 1)
        .PALSpeedUp = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "PALSpeedUp", 0))
        
        .KeepOrigVideo = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "KeepOrigVideo", 1))
        .VideoStandard = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "VideoStandard", 0)
        .VideoProfileLevel1 = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "VideoProfileLevel1", "6500")
        .VideoProfileLevel2 = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "VideoProfileLevel2", "4500")
        .VideoResolution = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "VideoResolution", 0)
        .VideoMinAvgBitRate = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "VideoMinAvgBitRate", "2500")
        .VideoMaxAvgBitRate = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "VideoMaxAvgBitRate", "8500")
        .VideoMaxBitRate = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "VideoMaxBitRate", "9000")
        
        .KeepOrigAudio = CBool(Val(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "KeepOrigAudio", 1)))
        .AC3AudioEncoder = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "AC3AudioEncoder", 0)
        .ForceFFmpeg4GB = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "ForceFFmpeg4GB", 1))
        .AudioFormat = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "AudioFormat", 0)
        .AudioBitRate = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AudioBitRate", "192")
        .AudioNormalize = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "AudioNormalize", 0))
        .AudioNormalizeVal = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AudioNormalizeVal", "1")
        .AudioDelayAuto = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "AudioDelayAuto", 1))
    
        .AudioLanguage = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AudioLanguage", "EN - English")
        .AudioLanguage2 = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "AudioLanguage2", "EN - English")
        .SubsLanguage = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "SubsLanguage", "EN - English")
        .SubsLanguage2 = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "SubsLanguage2", "EN - English")
        With .SubsFont
            .Name = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "SubsFontName", "Tahoma")
            .Height = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "SubsFontHeight", 18)
            .Bold = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "SubsFontBold", 0))
            .Italic = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "SubsFontItalic", 0))
            .Color = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "SubsFontColor", RGB(255, 255, 255))
        End With
        With .SubsPos
            .Left = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "SubsPosLeft", 80)
            .Bottom = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "SubsPosBottom", 100)
            .Width = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "SubsPosWidth", 560)
        End With
        .ChaptersInterval = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "ChaptersInterval", "5")
        .ChaptersUseSource = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "ChaptersUseSource", 1))
        .DVDBurningDrive = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "DVDBurningDrive", BurningDrive)
        .DVDBurningSpeed = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "DVDBurningSpeed", "4x")
        .DVDAutoErase = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "DVDAutoErase", 1))
    
        .SplashScreenName = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "SplashScreenName", "Default")
        .EncodingPriority = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "EncodingPriority", 0)
        .EncodingWindowStyle = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "EncodingWindowStyle", 1)
        .UnloadDShow = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "UnloadDShow", 0))
        .ffdshowRuntime = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "ffdshowRuntime", 1))
        .SaveSettings = CBool(modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "SaveSettings", 0))
        
        .Language = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "Language", "English")
        .Skin = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "Skin", "Default")
    End With

End Sub


Public Sub Reset_Project()

    Dim DVDMenuNull As MenuSettings
    Dim jj As Integer

    On Error Resume Next
    
    ' Initialize public variables
    VideoStandard = Preferences.VideoStandard
    DiscSize = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "DefaultDVDSize", DVD5)
    OutputSetup = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "DefaultOutputSetup", DVD_Folder)
    NumTitles = 0
    CurrentTitle = 0
    CurrentAudioTrack = 0
    Erase Title
    DVDMenu = DVDMenuNull
    
    ' Initialize frmMain
    With frmMain
        .Caption = "AVStoDVD"
        .Int_EditEncoderParams.value = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "DefaultEditEncoderParams", 0)
        .Int_FrameServingCheck.value = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "DefaultFrameServingCheck", 0)
        .intDeleteAssets.value = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "DefaultDeleteAssets", 1)
        .intDeleteWorking.value = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "DefaultDeleteWorking", 1)
        .Txt_DVD_Label.Text = "DVD"
        jj = modReg.EmiLeggiChiaveNumero(AVStoDVD_RegKey, "DefaultPostProcess", 0)
        If jj < 0 Or jj > .Cmb_PostProcess.ListCount - 1 Then
            .Cmb_PostProcess.ListIndex = 0
        Else
            .Cmb_PostProcess.ListIndex = jj
        End If
        .Txt_Estimated_Output_Size.Text = ""
        .Txt_Path_Output.Text = Preferences.OutputPath
        .ProgressBar.value = 0
        With .StatusBar
            .Panels("Video_Standard").Text = IIf(VideoStandard = PAL, "PAL", "NTSC")
            .Panels("DVD_Time").Text = VisualTime(0)
        End With
    End With
    With frmJobsList
        .JobsList.Tag = ""
    End With
    modMain.Change_Titles
    modMain.Change_Settings
    'modMain.Initialize_Project
    
    ' Initialize remaining public variables
    ChangeFlag = False
    
End Sub


Public Sub Initialize_Title(Title As TitleSettings, Video As Boolean, Audio As Boolean, Subs As Boolean, AVS As Boolean, Chapters As Boolean)

    Dim jj As Integer
    Dim FPS As Single
    Dim InputFPS As Single

    FPS = 25
    If VideoStandard = NTSC Then
        FPS = 2997 / 100
    End If
    
    With Title
        
        InputFPS = Val(.InputVideoInfo.FPS)
        If InputFPS = 0 Then
            InputFPS = FPS
        End If
        If .TitleName = "" Then
            .TitleName = modFS.NameOf(.InputVideoPathName)
        End If
        
        If Video = True Then
            .VideoAutoSetup = True
            .VideoAutoBitRate = True
            ' Define Video Resolution and if Video is to be kept
            .VideoIsToBeKept = False
            If Preferences.VideoResolution = Auto Then
                .VideoResolution = Full_D1
                If Val(.InputVideoInfo.Width) <= 352 Then
                    .VideoResolution = Half_D1
                    If VideoStandard = PAL And Val(.InputVideoInfo.Height) <= 288 Then
                        .VideoResolution = VCD
                    ElseIf VideoStandard = NTSC And Val(.InputVideoInfo.Height) <= 240 Then
                        .VideoResolution = VCD
                    End If
                End If
            Else
                .VideoResolution = Preferences.VideoResolution
            End If
            If Preferences.KeepOrigVideo = True Then
                Select Case VideoStandard
                Case PAL
                    Select Case .InputVideoInfo.DVDCompliant
                    Case PAL_Full_D1
                        .VideoIsToBeKept = True
                        .VideoResolution = Full_D1
                    Case PAL_Half_D1
                        .VideoIsToBeKept = True
                        .VideoResolution = Half_D1
                    Case PAL_VCD
                        .VideoIsToBeKept = True
                        .VideoResolution = VCD
                    End Select
                Case NTSC
                    Select Case .InputVideoInfo.DVDCompliant
                    Case NTSC_Full_D1
                        .VideoIsToBeKept = True
                        .VideoResolution = Full_D1
                    Case NTSC_Half_D1
                        .VideoIsToBeKept = True
                        .VideoResolution = Half_D1
                    Case NTSC_VCD
                        .VideoIsToBeKept = True
                        .VideoResolution = VCD
                    End Select
                End Select
            End If
            ' Define Video Encoding Profile
            If .VideoAutoSetup = True Then
                Select Case Val(.VideoBitRate)
                Case Is <= Val(Preferences.VideoProfileLevel2)
                    .VideoProfile = "HCenc VBR 2-pass"
                Case Is <= Val(Preferences.VideoProfileLevel1)
                    .VideoProfile = "HCenc VBR 1-pass"
                Case Else
                    .VideoProfile = "FFmpeg CBR 1-pass"
                End Select
            End If
            ' Define Video Aspect Ratio
            .VideoAspectRatio = Standard
            ' Define Video Adv Options
            If Val(.InputVideoInfo.DAR) > 1.75 Then
                .VideoAspectRatio = Widescreen
            End If
            With .VideoHCenc
                .AQ = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "DefaultHCencAQ", "1")
                .Lumgain = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "DefaultHCencLumGain", "1")
                .Matrix = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "DefaultHCencMatrix", "MPEG")
                .Profile = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "DefaultHCencProfile", "BEST")
                .Bias = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "DefaultHCencBias", "AUTO")
                .DCPrec = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "DefaultHCencDCPrec", "AUTO")
                .Zone = ""
            End With
            .VideoFFmpegHQ = False
            ' Define DVSource, Interlacement, Field order, GOPs
            .VideoDVSource = False
            If InStr(1, .InputVideoInfo.Compression, "DV") <> 0 And Val(.InputVideoInfo.AvgBitRate) / 1000 > 20000 Then
                Select Case VideoStandard
                Case PAL
                    If Val(.InputVideoInfo.FPS) = 25 And .InputVideoInfo.Width = "720" And .InputVideoInfo.Height = "576" Then
                        .VideoDVSource = True
                    End If
                Case NTSC
                    If Val(.InputVideoInfo.FPS) = 2997 / 100 And .InputVideoInfo.Width = "720" And .InputVideoInfo.Height = "480" Then
                        .VideoDVSource = True
                    End If
                End Select
            End If
            .VideoInterlacedEncoding = .VideoDVSource
            If InStr(1, UCase(.InputVideoInfo.ScanType), "INTERLACED") <> 0 Then
                .VideoInterlacedEncoding = True
            End If
            .VideoFieldOrder = "TFF"
            If UCase(.InputVideoInfo.ScanOrder) = "BFF" Or .VideoDVSource = True Then
                .VideoFieldOrder = "BFF"
            End If
            .VideoCloseAllGOPs = False
            ' Video bitrate is defined in dedicate bitrate routine
        End If
        
        If Audio = True Then
            jj = 1
            Do Until .InputAudioPathName(jj) = ""
                .AudioAutoSetup(jj) = True
                ' Define if Audio is to be kept
                .AudioIsToBeKept(jj) = False
                If Preferences.KeepOrigAudio = True Then
                    .AudioIsToBeKept(jj) = CBool(.InputAudioInfo(jj).DVDCompliant)
                End If
                ' Force Audio re-encoding if PALSpeedUp is on
                If Preferences.PALSpeedUp = True And FPS = 25 And InputFPS = 23.976 Then
                    .AudioIsToBeKept(jj) = False
                End If
                ' Define AudioFormat
                If .AudioIsToBeKept(jj) = True Then
                    Select Case .InputAudioInfo(jj).DVDCompliant
                    Case AC3_Compl
                        .AudioFormat(jj) = AC3
                    Case MP2_Compl
                        .AudioFormat(jj) = MP2
                    'Case WAV_Compl
                    '    .AudioFormat(jj) = WAV
                    Case DTS_Compl
                        .AudioFormat(jj) = DTS
                    End Select
                Else
                    If .AudioAutoSetup(jj) = True Then
                        .AudioFormat(jj) = Preferences.AudioFormat
                    End If
                End If
                With .AudioAften(jj)
                    .Pad = "0"
                    .DRC = "5"
                    .BWFilter = "0"
                End With
                .AudioChannelsMode(jj) = "2.0"
                If IsNumeric(.InputAudioInfo(jj).Channels) = True Then
                    Select Case Val(.InputAudioInfo(jj).Channels)
                    Case Is > 5
                        .AudioChannelsMode(jj) = "5.1"
                    Case 1
                        .AudioChannelsMode(jj) = "1.0"
                    End Select
                End If
                If jj = 1 Then
                    .AudioLanguage(jj) = Preferences.AudioLanguage
                Else
                    .AudioLanguage(jj) = Preferences.AudioLanguage2
                End If
                .AudioNormalize(jj) = Preferences.AudioNormalize
                .AudioDelayAuto(jj) = Preferences.AudioDelayAuto
                .AudioFixAC3(jj) = True
                jj = jj + 1
                If jj > MaxAudioTracks Then Exit Do
            Loop
            ' Audio bitrate is defined in dedicate bitrate routine
        End If
        
        If Subs = True Then
            jj = 1
            Do Until .InputSubsPathName(jj) = ""
                .SubsAutoSetup(jj) = True
                If jj = 1 Then
                    .SubsLanguage(jj) = Preferences.SubsLanguage
                Else
                    .SubsLanguage(jj) = Preferences.SubsLanguage2
                End If
                .SubsExtension(jj) = 1
                .SubsHardEncode(jj) = False
                jj = jj + 1
                If jj > MaxSubsTracks Then Exit Do
            Loop
        End If
        
        If AVS = True Then
            .AVSAutoSetup = True
            .AVSCrop = False
            .AVSVerticalResize = False
            .AVSDeInterlace = False
            .AVSTrim = False
            .AVSTweak = False
            .AVSSharpen = False
            .AVSDelayAudio = False
            .AVSAmplifyAudio = False
            .AVSFadeIO = False
            .AVSColorMatrix = False
            .AVSMSharpen = False
            .AVSHQDN3D = False
            .AVS.CropDx = 0
            .AVS.CropSx = 0
            .AVS.CropUp = 0
            .AVS.VResize = 100
            .AVS.DeIntThreshold = 10
            .AVS.FrameStart = 0
            If Val(.InputVideoInfo.FPS) > FPS Then
                .AVS.FrameEnd = Int(.TimeTrimmed * FPS)
            Else
                .AVS.FrameEnd = Int(Val(.InputVideoInfo.FrameCount))
            End If
            .AVS.Hue = 0
            .AVS.Saturation = 1
            .AVS.Brightness = 0
            .AVS.Contrast = 1
            .AVS.Sharpness = 0
            .AVS.AudioDelay = 0
            .AVS.AudioAmplify = 1
            .AVS.FadeIOFrames = 0
            .AVS.MSharpenThreshold = 10
            .AVS.MSharpenStrength = 100
            .AVS.HQDN3DStrength = 0
            .AVS.DeBlock = 25
            .AVSAutoScript = modAVS.Create_AVSScript(Title)
            .AVSScript = .AVSAutoScript
        End If
        
        ' Calculate TimeTrimmed
        .TimeTrimmed = Val(.InputGeneralInfo.Time) / 1000
        If .TimeTrimmed > 0 Then
            'If .AVS.FrameEnd = 0 Then
            '    If InputFPS < FPS Then
            '        .AVS.FrameEnd = Int(Val(.InputVideoInfo.FrameCount))
            '    Else
            '        .AVS.FrameEnd = Int(FPS * Val(.InputVideoInfo.Time) / 1000)
            '    End If
            'End If
            If .AVS.FrameEnd > 0 Then
                If InputFPS < FPS Then
                    .TimeTrimmed = (.AVS.FrameEnd - .AVS.FrameStart) / InputFPS
                    If Preferences.PALSpeedUp = True And FPS = 25 And InputFPS = 23.976 Then
                        .TimeTrimmed = .TimeTrimmed * 23.976 / 25
                    End If
                Else
                    .TimeTrimmed = (.AVS.FrameEnd - .AVS.FrameStart) / FPS
                End If
            End If
        End If
        
        If Chapters = True Then
            .ChaptersAutoSetup = True
            .ChaptersList = modMain.Create_Chapters_List(Title)
        End If
        
    End With

End Sub


Public Sub Load_Skin()

    Dim jj As Integer
    Dim PathSkinIni As String
    Dim NumFile As Integer
    Dim StrSkinIni As String
    Dim IconFileName As New Collection
    
    On Error GoTo Err_Handling
    
    Screen.MousePointer = vbHourglass
    
    Skin.Path = App.Path & "\Skins\" & Preferences.Skin
    If modFS.EsisteDir(Skin.Path) = False Then
        Skin.Path = App.Path & "\Skins\Default"
    End If

    With frmMain
        ' Load Text settings
        NumFile = FreeFile
        PathSkinIni = Skin.Path & "\Skin.ini"
        If modFS.EsisteFile(PathSkinIni) = False Then
            PathSkinIni = App.Path & "\Skins\Default\Skin.ini"
        End If
        Open PathSkinIni For Input As #NumFile
            Do
                StrSkinIni = StrSkinIni & Input(1, #NumFile)
            Loop Until UCase(Right(StrSkinIni, 7)) = "UPDATED" Or EOF(NumFile) = True
        Close #NumFile
        ' Set Foregroud settings
        Skin.ForeRed = Load_Str_Object(StrSkinIni, "Red", "0")
        Skin.ForeGreen = Load_Str_Object(StrSkinIni, "Green", "0")
        Skin.ForeBlue = Load_Str_Object(StrSkinIni, "Blue", "0")
        Skin.Font = Load_Str_Object(StrSkinIni, "Font", "Tahoma")
        Call modMain.Load_Skin_Font(frmMain)
        
        ' Initialize ImageList(s)
        Set .Toolbar.ImageList = Nothing
        Set .TitlesTreeView.ImageList = Nothing
        Set .ListView.SmallIcons = Nothing
        .ImageList60.ListImages.Clear
        .ImageList32.ListImages.Clear
        .ImageList16.ListImages.Clear
                
        ' Populate Imagelists
        If modFS.EsisteFile(Skin.Path & "\Icons.dll") = True Then
            modEnumResIcons.GetIconsFromLibrary Skin.Path & "\Icons.dll", .ImageList16, 16    '32 16x16 icons
            modEnumResIcons.GetIconsFromLibrary Skin.Path & "\Icons.dll", .ImageList32, 32    '43 32x32 icons
            modEnumResIcons.GetIconsFromLibrary Skin.Path & "\Icons.dll", .ImageList60, 60    '2  60x60 icons
        End If
        
        ' Backup with .ico
        If .ImageList16.ListImages.Count = 0 Or .ImageList32.ListImages.Count = 0 Or .ImageList60.ListImages.Count = 0 Then
            Set IconFileName = modFS.FileList(Skin.Path, "*.ico")
                If IconFileName.Count = 0 Then
                    MsgBox "Warning! Errors found during Skin Icons loading!" & vbCrLf & vbCrLf & "Default AVStoDVD icon will be used." & vbCrLf & vbCrLf & "See Help/FAQ/GUI/Q2.6 for more details.", vbCritical, App.Title
                    With .ImageList60.ListImages
                        For jj = 1 To 2
                            .add .Count + 1, , modMain.Load_Skin_Icon(App.Path & "\Graphics\AVStoDVD_Icon_Default.ico")
                        Next jj
                    End With
                    With .ImageList32.ListImages
                        For jj = 1 To 43
                            .add .Count + 1, , modMain.Load_Skin_Icon(App.Path & "\AVStoDVD.ico")
                        Next jj
                    End With
                    With .ImageList16.ListImages
                        For jj = 1 To 32
                            .add .Count + 1, , modMain.Load_Skin_Icon(App.Path & "\AVStoDVD.ico")
                        Next jj
                    End With
                Else
                    For jj = 1 To IconFileName.Count
                        With .ImageList60.ListImages
                            If InStr(1, IconFileName.Item(jj), "A2D_60_") <> 0 Then
                                .add .Count + 1, IconFileName.Item(jj), modMain.Load_Skin_Icon(Skin.Path & "\" & IconFileName.Item(jj))
                            End If
                        End With
                        With .ImageList32.ListImages
                            If InStr(1, IconFileName.Item(jj), "A2D_32_") <> 0 Then
                                .add .Count + 1, IconFileName.Item(jj), modMain.Load_Skin_Icon(Skin.Path & "\" & IconFileName.Item(jj))
                            End If
                        End With
                        With .ImageList16.ListImages
                            If InStr(1, IconFileName.Item(jj), "A2D_16_") <> 0 Then
                                .add .Count + 1, IconFileName.Item(jj), modMain.Load_Skin_Icon(Skin.Path & "\" & IconFileName.Item(jj))
                            End If
                        End With
                    Next jj
                End If
            Set IconFileName = Nothing
        End If
        
        ' Toolbar
        Set .Toolbar.ImageList = .ImageList32
        With .Toolbar
            .Buttons(2).Image = 1
            .Buttons(3).Image = 2
            .Buttons(4).Image = 3
            .Buttons(6).Image = 4
            .Buttons(7).Image = 5
            .Buttons(9).Image = 30
            .Buttons(11).Image = 36
            .Buttons(13).Image = 7
            .Buttons(15).Image = 6
            .Buttons(17).Image = 8
        End With
        
        ' TreeView
        Set .TitlesTreeView.ImageList = .ImageList16
        
        ' ListView
        Set .ListView.SmallIcons = .ImageList16
        modMain.Save_Log_Video "", True
            
        ' Statusbar
        With .StatusBar
            .Panels(1).Picture = frmMain.ImageList16.ListImages(1).Picture
            .Panels(2).Picture = frmMain.ImageList16.ListImages(2).Picture
            .Panels(3).Picture = frmMain.ImageList16.ListImages(3).Picture
            .Panels(4).Picture = frmMain.ImageList16.ListImages(4).Picture
            .Panels(5).Picture = frmMain.ImageList16.ListImages(26).Picture
            .Panels(6).Picture = frmMain.ImageList16.ListImages(5).Picture
        End With
        
        ' Main Form Buttons
        .Pls_Add_Title.Caption = ""
        .Pls_Add_Title.Picture = .ImageList32.ListImages(9).Picture
        .Img_Add_Title.Picture = .Pls_Add_Title.Picture
        .Pls_Edit_Title.Caption = ""
        .Pls_Edit_Title.Picture = .ImageList32.ListImages(10).Picture
        .Img_Edit_Title.Picture = .ImageList32.ListImages(11).Picture
        .Pls_Del_Title.Caption = ""
        .Pls_Del_Title.Picture = .ImageList32.ListImages(12).Picture
        .Img_Del_Title.Picture = .ImageList32.ListImages(13).Picture
        .Pls_Preview_Title.Caption = ""
        .Pls_Preview_Title.Picture = .ImageList32.ListImages(14).Picture
        .Img_Preview_Title.Picture = .ImageList32.ListImages(15).Picture
        .Pls_Path_Output.Caption = ""
        .Pls_Path_Output.Picture = .ImageList16.ListImages(11).Picture
        .Img_Path_Output.Picture = .Pls_Path_Output.Picture
        .Pls_Start.Caption = ""
        .Pls_Start.Picture = .ImageList60.ListImages(1).Picture
        .Img_Start.Picture = .ImageList60.ListImages(2).Picture
        
    End With
    
    ' JobsList Form Buttons
    With frmJobsList
        .Pls_Add_Job.Caption = ""
        .Pls_Add_Job.Picture = frmMain.ImageList16.ListImages(12).Picture
        .Img_Add_Job.Picture = .Pls_Add_Job.Picture
        .Pls_Remove_Job.Caption = ""
        .Pls_Remove_Job.Picture = frmMain.ImageList16.ListImages(14).Picture
        .Img_Remove_Job.Picture = .Pls_Remove_Job.Picture
        .Pls_Move_Up.Caption = ""
        .Pls_Move_Up.Picture = frmMain.ImageList16.ListImages(13).Picture
        .Img_Move_Up.Picture = .Pls_Move_Up.Picture
        .Pls_Erase_List.Caption = ""
        .Pls_Erase_List.Picture = frmMain.ImageList16.ListImages(15).Picture
        .Img_Erase_List.Picture = .Pls_Erase_List.Picture
        .Pls_Save_List.Caption = ""
        .Pls_Save_List.Picture = frmMain.ImageList16.ListImages(23).Picture
        .Img_Save_List.Picture = .Pls_Save_List.Picture
        .Pls_Load_List.Caption = ""
        .Pls_Load_List.Picture = frmMain.ImageList16.ListImages(24).Picture
        .Img_Load_List.Picture = .Pls_Load_List.Picture
        .Pls_Batch_Start.Caption = ""
        .Pls_Batch_Start.Picture = frmMain.ImageList16.ListImages(16).Picture
        .Img_Batch_Start.Picture = .Pls_Batch_Start.Picture
    End With
    
    GoTo Exit_Handling
    
Err_Handling:
Select Case Err.Number
Case 9999 'debug purpose
    Resume
End Select
Set IconFileName = Nothing

Exit_Handling:
Screen.MousePointer = vbDefault
    
End Sub


Public Sub Load_Skin_Font(frm As Form)

    Dim ctr As Control
    Dim jj As Integer
    Dim FC As Long
    
    On Error GoTo Err_Handling
    
    FC = RGB(CInt(Skin.ForeRed), CInt(Skin.ForeGreen), CInt(Skin.ForeBlue))
    With frm
        For Each ctr In .Controls
            Select Case UCase(Left(ctr.Name, 3))
            Case "PLS"
                .Controls(ctr.Name).Font.Name = Skin.Font
            Case "COR", "INT", "LBL"
                .Controls(ctr.Name).ForeColor = FC
                .Controls(ctr.Name).Font.Name = Skin.Font
            Case "OPT"
                For jj = .Controls(ctr.Name).LBound To .Controls(ctr.Name).UBound
                    .Controls(ctr.Name).Item(jj).ForeColor = FC
                    .Controls(ctr.Name).Item(jj).Font.Name = Skin.Font
                Next jj
            End Select
            If InStr(1, UCase(ctr.Name), "PROGRESSBAR") <> 0 Then
                modUtil.ProgBarForeColor ctr.hwnd, FC
            End If
        Next ctr
    End With
    
    Exit Sub

Err_Handling:
Select Case Err.Number
Case 438 'Propriet o metodo non supportati dall'oggetto
    Resume Next
End Select

End Sub


Public Function Load_Skin_Icon(IconPathName As String) As Picture

    On Error GoTo Err_Handling
    
    If modFS.EsisteFile(IconPathName) = True Then
        Set Load_Skin_Icon = LoadPicture(IconPathName)
    ElseIf modFS.EsisteFile(App.Path & "\Skins\Default\" & modFS.NameOf(IconPathName) & "." & modFS.ExtOf(IconPathName)) = True Then
        Set Load_Skin_Icon = LoadPicture(App.Path & "\Skins\Default\" & modFS.NameOf(IconPathName) & "." & modFS.ExtOf(IconPathName))
    Else
        GoTo Err_Handling
    End If
    
    Exit Function
    
Err_Handling:
Set Load_Skin_Icon = LoadPicture(App.Path & "\AVStoDVD.ico")
    
End Function


Public Function Load_Picture_AVStoDVD(PathName As String, Optional OnErrorPathName As String, Optional IsVideo As Boolean) As Picture

    Dim StrAVS As String
    Dim NumFile As Integer
    
    On Error GoTo Err_Handling
    
    If modUtil.IsPicture(PathName) = True Then
        Set Load_Picture_AVStoDVD = LoadPicture(PathName)
    ElseIf IsVideo = True Then
        StrAVS = "LoadPlugin(""" & App.Path & "\Lib\ffms2.dll""" & ")" & vbCrLf & _
                 "Import(""" & App.Path & "\Lib\A2DSource.avsi""" & ")" & vbCrLf & vbCrLf & _
                 "A2DVideoSource(""" & PathName & """)" & vbCrLf & _
                 "ConvertToYV12" & vbCrLf & _
                 "Trim(1,1)" & vbCrLf
        NumFile = FreeFile
        Open Preferences.TempPath & "\Picture.avs" For Output As #NumFile
            Print #NumFile, StrAVS
        Close #NumFile
        modShellEx.Execute App.Path & "\FFmpeg\ffmpeg.exe", "-i """ & Preferences.TempPath & "\Picture.avs""" & " -f rawvideo -threads " & SysInfo.ProcessorNumber & " -vcodec bmp -r 1 -y -an """ & Preferences.TempPath & "\Picture.bmp""", SW_HIDE, True
        Set Load_Picture_AVStoDVD = LoadPicture(Preferences.TempPath & "\Picture.bmp")
    Else
        GoTo Err_Handling
    End If
    
    Exit Function
    
Err_Handling:
If OnErrorPathName = "" Then
    MsgBox "Warning! Image '" & PathName & "' cannot be found or is invalid!" & vbCrLf & vbCrLf & "AVStoDVD default image will be loaded.", vbExclamation, App.Title
    OnErrorPathName = AVStoDVD_Picture
End If
Set Load_Picture_AVStoDVD = LoadPicture(OnErrorPathName)

End Function


'Update main form on changing Project Settings
Public Sub Change_Settings()

    Dim jj As Integer
    Dim ctr As Control
    
    On Error Resume Next
        
    With frmMain
        'Changing Disc Size
        .Menu_Options_DVD_5.Checked = False
        .Menu_Options_DVD_9.Checked = False
        .Menu_Options_Custom_Size.Checked = False
        With .Toolbar.Buttons("DVD_Size")
            .ButtonMenus("DVD_5").Text = frmMain.Menu_Options_DVD_5.Caption
            .ButtonMenus("DVD_9").Text = frmMain.Menu_Options_DVD_9.Caption
            .ButtonMenus("Custom").Text = frmMain.Menu_Options_Custom_Size.Caption
        End With
        Select Case DiscSize
        Case DVD5
            .Menu_Options_DVD_5.Checked = True
            .Toolbar.Buttons("DVD_Size").ButtonMenus("DVD_5").Text = Chr(149) & "  " & .Toolbar.Buttons("DVD_Size").ButtonMenus("DVD_5").Text
            .Txt_Output_Size.Text = 4450
            .StatusBar.Panels("DVD_Size").Text = modStr.DefaultStr(Language("170021"), "DVD-5")
        Case DVD9
            .Menu_Options_DVD_9.Checked = True
            .Toolbar.Buttons("DVD_Size").ButtonMenus("DVD_9").Text = Chr(149) & "  " & .Toolbar.Buttons("DVD_Size").ButtonMenus("DVD_9").Text
            .Txt_Output_Size.Text = 8100
            .StatusBar.Panels("DVD_Size").Text = modStr.DefaultStr(Language("170022"), "DVD-9")
        Case Custom
            .Menu_Options_Custom_Size.Checked = True
            .Toolbar.Buttons("DVD_Size").ButtonMenus("Custom").Text = Chr(149) & "  " & .Toolbar.Buttons("DVD_Size").ButtonMenus("Custom").Text
            .Txt_Output_Size.Text = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, "DefaultCustomDVDSize", "2200")
            .StatusBar.Panels("DVD_Size").Text = modStr.DefaultStr(Language("170023"), "Custom")
        End Select
        .ProgressBar.Max = .Txt_Output_Size.Text
        
        'Changing Output Setup
        .Menu_Options_MPEG2_2.Checked = False
        .Menu_Options_MPEG2_1.Checked = False
        .Menu_Options_DVD_Folder.Checked = False
        .Menu_Options_ISO.Checked = False
        .Menu_Options_Burn_DVD.Checked = False
        With .Toolbar.Buttons("Output_Setup")
            .ButtonMenus("MPEG2_2").Text = frmMain.Menu_Options_MPEG2_2.Caption
            .ButtonMenus("MPEG2_1").Text = frmMain.Menu_Options_MPEG2_1.Caption
            .ButtonMenus("DVD_Folder").Text = frmMain.Menu_Options_DVD_Folder.Caption
            .ButtonMenus("ISO").Text = frmMain.Menu_Options_ISO.Caption
            .ButtonMenus("Burn_DVD").Text = frmMain.Menu_Options_Burn_DVD.Caption
        End With
        Select Case OutputSetup
        Case MPEG2_Streams
            .Menu_Options_MPEG2_2.Checked = True
            .Toolbar.Buttons("Output_Setup").ButtonMenus("MPEG2_2").Text = Chr(149) & "  " & .Toolbar.Buttons("Output_Setup").ButtonMenus("MPEG2_2").Text
            .StatusBar.Panels("Output_Setup").Text = modStr.DefaultStr(Language("170031"), "MPEG2 Streams")
        Case MPEG2_File
            .Menu_Options_MPEG2_1.Checked = True
            .Toolbar.Buttons("Output_Setup").ButtonMenus("MPEG2_1").Text = Chr(149) & "  " & .Toolbar.Buttons("Output_Setup").ButtonMenus("MPEG2_1").Text
            .StatusBar.Panels("Output_Setup").Text = modStr.DefaultStr(Language("170032"), "MPEG2 File")
        Case DVD_Folder
            .Menu_Options_DVD_Folder.Checked = True
            .Toolbar.Buttons("Output_Setup").ButtonMenus("DVD_Folder").Text = Chr(149) & "  " & .Toolbar.Buttons("Output_Setup").ButtonMenus("DVD_Folder").Text
            .StatusBar.Panels("Output_Setup").Text = modStr.DefaultStr(Language("170033"), "DVD Folder")
        Case ISO_UDF_Image
            .Menu_Options_ISO.Checked = True
            .Toolbar.Buttons("Output_Setup").ButtonMenus("ISO").Text = Chr(149) & "  " & .Toolbar.Buttons("Output_Setup").ButtonMenus("ISO").Text
            .StatusBar.Panels("Output_Setup").Text = modStr.DefaultStr(Language("170034"), "ISO UDF Image")
        Case Burn_DVD
            .Menu_Options_Burn_DVD.Checked = True
            .Toolbar.Buttons("Output_Setup").ButtonMenus("Burn_DVD").Text = Chr(149) & "  " & .Toolbar.Buttons("Output_Setup").ButtonMenus("Burn_DVD").Text
            .StatusBar.Panels("Output_Setup").Text = modStr.DefaultStr(Language("170035"), "Burn DVD")
        End Select
        
        ' Changing DVD Menu
        With .Toolbar.Buttons("DVD_Menu")
            .ButtonMenus("Wizard").Text = frmMain.Menu_Options_DVDMenu_Wizard.Caption
            .ButtonMenus("Editor").Text = frmMain.Menu_Options_DVDMenu_Editor.Caption
            .ButtonMenus("Reset").Text = frmMain.Menu_Options_DVDMenu_Reset.Caption
        End With
        .Menu_Options_DVDMenu_Editor.Enabled = DVDMenu.IsInit
        .Toolbar.Buttons("DVD_Menu").ButtonMenus("Editor").Enabled = DVDMenu.IsInit
        .StatusBar.Panels("DVD_Menu").Text = modStr.DefaultStr(Language("170051"), "Menu Disabled")
        If DVDMenu.IsInit = True Then
            .StatusBar.Panels("DVD_Menu").Text = modStr.DefaultStr(Language("170052"), "Menu Enabled")
        End If
        .Menu_Options_DVDMenu.Enabled = Not (.Menu_Options_MPEG2_1.Checked Or .Menu_Options_MPEG2_2.Checked)
        .Toolbar.Buttons("DVD_Menu").Enabled = .Menu_Options_DVDMenu.Enabled
            
        ' Changing Language
        .Menu_View_Select_Language_English.Checked = False
        For jj = 1 To 9
            .Controls("Menu_View_Select_Language_" & jj).Checked = False
        Next jj
        If Preferences.Language = "English" Then
            .Menu_View_Select_Language_English.Checked = True
        Else
            For jj = 1 To 9
                If Preferences.Language = .Controls("Menu_View_Select_Language_" & jj).Caption Then
                    .Controls("Menu_View_Select_Language_" & jj).Checked = True
                End If
            Next jj
        End If
        If NumTitles > 0 Then
            For Each ctr In .Controls
                If InStr(1, ctr.Name, .Menu_Title_EditInfo.Name & "_Audio") <> 0 Then
                    ctr.Caption = ctr.Tag & " (Track " & CurrentAudioTrack & ")"
                End If
            Next ctr
        End If
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "Language", Preferences.Language
        
        ' Changing Skin
        .Menu_View_Select_Skin_Default.Checked = False
        For jj = 1 To 9
            .Controls("Menu_View_Select_Skin_" & jj).Checked = False
        Next jj
        If Preferences.Skin = "Default" Then
            .Menu_View_Select_Skin_Default.Checked = True
        Else
            For jj = 1 To 9
                If Preferences.Skin = .Controls("Menu_View_Select_Skin_" & jj).Caption Then
                    .Controls("Menu_View_Select_Skin_" & jj).Checked = True
                End If
            Next jj
        End If
        modReg.ScriviChiaveStringa AVStoDVD_RegKey, "Skin", Preferences.Skin
    End With

End Sub


Public Sub Change_Titles()

    Dim jj As Integer
    Dim kk As Integer
    Dim hh As Integer
    Dim NodeExpandedFlag(1 To 99) As Boolean
    Dim Str As String
    
    On Error Resume Next
    
    With frmMain
        .Menu_File_Save.Enabled = CBool(NumTitles)
        .Menu_File_Save_as.Enabled = CBool(NumTitles)
        .Menu_File_Start.Enabled = CBool(NumTitles)
        .Img_Start.Enabled = CBool(NumTitles)
        .Img_Start.Picture = frmMain.ImageList60.ListImages(2 + CInt(CBool(NumTitles))).Picture
        .Menu_Title_Edit.Enabled = CBool(NumTitles)
        .Img_Edit_Title.Enabled = CBool(NumTitles)
        .Img_Edit_Title.Picture = frmMain.ImageList32.ListImages(11 + CInt(CBool(NumTitles))).Picture
        .Menu_Title_Remove.Enabled = CBool(NumTitles)
        .Img_Del_Title.Enabled = CBool(NumTitles)
        .Img_Del_Title.Picture = frmMain.ImageList32.ListImages(13 + CInt(CBool(NumTitles))).Picture
        .Menu_Title_Refresh.Enabled = CBool(NumTitles)
        .Menu_Title_Preview.Enabled = CBool(NumTitles)
        .Img_Preview_Title.Enabled = CBool(NumTitles)
        .Img_Preview_Title.Picture = frmMain.ImageList32.ListImages(15 + CInt(CBool(NumTitles))).Picture
        .Menu_Title_ViewInfo.Enabled = CBool(NumTitles)
        .Menu_Title_EditInfo.Enabled = CBool(NumTitles)
        .Menu_Title_Audio.Enabled = CBool(NumTitles)
        .Menu_Title_Subs.Enabled = CBool(NumTitles)
        .Menu_Options_DVDMenu_Wizard.Enabled = CBool(NumTitles)
        .Menu_Tools_Join_AVS.Enabled = CBool(NumTitles)
        .Menu_Codecs_AviSynth_FrameServing_Check.Enabled = CBool(NumTitles)
        .Menu_Codecs_Graph.Enabled = CBool(NumTitles)
    End With

    With frmMain.TitlesTreeView
        If .Nodes.Count > 0 Then
            For jj = 1 To .Nodes.Count
                If .Nodes.Item(jj).Children > 0 Then
                    kk = kk + 1
                End If
            Next jj
            For jj = 1 To kk
                NodeExpandedFlag(jj) = .Nodes.Item("Title " & jj).Expanded
            Next jj
        End If
        .Nodes.Clear
        For jj = 1 To NumTitles
            Str = "Title " & jj & " (" & Title(jj).InputVideoPathName
            Str = Str & ")"
            .Nodes.add , tvwFirst, "Title " & jj, Str, 1
            .Nodes.add "Title " & jj, tvwChild, "Video " & jj, Title(jj).InputVideoInfo.Summary, 8
            If Title(jj).InputAudioPathName(1) <> "" Then
                Str = Title(jj).InputAudioInfo(1).Summary
                If Title(jj).InputAudioPathName(1) = Title(jj).InputVideoPathName Then
                    Str = Str & " - Internal" & IIf(Val(Title(jj).InputGeneralInfo.AudioTracksCount) > 1, " (Track " & Title(jj).InputAudioInfo(1).TrackID & ")", "")
                Else
                    Str = Str & " - External"
                End If
                .Nodes.add "Video " & jj, tvwNext, "Audio 1 " & jj, Str, 9
                hh = 1
                For kk = 2 To MaxAudioTracks
                    If Title(jj).InputAudioPathName(kk) <> "" Then
                        Str = Title(jj).InputAudioInfo(kk).Summary
                        If Title(jj).InputAudioPathName(kk) = Title(jj).InputVideoPathName Then
                            Str = Str & " - Internal" & IIf(Val(Title(jj).InputGeneralInfo.AudioTracksCount) > 1, " (Track " & Title(jj).InputAudioInfo(kk).TrackID & ")", "")
                        Else
                            Str = Str & " - External"
                        End If
                        hh = hh + 1
                        .Nodes.add "Audio " & hh - 1 & " " & jj, tvwNext, "Audio " & hh & " " & jj, Str, 9
                    End If
                Next kk
            End If
            If Title(jj).InputSubsPathName(1) <> "" Then
                Str = Title(jj).InputSubsInfo(1).Summary
                If Title(jj).InputSubsPathName(1) = Title(jj).InputVideoPathName Then
                    Str = Str & " - Internal" & IIf(Val(Title(jj).InputGeneralInfo.SubsTracksCount) > 1, " (Track " & Title(jj).InputSubsInfo(1).TrackID & ")", "")
                Else
                    Str = Str & " - External"
                End If
                .Nodes.add "Audio " & hh & " " & jj, tvwNext, "Subs 1 " & jj, Str, 10
                hh = 1
                For kk = 2 To MaxSubsTracks
                    If Title(jj).InputSubsPathName(kk) <> "" Then
                        Str = Title(jj).InputSubsInfo(kk).Summary
                        If Title(jj).InputSubsPathName(kk) = Title(jj).InputVideoPathName Then
                            Str = Str & " - Internal" & IIf(Val(Title(jj).InputGeneralInfo.SubsTracksCount) > 1, " (Track " & Title(jj).InputSubsInfo(kk).TrackID & ")", "")
                        Else
                            Str = Str & " - External"
                        End If
                        hh = hh + 1
                        .Nodes.add "Subs " & hh - 1 & " " & jj, tvwNext, "Subs " & hh & " " & jj, Str, 10
                    End If
                Next kk
            End If
        Next jj
        If NumTitles > 0 Then
            If CurrentTitle > NumTitles Then CurrentTitle = NumTitles
            For jj = 1 To NumTitles
                .Nodes.Item("Title " & jj).Expanded = NodeExpandedFlag(jj)
            Next jj
            .Nodes.Item("Title " & CurrentTitle).Expanded = True
            .Nodes.Item("Title " & CurrentTitle).Selected = True
            ChangeFlag = True
        End If
        If frmMain.Enabled = True And frmMain.Visible = True Then
            .SetFocus
        End If
        Call frmMain.TitlesTreeView_NodeClick(frmMain.TitlesTreeView.SelectedItem)
    End With
    
End Sub


Public Sub Define_BitRates_DVDSize()

    Dim jj As Integer
    Dim kk As Integer
    Dim LeftTime As Long
    Dim LeftVideoBitRate As Single
    Dim DVD_Time As Long
    Dim DVD_Size As Single
    Dim DVD_Size_Safe As Single
    Dim Output_Filesize As Single
    Dim KbpsToMB As Single  'still have to multiply for time
    Dim FileSystem As String
    Dim AudioBitRateMax As Integer
    Dim AudioBitRateTot As Integer
    Dim AudioBitRateStr As String
    Dim MInfo As New clsMediaInfo
    
    On Error GoTo Err_Handling
    
    ' Initialize variables
    KbpsToMB = 1000 / 8 / 1024 / 1024
    frmMain.Txt_Estimated_Output_Size.Text = ""
    frmMain.StatusBar.Panels("DVD_Time").Text = VisualTime(0)
    DVD_Size = Val(frmMain.Txt_Output_Size.Text)
    
    If NumTitles > 0 Then
        With DVDMenu
            If .IsInit = True Then
                If .Style = MotionMenu Then
                    Output_Filesize = (Val(.VideoBitRate) + 500) * KbpsToMB * Val(.MotionMenuDuration)
                Else
                    Output_Filesize = 1
                    If modFS.EsisteFile(.BackgroundAudioPath) = True Then
                        If MInfo.ReadMediaInfo(.BackgroundAudioPath, , False, False, True, False) = True Then
                            Output_Filesize = Int(192 * Val(MInfo.AudioTime(0)) / 1000 / 1024 / 8) + 1
                        End If
                        Set MInfo = Nothing
                    End If
                End If
                Output_Filesize = .NumMenuPages * Output_Filesize
            End If
        End With
        frmMain.Txt_Estimated_Output_Size.Tag = Output_Filesize
        
        ' Calculate DVD Time
        For jj = LBound(Title) To NumTitles
            DVD_Time = DVD_Time + Title(jj).TimeTrimmed
        Next jj
        LeftTime = DVD_Time
        ' Define Subs and Audio bitrates and initialize Video bitrate
        For jj = LBound(Title) To NumTitles
            With Title(jj)
                ' Add Subs bitrate
                For kk = 1 To Val(.InputGeneralInfo.SubsTracksCount)
                    If .SubsHardEncode(kk) = False Then
                        Output_Filesize = Output_Filesize + 15 * KbpsToMB * .TimeTrimmed
                    End If
                Next kk
                ' Define and add Audio bitrate (all Tracks)
                For kk = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                    ' Define AudioBitRate
                    If .AudioIsToBeKept(kk) = True Then
                        .AudioBitRate(kk) = Val(.InputAudioInfo(kk).AvgBitRate) / 1000
                    Else
                        If .AudioAutoSetup(kk) = True Then .AudioBitRate(kk) = 0
                        If .AudioBitRate(kk) <> 0 Then
                            AudioBitRateStr = Round(.AudioBitRate(kk), 0) * 1000
                        Else
                            If .InputAudioPathName(kk) = .InputVideoPathName Then
                                AudioBitRateStr = .InputAudioInfo(kk).AvgBitRate
                            Else
                                AudioBitRateStr = .InputAudioInfo(1).AvgBitRate
                            End If
                            AudioBitRateMax = BitRates(.AudioFormat(kk)).Item(BitRates(.AudioFormat(kk)).Count)
                            If Val(AudioBitRateStr) / 1000 > Val(Preferences.AudioBitRate) Or AudioBitRateStr = "" Then
                                If Val(.InputAudioInfo(kk).Channels) > 2 Then
                                    .AudioBitRate(kk) = AudioBitRateMax
                                End If
                            End If
                        End If
                        If .AudioBitRate(kk) = 0 Then .AudioBitRate(kk) = Val(Preferences.AudioBitRate)
                    End If
                    Output_Filesize = Output_Filesize + .AudioBitRate(kk) * KbpsToMB * .TimeTrimmed
                Next kk
                ' Initialize VideoBitRate and VideoMaxBitrate
                If .VideoIsToBeKept = True Then
                    .VideoBitRate = Int(Val(.InputVideoInfo.AvgBitRate) / 1000)
                End If
                If .VideoBitRate = 0 Then .VideoBitRate = Preferences.VideoMaxBitRate
                If .VideoBitRate > Preferences.VideoMaxBitRate Then .VideoBitRate = Preferences.VideoMaxBitRate
                .VideoMaxBitRate = Preferences.VideoMaxBitRate
                ' Reserve output space to special settings (direct stream copy and user-defined videobitrate)
                If .VideoIsToBeKept = True Or .VideoAutoBitRate = False Then
                    Output_Filesize = Output_Filesize + .VideoBitRate * KbpsToMB * .TimeTrimmed
                    LeftTime = LeftTime - .TimeTrimmed
                End If
            End With
        Next jj
        If OutputSetup < DVD_Folder And DiscSize = Custom Then
            DVD_Size_Safe = DVD_Size
        Else
            DVD_Size_Safe = Int(DVD_Size * (0.995 - 0.01 * DVD_Time / 3600))
        End If
        ' Finalize VideoBitrate
        If LeftTime > 0 Then
            LeftVideoBitRate = Round((DVD_Size_Safe - Output_Filesize) / KbpsToMB / LeftTime, 0)
            If LeftVideoBitRate > Val(Preferences.VideoMaxAvgBitRate) Then LeftVideoBitRate = Val(Preferences.VideoMaxAvgBitRate)
            If LeftVideoBitRate < Val(Preferences.VideoMinAvgBitRate) Then LeftVideoBitRate = Val(Preferences.VideoMinAvgBitRate)
            For jj = LBound(Title) To NumTitles
                With Title(jj)
                    If .VideoIsToBeKept = False And .VideoAutoBitRate = True Then
                        .VideoBitRate = LeftVideoBitRate
                        AudioBitRateTot = 0
                        For kk = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                            AudioBitRateTot = AudioBitRateTot + .AudioBitRate(kk)
                        Next kk
                        If .VideoBitRate + AudioBitRateTot > Preferences.VideoMaxBitRate Then
                            .VideoBitRate = Preferences.VideoMaxBitRate - AudioBitRateTot
                        End If
                        If .VideoMaxBitRate + AudioBitRateTot > 9500 Then
                            .VideoMaxBitRate = 9500 - AudioBitRateTot
                        End If
                        If .VideoBitRate > .VideoMaxBitRate Then .VideoMaxBitRate = .VideoBitRate
                        Output_Filesize = Output_Filesize + .VideoBitRate * KbpsToMB * .TimeTrimmed
                    End If
                    ' Define Video Encoding Profile
                    If .VideoAutoSetup = True Then
                        Select Case Val(.VideoBitRate)
                        Case Is <= Val(Preferences.VideoProfileLevel2)
                            .VideoProfile = "HCenc VBR 2-pass"
                        Case Is <= Val(Preferences.VideoProfileLevel1)
                            .VideoProfile = "HCenc VBR 1-pass"
                        Case Else
                            .VideoProfile = "FFmpeg CBR 1-pass"
                        End Select
                    End If
                End With
            Next jj
        End If
        With frmMain.StatusBar.Panels("DVD_Time")
            .Text = VisualTime(DVD_Time)
        End With
    
    End If

    ' Update Estimated Output Size and Progress Bar
    With frmMain
        .Txt_Estimated_Output_Size.Text = ""
        If Output_Filesize > 0 And DVD_Size_Safe > 0 Then
            .Txt_Estimated_Output_Size.Text = Int(Output_Filesize * Val(.Txt_Output_Size) / DVD_Size_Safe)
        End If
        .Txt_Estimated_Output_Size.ToolTipText = modStr.DefaultStr(Language("160021"), .Txt_Estimated_Output_Size.ToolTipText) & ": " & Round(Val(.Txt_Estimated_Output_Size.Tag)) & "/" & Round((Val(.Txt_Estimated_Output_Size.Text) - Val(.Txt_Estimated_Output_Size.Tag)) * (DVD_Size_Safe / .Txt_Output_Size.Text), 0) & "/" & Round((Val(.Txt_Estimated_Output_Size.Text) - Val(.Txt_Estimated_Output_Size.Tag)) * (1 - DVD_Size_Safe / .Txt_Output_Size.Text), 0) & " MB"
        If Val(.Txt_Estimated_Output_Size.Text) > Val(.Txt_Output_Size.Text) Then
            .Txt_Estimated_Output_Size.ForeColor = RGB(255, 0, 0)
            .ProgressBar.value = Val(.Txt_Output_Size.Text)
            modUtil.ProgBarForeColor .ProgressBar.hwnd, RGB(255, 0, 0)
            'modMain.Save_Log_Video "Warning! Resulting DVD will be oversized (" & Int(Val(.Txt_Estimated_Output_Size.Text) / Val(.Txt_Output_Size.Text) * 100) & "%)!"
            modMain.Save_Log_Video "Warning! Resulting DVD will be oversized (" & Format(Val(.Txt_Estimated_Output_Size.Text) / Val(.Txt_Output_Size.Text), "0%") & ")!"
        Else
            .Txt_Estimated_Output_Size.ForeColor = RGB(0, 0, 0)
            .ProgressBar.value = Val(.Txt_Estimated_Output_Size.Text)
            modUtil.ProgBarForeColor .ProgressBar.hwnd, RGB(Skin.ForeRed, Skin.ForeGreen, Skin.ForeBlue)
        End If
        FileSystem = modFS.atFATType(Left(Preferences.OutputPath, 2))
        If InStr(1, FileSystem, "FAT") <> 0 And Val(.Txt_Estimated_Output_Size.Text) > 3990 Then
            MsgBox "Warning! Output Folder FileSystem is " & UCase(FileSystem) & "." & vbCrLf & _
                   "DVD Size must be limited to 4 GB." & vbCrLf & vbCrLf & _
                   "Please set DVD Size to 'Custom'/'3990' MB", vbExclamation, App.Title
        End If
    End With

    Exit Sub
    
Err_Handling:
Select Case Err.Number
Case 9999
    Resume
Case Else
    MsgBox "Error " & Err.Number & vbCrLf & vbCrLf & Err.Description, vbCritical, App.Title
    modMain.Save_Log_Video "Warning! Failed to initialize Project and compute output DVD size! Verify source file and/or check project settings.", , True
    frmMain.Txt_Output_Size.Text = ""
    frmMain.ProgressBar.value = Val(frmMain.Txt_Output_Size.Text)
    Set MInfo = Nothing
End Select

End Sub


' Create chapters list (sequence of frames) to be saved as txt file and used by MuxMan
Public Function Create_Chapters_List(Title As TitleSettings, Optional Delimiter As String = " ") As String

    Dim jj As Integer
    Dim ChapterFPS As Single
    Dim FrameChapter As Long
    Dim Chapters
    
    On Error GoTo Err_Handling
    
    ChapterFPS = 25
    If VideoStandard = NTSC Then
        ChapterFPS = 2997 / 100
    End If
    With Title
        If Preferences.ChaptersUseSource = True And .InputGeneralInfo.ChaptersList <> "" Then
            Chapters = Split(.InputGeneralInfo.ChaptersList, " ")
            For jj = LBound(Chapters) To UBound(Chapters)
                If Chapters(jj) <> "" Then
                    FrameChapter = Int((Val(Mid(Chapters(jj), 1, 2)) * 3600 + Val(Mid(Chapters(jj), 4, 2)) * 60 + Val(Mid(Chapters(jj), 7, 2)) + Val(Right(Chapters(jj), 4))) * ChapterFPS)
                    If FrameChapter > 0 Then
                        If FrameChapter < .TimeTrimmed * ChapterFPS Then
                            Create_Chapters_List = Create_Chapters_List & FrameChapter & Delimiter
                        End If
                    End If
                End If
            Next jj
        ElseIf Val(Preferences.ChaptersInterval) * 60 < .TimeTrimmed Then
            Do
                jj = jj + 1
                FrameChapter = Val(Preferences.ChaptersInterval) * jj * 60 * Round(ChapterFPS)
                If FrameChapter < .TimeTrimmed * ChapterFPS Then
                    Create_Chapters_List = Create_Chapters_List & FrameChapter & Delimiter
                End If
            Loop Until FrameChapter > .TimeTrimmed * ChapterFPS
        End If
    End With
    If Right(Create_Chapters_List, 1) = Delimiter Then
        Create_Chapters_List = Left(Create_Chapters_List, Len(Create_Chapters_List) - Len(Delimiter))
    End If
    
    Exit Function
    
Err_Handling:
Create_Chapters_List = ""

End Function


Public Sub Save_Log(Str_File As String, Str_Log As String, Append_Flag As Boolean, Optional Video_Flag As Boolean)

    Dim NumFile As Integer
        
    ' Verify log file path
    If Append_Flag = False Then
        modFS.DeleteIfExist Str_File
    End If
    ' Append string 'Str_Log' to txt-based file 'Str_File'
    NumFile = FreeFile
    Open Str_File For Append As #NumFile
        Print #NumFile, "<" & Now() & ">" & vbCrLf & Str_Log & vbCrLf & "<>" & vbCrLf
    Close #NumFile
    If Video_Flag = True Then
        modMain.Save_Log_Video Str_Log
    End If

End Sub


Public Sub Save_Log_Video(StrLog As String, Optional Refresh As Boolean, Optional MessageBox As Boolean)

    Dim StrLogMod As String
    Dim IconNum As Integer
    Dim jj As Integer
    Dim Str
    Dim bFlag As Boolean
    
    ' Uses icons from ImageList16 control
    ' 6 -> InfoIcon
    ' 7 -> WarningIcon
    
    On Error Resume Next
    
    With frmMain.ListView
        If Refresh = True Then
            For jj = 1 To .ListItems.Count
                IconNum = 6
                With .ListItems(jj)
                    If InStr(1, UCase(.SubItems(2)), "WARNING") <> 0 Then IconNum = 7
                    If InStr(1, UCase(.SubItems(2)), "ABORT") <> 0 Then IconNum = 7
                    If InStr(1, UCase(.SubItems(2)), "ERROR") <> 0 Then IconNum = 7
                    .SmallIcon = IconNum
                End With
            Next jj
        End If
        If StrLog <> "" Then
            For jj = 1 To Len(StrLog)
                If Mid(StrLog, jj, 1) = """" Then
                    bFlag = Not bFlag
                Else
                    If bFlag = False Then
                        StrLogMod = StrLogMod & Mid(StrLog, jj, 1)
                    End If
                End If
            Next jj
            IconNum = 6
            If InStr(1, UCase(StrLogMod), "WARNING") <> 0 Then IconNum = 7
            If InStr(1, UCase(StrLogMod), "ABORT") <> 0 Then IconNum = 7
            If InStr(1, UCase(StrLogMod), "ERROR") <> 0 Then IconNum = 7
            Str = Split(StrLog, vbCrLf)
            For jj = LBound(Str) To UBound(Str)
                If Str(jj) <> "" Then
                    .ListItems.add .ListItems.Count + 1, , ""
                    With .ListItems(.ListItems.Count)
                        .SmallIcon = IconNum
                        .SubItems(1) = Format(Time, "hh:nn:ss")
                        .SubItems(2) = Str(jj)
                        .EnsureVisible
                    End With
                End If
            Next jj
            If MessageBox = True Then
                MsgBox StrLog, IIf(IconNum = 7, vbExclamation, vbInformation), App.Title
            End If
        End If
    End With
    
    modUtil.ListViewAutoSize frmMain.ListView, 1
    DoEvents

End Sub


Public Sub Save_History(frm As Form, MenuEntry As String, RegKeyEntry As String, PathName As String, Optional Counts As Integer = 5)

    Dim jj As Integer

    For jj = 1 To Counts
        If modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, RegKeyEntry & jj, "") = PathName Then
            Exit Sub
        End If
    Next jj
    For jj = Counts To 2 Step -1
        With frm.Controls(MenuEntry & jj)
            .Caption = modReg.EmiLeggiChiaveStringa(AVStoDVD_RegKey, RegKeyEntry & jj - 1, "")
            If .Caption <> "" Then
                modReg.ScriviChiaveStringa AVStoDVD_RegKey, RegKeyEntry & jj, .Caption
            End If
        End With
    Next jj
    frm.Controls(MenuEntry & "1").Caption = PathName
    modReg.ScriviChiaveStringa AVStoDVD_RegKey, RegKeyEntry & "1", PathName
    For jj = 1 To Counts
        frm.Controls(MenuEntry & jj).Visible = CBool(Len(frm.Controls(MenuEntry & jj).Caption))
    Next jj

End Sub


Public Function Create_Job_Save_Str(Optional FileNameSave As String) As String

    ' Create string containing all current project settings
    
    Dim Titolo As String
    Dim jj As Integer
    Dim kk As Integer
    Dim hh As Integer
    Dim Str As String
    
    On Error GoTo Err_Handling
    
    Screen.MousePointer = vbHourglass
    Titolo = "** Project Settings **"
    Str = Str & String(Len(Titolo), "*") & vbCrLf
    Str = Str & Titolo & vbCrLf
    Str = Str & String(Len(Titolo), "*") & vbCrLf
    Str = Str & vbCrLf
    Str = Str & "Project_PathName: " & FileNameSave & vbCrLf
    With frmMain
        Str = Str & "Output_Folder: " & .Txt_Path_Output.Text & vbCrLf
        Str = Str & "EditEncoderParams: " & .Int_EditEncoderParams.value & vbCrLf
        Str = Str & "DeleteAssets: " & .intDeleteAssets.value & vbCrLf
        Str = Str & "DeleteWorking: " & .intDeleteWorking.value & vbCrLf
        Str = Str & "FrameServingCheck: " & .Int_FrameServingCheck.value & vbCrLf
        Str = Str & "DVD_Label: " & .Txt_DVD_Label.Text & vbCrLf
        Str = Str & "Post_Process: " & .Cmb_PostProcess.ListIndex & vbCrLf
        Str = Str & "Output_Size: " & .Txt_Output_Size.Text & vbCrLf
        Str = Str & "DVD_Size: " & DiscSize & vbCrLf
        Str = Str & "Output_Setup: " & OutputSetup & vbCrLf
        Str = Str & "Video_Standard: " & VideoStandard & vbCrLf
    End With
    With DVDMenu
        If .IsInit = True Then
            Str = Str & vbCrLf
            Str = Str & "[DVD Menu]" & vbCrLf
            ' Wizard settings
            Str = Str & "IsInit: " & -CInt(.IsInit) & vbCrLf
            Str = Str & "IsFinal: " & -CInt(.IsFinal) & vbCrLf
            Str = Str & "Style: " & .Style & vbCrLf
            Str = Str & "AR: " & .AR & vbCrLf
            Str = Str & "TitlesFormat: " & .TitlesFormat & vbCrLf
            Str = Str & "Template: " & .Template & vbCrLf
            Str = Str & "MaxTitlesPage: " & .MaxTitlesPage & vbCrLf
            Str = Str & "PlayAllButton: " & -CInt(.PlayAllButton) & vbCrLf
            Str = Str & "ForcePlayAllSelection: " & -CInt(.ForcePlayAllSelection) & vbCrLf
            Str = Str & "BackgroundAudio: " & -CInt(.BackgroundAudio) & vbCrLf
            Str = Str & "MotionMenuDuration: " & .MotionMenuDuration & vbCrLf
            Str = Str & "VideoBitRate: " & .VideoBitRate & vbCrLf
            Str = Str & "MaxThumbsRow: " & .MaxThumbsRow & vbCrLf
            Str = Str & "ThumbImageSource: " & .ThumbImageSource & vbCrLf
            Str = Str & "ThumbFramePos: " & .ThumbFramePos & vbCrLf
            Str = Str & "HLFormat: " & .HLFormat & vbCrLf
            Str = Str & "HLColorsPlay: " & .HLColorsPlay & vbCrLf
            Str = Str & "HLColorsSel: " & .HLColorsSel & vbCrLf
            Str = Str & "ThumbShadow: " & .ThumbShadow & vbCrLf
            Str = Str & "PlayAllShadow: " & .PlayAllShadow & vbCrLf
            Str = Str & "ArrowsShadow: " & .ArrowsShadow & vbCrLf
            ' Editor settings
            Str = Str & "NumMenuTitles: " & .NumMenuTitles & vbCrLf
            Str = Str & "NumMenuPages: " & .NumMenuPages & vbCrLf
            Str = Str & "BackgroundPicturePath: " & .BackgroundPicturePath & vbCrLf
            Str = Str & "BackgroundVideoPath: " & .BackgroundVideoPath & vbCrLf
            Str = Str & "BackgroundAudioPath: " & .BackgroundAudioPath & vbCrLf
            Str = Str & "TitleText: " & Replace(.TitleText, vbCrLf, "~~") & vbCrLf   'replace CR+LF with ~~
            Str = Str & "TitleFontName: " & .TitleFont.Name & vbCrLf
            Str = Str & "TitleFontHeight: " & .TitleFont.Height & vbCrLf
            Str = Str & "TitleFontBold: " & -CInt(.TitleFont.Bold) & vbCrLf
            Str = Str & "TitleFontItalic: " & -CInt(.TitleFont.Italic) & vbCrLf
            Str = Str & "TitleFontUnderline: " & -CInt(.TitleFont.Underline) & vbCrLf
            Str = Str & "TitleFontOutline: " & -CInt(.TitleFont.Outline) & vbCrLf
            Str = Str & "TitleFontShadow: " & -CInt(.TitleFont.Shadow) & vbCrLf
            Str = Str & "TitleFontColor: " & .TitleFont.Color & vbCrLf
            Str = Str & "TitleAlignment: " & .TitleAlignment & vbCrLf
            Str = Str & "TitleLeft: " & .TitleLeft & vbCrLf
            Str = Str & "TitleTop: " & .TitleTop & vbCrLf
            Str = Str & "TitleWidth: " & .TitleWidth & vbCrLf
            Str = Str & "TitleHeight: " & .TitleHeight & vbCrLf
            Str = Str & "PlayAllButtonPicturePath: " & .PlayAllButtonPicturePath & vbCrLf
            Str = Str & "PlayAllButtonLeft: " & .PlayAllButtonLeft & vbCrLf
            Str = Str & "PlayAllButtonTop: " & .PlayAllButtonTop & vbCrLf
            Str = Str & "PlayAllButtonWidth: " & .PlayAllButtonWidth & vbCrLf
            Str = Str & "PlayAllButtonHeight: " & .PlayAllButtonHeight & vbCrLf
            Str = Str & "ArrowLButtonPicturePath: " & .ArrowLButtonPicturePath & vbCrLf
            Str = Str & "ArrowLButtonLeft: " & .ArrowLButtonLeft & vbCrLf
            Str = Str & "ArrowLButtonTop: " & .ArrowLButtonTop & vbCrLf
            Str = Str & "ArrowLButtonWidth: " & .ArrowLButtonWidth & vbCrLf
            Str = Str & "ArrowLButtonHeight: " & .ArrowLButtonHeight & vbCrLf
            Str = Str & "ArrowRButtonPicturePath: " & .ArrowRButtonPicturePath & vbCrLf
            Str = Str & "ArrowRButtonLeft: " & .ArrowRButtonLeft & vbCrLf
            Str = Str & "ArrowRButtonTop: " & .ArrowRButtonTop & vbCrLf
            Str = Str & "ArrowRButtonWidth: " & .ArrowRButtonWidth & vbCrLf
            Str = Str & "ArrowRButtonHeight: " & .ArrowRButtonHeight & vbCrLf
        End If
    End With
    Str = Str & vbCrLf & vbCrLf
    For jj = 1 To NumTitles
        DoEvents
        With Title(jj)
            Titolo = "** Title " & jj & " **"
            Str = Str & String(Len(Titolo), "*") & vbCrLf
            Str = Str & Titolo & vbCrLf
            Str = Str & String(Len(Titolo), "*") & vbCrLf
            Str = Str & vbCrLf
            Str = Str & "[General]" & vbCrLf
            Str = Str & "TitleName: " & .TitleName & vbCrLf
            Str = Str & "TimeTrimmed: " & .TimeTrimmed & vbCrLf
            Str = Str & "InputVideoPathName: " & .InputVideoPathName & vbCrLf
            For kk = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                Str = Str & "InputAudioPathName" & kk & ": " & .InputAudioPathName(kk) & vbCrLf
            Next kk
            For kk = 1 To Val(.InputGeneralInfo.SubsTracksCount)
                Str = Str & "InputSubsPathName" & kk & ": " & .InputSubsPathName(kk) & vbCrLf
            Next kk
            Str = Str & vbCrLf
            Str = Str & "[MediaInfo]" & vbCrLf
            With .InputGeneralInfo
                Str = Str & "MediaInfoVersion: " & .MediaInfoVersion & vbCrLf
                Str = Str & "Format: " & .Format & vbCrLf
                Str = Str & "AudioTracksCount: " & .AudioTracksCount & vbCrLf
                Str = Str & "SubsTracksCount: " & .SubsTracksCount & vbCrLf
                Str = Str & "Time: " & .Time & vbCrLf
                Str = Str & "ChaptersList: " & .ChaptersList & vbCrLf
            End With
            With .InputVideoInfo
                Str = Str & "VideoTime: " & .Time & vbCrLf
                Str = Str & "VideoCompression: " & .Compression & vbCrLf
                Str = Str & "VideoBitRateMode: " & .BitRateMode & vbCrLf
                Str = Str & "VideoAvgBitRate: " & .AvgBitRate & vbCrLf
                Str = Str & "VideoMinBitRate: " & .MinBitRate & vbCrLf
                Str = Str & "VideoMaxBitRate: " & .MaxBitRate & vbCrLf
                Str = Str & "VideoWidth: " & .Width & vbCrLf
                Str = Str & "VideoHeight: " & .Height & vbCrLf
                Str = Str & "VideoDAR: " & .DAR & vbCrLf
                Str = Str & "VideoPAR: " & .PAR & vbCrLf
                Str = Str & "VideoFAR: " & .FAR & vbCrLf
                Str = Str & "VideoFrameRateMode: " & .FrameRateMode & vbCrLf
                Str = Str & "VideoFPS: " & .FPS & vbCrLf
                Str = Str & "VideoFrameCount: " & .FrameCount & vbCrLf
                Str = Str & "VideoScanType: " & .ScanType & vbCrLf
                Str = Str & "VideoScanOrder: " & .ScanOrder & vbCrLf
            End With
            For hh = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                With .InputAudioInfo(hh)
                    Str = Str & "AudioID(" & hh & "): " & .ID & vbCrLf
                    Str = Str & "AudioTrackID(" & hh & "): " & .TrackID & vbCrLf
                    Str = Str & "AudioTime(" & hh & "): " & .Time & vbCrLf
                    Str = Str & "AudioCompression(" & hh & "): " & .Compression & vbCrLf
                    Str = Str & "AudioAvgBitRate(" & hh & "): " & .AvgBitRate & vbCrLf
                    Str = Str & "AudioBitRateMode(" & hh & "): " & .BitRateMode & vbCrLf
                    Str = Str & "AudioChannels(" & hh & "): " & .Channels & vbCrLf
                    Str = Str & "AudioSampleRate(" & hh & "): " & .SampleRate & vbCrLf
                    Str = Str & "AudioResolution(" & hh & "): " & .Resolution & vbCrLf
                    Str = Str & "AudioLanguage(" & hh & "): " & .Language & vbCrLf
                    Str = Str & "AudioDelay(" & hh & "): " & .Delay & vbCrLf
                End With
            Next hh
            For hh = 1 To Val(.InputGeneralInfo.SubsTracksCount)
                With .InputSubsInfo(hh)
                    Str = Str & "TextID(" & hh & "): " & .ID & vbCrLf
                    Str = Str & "TextTrackID(" & hh & "): " & .TrackID & vbCrLf
                    Str = Str & "TextFormat(" & hh & "): " & .Format & vbCrLf
                    Str = Str & "TextTitle(" & hh & "): " & .Title & vbCrLf
                    Str = Str & "TextLanguage(" & hh & "): " & .Language & vbCrLf
                End With
            Next hh
            Str = Str & vbCrLf
            Str = Str & "[Video]" & vbCrLf
            Str = Str & "VideoAutoSetup: " & -CInt(.VideoAutoSetup) & vbCrLf
            Str = Str & "VideoIsToBeKept: " & -CInt(.VideoIsToBeKept) & vbCrLf
            Str = Str & "VideoProfile: " & .VideoProfile & vbCrLf
            Str = Str & "VideoHCencAQ: " & .VideoHCenc.AQ & vbCrLf
            Str = Str & "VideoHCencLumgain: " & .VideoHCenc.Lumgain & vbCrLf
            Str = Str & "VideoHCencMatrix: " & .VideoHCenc.Matrix & vbCrLf
            Str = Str & "VideoHCencProfile: " & .VideoHCenc.Profile & vbCrLf
            Str = Str & "VideoHCencBias: " & .VideoHCenc.Bias & vbCrLf
            Str = Str & "VideoHCencDCPrec: " & .VideoHCenc.DCPrec & vbCrLf
            Str = Str & "VideoHCencZone: " & .VideoHCenc.Zone & vbCrLf
            Str = Str & "VideoFFmpegHQ: " & .VideoFFmpegHQ & vbCrLf
            Str = Str & "VideoResolution: " & .VideoResolution & vbCrLf
            Str = Str & "VideoAspectRatio: " & .VideoAspectRatio & vbCrLf
            Str = Str & "VideoDVSource: " & -CInt(.VideoDVSource) & vbCrLf
            Str = Str & "VideoInterlacedEncoding: " & -CInt(.VideoInterlacedEncoding) & vbCrLf
            Str = Str & "VideoFieldOrder: " & .VideoFieldOrder & vbCrLf
            Str = Str & "VideoCloseAllGOPs: " & -CInt(.VideoCloseAllGOPs) & vbCrLf
            Str = Str & "VideoBitRate: " & .VideoBitRate & vbCrLf
            Str = Str & "VideoMaxBitRate: " & .VideoMaxBitRate & vbCrLf
            Str = Str & "VideoAutoBitRate: " & -CInt(.VideoAutoBitRate) & vbCrLf
            Str = Str & vbCrLf
            Str = Str & "[Audio]" & vbCrLf
            For kk = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                Str = Str & "AudioAutoSetup" & kk & ": " & -CInt(.AudioAutoSetup(kk)) & vbCrLf
                Str = Str & "AudioIsToBeKept" & kk & ": " & -CInt(.AudioIsToBeKept(kk)) & vbCrLf
                Str = Str & "AudioFormat" & kk & ": " & .AudioFormat(kk) & vbCrLf
                Str = Str & "AudioChannelsMode" & kk & ": " & .AudioChannelsMode(kk) & vbCrLf
                Str = Str & "AudioLanguage" & kk & ": " & .AudioLanguage(kk) & vbCrLf
                Str = Str & "AudioBitRate" & kk & ": " & .AudioBitRate(kk) & vbCrLf
                Str = Str & "AudioNormalize" & kk & ": " & -CInt(.AudioNormalize(kk)) & vbCrLf
                Str = Str & "AudioDelayAuto" & kk & ": " & -CInt(.AudioDelayAuto(kk)) & vbCrLf
                Str = Str & "AudioFixAC3" & kk & ": " & -CInt(.AudioFixAC3(kk)) & vbCrLf
                Str = Str & "AudioAftenPad" & kk & ": " & .AudioAften(kk).Pad & vbCrLf
                Str = Str & "AudioAftenDRC" & kk & ": " & .AudioAften(kk).DRC & vbCrLf
                Str = Str & "AudioAftenBWFilter" & kk & ": " & .AudioAften(kk).BWFilter & vbCrLf
            Next kk
            Str = Str & vbCrLf
            Str = Str & "[Subs]" & vbCrLf
            For kk = 1 To Val(.InputGeneralInfo.SubsTracksCount)
                Str = Str & "SubsAutoSetup" & kk & ": " & -CInt(.SubsAutoSetup(kk)) & vbCrLf
                Str = Str & "SubsLanguage" & kk & ": " & .SubsLanguage(kk) & vbCrLf
                Str = Str & "SubsExtension" & kk & ": " & .SubsExtension(kk) & vbCrLf
                Str = Str & "SubsHardEncode" & kk & ": " & -CInt(.SubsHardEncode(kk)) & vbCrLf
            Next kk
            Str = Str & vbCrLf
            Str = Str & "[AVS]" & vbCrLf
            Str = Str & "AVSAutoSetup: " & -CInt(.AVSAutoSetup) & vbCrLf
            Str = Str & "AVSAutoScript: " & vbCrLf & .AVSAutoScript & vbCrLf
            Str = Str & "AVSScript: " & vbCrLf & .AVSScript & vbCrLf
            Str = Str & "AVSCrop: " & -CInt(.AVSCrop) & vbCrLf
            Str = Str & "CropDx: " & .AVS.CropDx & vbCrLf
            Str = Str & "CropSx: " & .AVS.CropSx & vbCrLf
            Str = Str & "CropUp: " & .AVS.CropUp & vbCrLf
            Str = Str & "CropDo: " & .AVS.CropDo & vbCrLf
            Str = Str & "AVSVerticalResize: " & -CInt(.AVSVerticalResize) & vbCrLf
            Str = Str & "VResize: " & .AVS.VResize & vbCrLf
            Str = Str & "AVSDeInterlace: " & -CInt(.AVSDeInterlace) & vbCrLf
            Str = Str & "DeIntThreshold: " & .AVS.DeIntThreshold & vbCrLf
            Str = Str & "AVSTrim: " & -CInt(.AVSTrim) & vbCrLf
            Str = Str & "FrameStart: " & .AVS.FrameStart & vbCrLf
            Str = Str & "FrameEnd: " & .AVS.FrameEnd & vbCrLf
            Str = Str & "AVSTweak: " & -CInt(.AVSTweak) & vbCrLf
            Str = Str & "Hue: " & .AVS.Hue & vbCrLf
            Str = Str & "Saturation: " & .AVS.Saturation & vbCrLf
            Str = Str & "Brightness: " & .AVS.Brightness & vbCrLf
            Str = Str & "Contrast: " & .AVS.Contrast & vbCrLf
            Str = Str & "AVSSharpen: " & -CInt(.AVSSharpen) & vbCrLf
            Str = Str & "Sharpness: " & .AVS.Sharpness & vbCrLf
            Str = Str & "AVSDelayAudio: " & -CInt(.AVSDelayAudio) & vbCrLf
            Str = Str & "AudioDelay: " & .AVS.AudioDelay & vbCrLf
            Str = Str & "AVSAmplifyAudio: " & -CInt(.AVSAmplifyAudio) & vbCrLf
            Str = Str & "AudioAmplify: " & .AVS.AudioAmplify & vbCrLf
            Str = Str & "AVSFadeIO: " & -CInt(.AVSFadeIO) & vbCrLf
            Str = Str & "FadeIOFrames: " & .AVS.FadeIOFrames & vbCrLf
            Str = Str & "AVSColorMatrix: " & -CInt(.AVSColorMatrix) & vbCrLf
            Str = Str & "ColorMatrixSource: " & .AVS.ColorMatrixSource & vbCrLf
            Str = Str & "ColorMatrixDest: " & .AVS.ColorMatrixDest & vbCrLf
            Str = Str & "AVSMSharpen: " & -CInt(.AVSMSharpen) & vbCrLf
            Str = Str & "MSharpenThreshold: " & .AVS.MSharpenThreshold & vbCrLf
            Str = Str & "MSharpenStrength: " & .AVS.MSharpenStrength & vbCrLf
            Str = Str & "AVSHQDN3D: " & -CInt(.AVSHQDN3D) & vbCrLf
            Str = Str & "HQDN3DStrength: " & .AVS.HQDN3DStrength & vbCrLf
            Str = Str & "AVSDeBlock: " & -CInt(.AVSDeBlock) & vbCrLf
            Str = Str & "DeBlock: " & .AVS.DeBlock & vbCrLf
            Str = Str & vbCrLf
            Str = Str & "[Chapters]" & vbCrLf
            Str = Str & "ChaptersAutoSetup: " & -CInt(.ChaptersAutoSetup) & vbCrLf
            Str = Str & "ChaptersList: " & .ChaptersList & vbCrLf
            Str = Str & vbCrLf
        End With
        If DVDMenu.NumMenuTitles > 0 Then
            Str = Str & "[Title Menu]" & vbCrLf
            Str = Str & "ThumbLeft: " & DVDMenu.ThumbLeft(jj) & vbCrLf
            Str = Str & "ThumbTop: " & DVDMenu.ThumbTop(jj) & vbCrLf
            Str = Str & "ThumbWidth: " & DVDMenu.ThumbWidth(jj) & vbCrLf
            Str = Str & "ThumbHeight: " & DVDMenu.ThumbHeight(jj) & vbCrLf
            Str = Str & "ThumbFrameStart: " & DVDMenu.ThumbFrameStart(jj) & vbCrLf
            Str = Str & "ThumbFrameEnd: " & DVDMenu.ThumbFrameEnd(jj) & vbCrLf
            Str = Str & "ThumbLabelText: " & Replace(DVDMenu.ThumbLabelText(jj), vbCrLf, "~~") & vbCrLf
            Str = Str & "ThumbLabelFontName: " & DVDMenu.ThumbLabelFont(jj).Name & vbCrLf
            Str = Str & "ThumbLabelFontHeight: " & DVDMenu.ThumbLabelFont(jj).Height & vbCrLf
            Str = Str & "ThumbLabelFontBold: " & -CInt(DVDMenu.ThumbLabelFont(jj).Bold) & vbCrLf
            Str = Str & "ThumbLabelFontItalic: " & -CInt(DVDMenu.ThumbLabelFont(jj).Italic) & vbCrLf
            Str = Str & "ThumbLabelFontUnderline: " & -CInt(DVDMenu.ThumbLabelFont(jj).Underline) & vbCrLf
            Str = Str & "ThumbLabelFontOutline: " & -CInt(DVDMenu.ThumbLabelFont(jj).Outline) & vbCrLf
            Str = Str & "ThumbLabelFontShadow: " & -CInt(DVDMenu.ThumbLabelFont(jj).Shadow) & vbCrLf
            Str = Str & "ThumbLabelFontColor: " & DVDMenu.ThumbLabelFont(jj).Color & vbCrLf
            Str = Str & "ThumbLabelAlignment: " & DVDMenu.ThumbLabelAlignment(jj) & vbCrLf
            Str = Str & "ThumbLabelLeft: " & DVDMenu.ThumbLabelLeft(jj) & vbCrLf
            Str = Str & "ThumbLabelTop: " & DVDMenu.ThumbLabelTop(jj) & vbCrLf
            Str = Str & "ThumbLabelWidth: " & DVDMenu.ThumbLabelWidth(jj) & vbCrLf
            Str = Str & "ThumbLabelHeight: " & DVDMenu.ThumbLabelHeight(jj) & vbCrLf
            Str = Str & "ThumbAVSSCript: " & vbCrLf & DVDMenu.ThumbAVSSCript(jj) & vbCrLf
            Str = Str & "ThumbPicturePath: " & vbCrLf & DVDMenu.ThumbPicturePath(jj) & vbCrLf
            Str = Str & "~~" & vbCrLf
        End If
        Str = Str & vbCrLf & vbCrLf
    Next jj
    Do Until Right(Str, 2) <> vbCrLf
        Str = Left(Str, Len(Str) - 2)
    Loop
    Str = Str & vbCrLf & vbCrLf & _
          frmMain.StatusBar.Panels("Release").Text & " - by MrC" & vbCrLf & _
          "AVStoDVD Job <" & FileNameSave & "> created on date " & Now
    Create_Job_Save_Str = Str
    Screen.MousePointer = vbDefault
    
    Exit Function

Err_Handling:
Create_Job_Save_Str = ""
Screen.MousePointer = vbDefault

End Function


Public Sub Load_AVStoDVD_Job(StrOpen As String)

    ' Load Project Settings from <StrJob> string (I kwow, this part of the code is orrible...)
    
    Dim StrOpenTitle As String
    Dim Inizio As Integer
    Dim Fine As Integer
    Dim Flag As Boolean
    Dim jj As Integer
    Dim kk As Integer
    Dim hh As Integer
    
    On Error GoTo Err_Handling
    
    Screen.MousePointer = vbHourglass
    modMain.Reset_Project
    
    If InStr(1, StrOpen, "Project Settings") <> 0 Then
        With frmMain
            .Caption = "AVStoDVD" & IIf(modMain.Load_Str_Object(StrOpen, "Project_PathName") <> "", " - " & modMain.Load_Str_Object(StrOpen, "Project_PathName"), "")
            .Txt_Path_Output.Text = modMain.Load_Str_Object(StrOpen, "Output_Folder", frmMain.Txt_Path_Output.Text)
            .Int_EditEncoderParams.value = modMain.Load_Str_Object(StrOpen, "EditEncoderParams", 0)
            .Int_FrameServingCheck.value = modMain.Load_Str_Object(StrOpen, "FrameServingCheck", 1)
            .intDeleteAssets.value = modMain.Load_Str_Object(StrOpen, "DeleteAssets", 1)
            .intDeleteWorking.value = modMain.Load_Str_Object(StrOpen, "DeleteWorking", 1)
            .Txt_DVD_Label.Text = modMain.Load_Str_Object(StrOpen, "DVD_Label", "DVD")
            .Cmb_PostProcess.ListIndex = Int(Val(modMain.Load_Str_Object(StrOpen, "Post_Process", 0)))
            .Txt_Output_Size.Text = modMain.Load_Str_Object(StrOpen, "Output_Size", frmMain.Txt_Output_Size.Text)
            DiscSize = Int(Val(modMain.Load_Str_Object(StrOpen, "DVD_Size", DiscSize)))
            OutputSetup = Int(Val(modMain.Load_Str_Object(StrOpen, "Output_Setup", OutputSetup)))
            VideoStandard = Int(Val(modMain.Load_Str_Object(StrOpen, "Video_Standard", VideoStandard)))
        End With
    End If
    Do
        DoEvents
        jj = jj + 1
        If InStr(1, StrOpen, "Title " & jj) <> 0 Then
            StrOpenTitle = Mid(StrOpen, InStr(1, StrOpen, "Title " & jj), IIf(InStr(1, StrOpen, "Title " & jj + 1) <> 0, InStr(1, StrOpen, "Title " & jj + 1) - InStr(1, StrOpen, "Title " & jj), InStr(1, StrOpen, "AVStoDVD Release") - InStr(1, StrOpen, "Title " & jj)))
            With Title(jj)
                ' General
                .TitleName = modMain.Load_Str_Object(StrOpenTitle, "TitleName", .TitleName)
                .TimeTrimmed = modMain.Load_Str_Object(StrOpenTitle, "TimeTrimmed")
                .InputVideoPathName = modMain.Load_Str_Object(StrOpenTitle, "InputVideoPathName", .InputVideoPathName)
                For hh = 1 To MaxAudioTracks
                    .InputAudioPathName(hh) = modMain.Load_Str_Object(StrOpenTitle, "InputAudioPathName" & hh)
                Next hh
                For hh = 1 To MaxSubsTracks
                    .InputSubsPathName(hh) = modMain.Load_Str_Object(StrOpenTitle, "InputSubsPathName" & hh)
                Next hh
                ' MediaInfo
                StrOpenTitle = Mid(StrOpenTitle, InStr(1, StrOpenTitle, "[MediaInfo]"), Len(StrOpenTitle) - InStr(1, StrOpenTitle, "[MediaInfo]") + 1)
                With .InputGeneralInfo
                    .MediaInfoVersion = modMain.Load_Str_Object(StrOpenTitle, "MediaInfoVersion", .MediaInfoVersion)
                    .Format = modMain.Load_Str_Object(StrOpenTitle, "Format", .Format)
                    .AudioTracksCount = modMain.Load_Str_Object(StrOpenTitle, "AudioTracksCount", .AudioTracksCount)
                    .SubsTracksCount = modMain.Load_Str_Object(StrOpenTitle, "SubsTracksCount", .SubsTracksCount)
                    .Time = modMain.Load_Str_Object(StrOpenTitle, "Time", .Time)
                    .ChaptersList = modMain.Load_Str_Object(StrOpenTitle, "ChaptersList", .ChaptersList)
                End With
                With .InputVideoInfo
                    .Time = modMain.Load_Str_Object(StrOpenTitle, "VideoTime", .Time)
                    .Compression = modMain.Load_Str_Object(StrOpenTitle, "VideoCompression", .Compression)
                    .BitRateMode = modMain.Load_Str_Object(StrOpenTitle, "VideoBitRateMode", .BitRateMode)
                    .AvgBitRate = modMain.Load_Str_Object(StrOpenTitle, "VideoAvgBitRate", .AvgBitRate)
                    .MinBitRate = modMain.Load_Str_Object(StrOpenTitle, "VideoMinBitRate", .MinBitRate)
                    .MaxBitRate = modMain.Load_Str_Object(StrOpenTitle, "VideoMaxBitRate", .MaxBitRate)
                    .Width = modMain.Load_Str_Object(StrOpenTitle, "VideoWidth", .Width)
                    .Height = modMain.Load_Str_Object(StrOpenTitle, "VideoHeight", .Height)
                    .DAR = modMain.Load_Str_Object(StrOpenTitle, "VideoDAR", .DAR)
                    .PAR = modMain.Load_Str_Object(StrOpenTitle, "VideoPAR", .PAR)
                    .FAR = modMain.Load_Str_Object(StrOpenTitle, "VideoFAR", .FAR)
                    .FrameRateMode = modMain.Load_Str_Object(StrOpenTitle, "VideoFrameRateMode", .FrameRateMode)
                    .FPS = modMain.Load_Str_Object(StrOpenTitle, "VideoFPS", .FPS)
                    .FrameCount = modMain.Load_Str_Object(StrOpenTitle, "VideoFrameCount", .FrameCount)
                    .ScanType = modMain.Load_Str_Object(StrOpenTitle, "VideoScanType", .ScanType)
                    .ScanOrder = modMain.Load_Str_Object(StrOpenTitle, "VideoScanOrder", .ScanOrder)
                End With
                For hh = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                    With .InputAudioInfo(hh)
                        .ID = modMain.Load_Str_Object(StrOpenTitle, "AudioID(" & hh & ")")
                        .TrackID = modMain.Load_Str_Object(StrOpenTitle, "AudioTrackID(" & hh & ")")
                        .Time = modMain.Load_Str_Object(StrOpenTitle, "AudioTime(" & hh & ")")
                        .Compression = modMain.Load_Str_Object(StrOpenTitle, "AudioCompression(" & hh & ")")
                        .AvgBitRate = modMain.Load_Str_Object(StrOpenTitle, "AudioAvgBitRate(" & hh & ")")
                        .BitRateMode = modMain.Load_Str_Object(StrOpenTitle, "AudioBitRateMode(" & hh & ")")
                        .Channels = modMain.Load_Str_Object(StrOpenTitle, "AudioChannels(" & hh & ")")
                        .SampleRate = modMain.Load_Str_Object(StrOpenTitle, "AudioSampleRate(" & hh & ")")
                        .Resolution = modMain.Load_Str_Object(StrOpenTitle, "AudioResolution(" & hh & ")")
                        .Language = modMain.Load_Str_Object(StrOpenTitle, "AudioLanguage(" & hh & ")")
                        .Delay = modMain.Load_Str_Object(StrOpenTitle, "AudioDelay(" & hh & ")")
                    End With
                Next hh
                For hh = 1 To Val(.InputGeneralInfo.SubsTracksCount)
                    With .InputSubsInfo(hh)
                        .ID = modMain.Load_Str_Object(StrOpenTitle, "TextID(" & hh & ")")
                        .TrackID = modMain.Load_Str_Object(StrOpenTitle, "TextTrackID(" & hh & ")")
                        .Format = modMain.Load_Str_Object(StrOpenTitle, "TextFormat(" & hh & ")")
                        .Title = modMain.Load_Str_Object(StrOpenTitle, "TextTitle(" & hh & ")")
                        .Language = modMain.Load_Str_Object(StrOpenTitle, "TextLanguage(" & hh & ")")
                    End With
                Next hh
                ' Video
                StrOpenTitle = Mid(StrOpenTitle, InStr(1, StrOpenTitle, "[Video]"), Len(StrOpenTitle) - InStr(1, StrOpenTitle, "[Video]") + 1)
                .VideoAutoSetup = CBool(modMain.Load_Str_Object(StrOpenTitle, "VideoAutoSetup", "1"))
                .VideoIsToBeKept = CBool(modMain.Load_Str_Object(StrOpenTitle, "VideoIsToBeKept", "0"))
                .VideoProfile = modMain.Load_Str_Object(StrOpenTitle, "VideoProfile", .VideoProfile)
                With .VideoHCenc
                    .AQ = modMain.Load_Str_Object(StrOpenTitle, "VideoHCencAQ", .AQ)
                    .Lumgain = modMain.Load_Str_Object(StrOpenTitle, "VideoHCencLumgain", .Lumgain)
                    .Matrix = modMain.Load_Str_Object(StrOpenTitle, "VideoHCencMatrix", .Matrix)
                    .Profile = modMain.Load_Str_Object(StrOpenTitle, "VideoHCencProfile", .Profile)
                    .Bias = modMain.Load_Str_Object(StrOpenTitle, "VideoHCencBias", .Bias)
                    .DCPrec = modMain.Load_Str_Object(StrOpenTitle, "VideoHCencDCPrec", .DCPrec)
                    .Zone = modMain.Load_Str_Object(StrOpenTitle, "VideoHCencZone", .Zone)
                End With
                .VideoFFmpegHQ = CBool(modMain.Load_Str_Object(StrOpenTitle, "VideoFFmpegHQ", "0"))
                .VideoResolution = CInt(modMain.Load_Str_Object(StrOpenTitle, "VideoResolution", Preferences.VideoResolution))
                .VideoAspectRatio = CInt(modMain.Load_Str_Object(StrOpenTitle, "VideoAspectRatio", .VideoAspectRatio))
                .VideoDVSource = CBool(modMain.Load_Str_Object(StrOpenTitle, "VideoDVSource", "0"))
                .VideoInterlacedEncoding = CBool(modMain.Load_Str_Object(StrOpenTitle, "VideoInterlacedEncoding", "0"))
                .VideoFieldOrder = modMain.Load_Str_Object(StrOpenTitle, "VideoFieldOrder", .VideoFieldOrder)
                .VideoCloseAllGOPs = CBool(modMain.Load_Str_Object(StrOpenTitle, "VideoCloseAllGOPs", "0"))
                .VideoBitRate = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "VideoBitRate", .VideoBitRate)))
                .VideoMaxBitRate = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "VideoMaxBitRate", .VideoMaxBitRate)))
                .VideoAutoBitRate = CBool(modMain.Load_Str_Object(StrOpenTitle, "VideoAutoBitRate", "1"))
                ' Audio
                StrOpenTitle = Mid(StrOpenTitle, InStr(1, StrOpenTitle, "[Audio]"), Len(StrOpenTitle) - InStr(1, StrOpenTitle, "[Audio]") + 1)
                For kk = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                    .AudioIsToBeKept(kk) = CBool(modMain.Load_Str_Object(StrOpenTitle, "AudioIsToBeKept" & kk, "0"))
                    .AudioAutoSetup(kk) = CBool(modMain.Load_Str_Object(StrOpenTitle, "AudioAutoSetup" & kk, "1"))
                    .AudioFormat(kk) = modMain.Load_Str_Object(StrOpenTitle, "AudioFormat" & kk, Preferences.AudioFormat)
                    .AudioChannelsMode(kk) = modMain.Load_Str_Object(StrOpenTitle, "AudioChannelsMode" & kk, .AudioChannelsMode(kk))
                    .AudioLanguage(kk) = modMain.Load_Str_Object(StrOpenTitle, "AudioLanguage" & kk, IIf(kk = 1, Preferences.AudioLanguage, Preferences.AudioLanguage2))
                    .AudioBitRate(kk) = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "AudioBitRate" & kk, .AudioBitRate(kk))))
                    .AudioNormalize(kk) = CBool(modMain.Load_Str_Object(StrOpenTitle, "AudioNormalize" & kk, Preferences.AudioNormalize))
                    .AudioDelayAuto(kk) = CBool(modMain.Load_Str_Object(StrOpenTitle, "AudioDelayAuto" & kk, Preferences.AudioDelayAuto))
                    .AudioFixAC3(kk) = CBool(modMain.Load_Str_Object(StrOpenTitle, "AudioFixAC3" & kk, "1"))
                    With .AudioAften(kk)
                        .Pad = modMain.Load_Str_Object(StrOpenTitle, "AudioAftenPad" & kk, "0")
                        .DRC = modMain.Load_Str_Object(StrOpenTitle, "AudioAftenDRC" & kk, "5")
                        .BWFilter = modMain.Load_Str_Object(StrOpenTitle, "AudioAftenBWFilter" & kk, "0")
                    End With
                Next kk
                ' Subs
                StrOpenTitle = Mid(StrOpenTitle, InStr(1, StrOpenTitle, "[Subs]"), Len(StrOpenTitle) - InStr(1, StrOpenTitle, "[Subs]") + 1)
                For kk = 1 To Val(.InputGeneralInfo.SubsTracksCount)
                    .SubsAutoSetup(kk) = CBool(modMain.Load_Str_Object(StrOpenTitle, "SubsAutoSetup" & kk, "1"))
                    .SubsLanguage(kk) = modMain.Load_Str_Object(StrOpenTitle, "SubsLanguage" & kk, IIf(kk = 1, Preferences.SubsLanguage, Preferences.SubsLanguage2))
                    .SubsExtension(kk) = Int(modMain.Load_Str_Object(StrOpenTitle, "SubsExtension" & kk, "1"))
                    .SubsHardEncode(kk) = CBool(modMain.Load_Str_Object(StrOpenTitle, "SubsHardEncode" & kk, "0"))
                Next kk
                ' AVS
                StrOpenTitle = Mid(StrOpenTitle, InStr(1, StrOpenTitle, "[AVS]"), Len(StrOpenTitle) - InStr(1, StrOpenTitle, "[AVS]") + 1)
                .AVSAutoSetup = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSAutoSetup", "1"))
                If InStr(1, StrOpenTitle, "AVSAutoScript: ", vbTextCompare) <> 0 Then
                    Inizio = InStr(1, StrOpenTitle, "AVSAutoScript: ", vbTextCompare) + 15
                    Fine = InStr(Inizio, StrOpenTitle, "AVSScript: ", vbTextCompare)
                    .AVSAutoScript = Mid(StrOpenTitle, Inizio, Fine - Inizio - 1)
                    .AVSAutoScript = modStr.RemoveCharBegEnd(.AVSAutoScript, Chr(10), Chr(13))
                End If
                If InStr(1, StrOpenTitle, "AVSScript: ", vbTextCompare) <> 0 Then
                    Inizio = InStr(1, StrOpenTitle, "AVSScript: ", vbTextCompare) + 12
                    Fine = InStr(Inizio, StrOpenTitle, "AVSCrop: ", vbTextCompare)
                    .AVSScript = Mid(StrOpenTitle, Inizio, Fine - Inizio - 1)
                    .AVSScript = modStr.RemoveCharBegEnd(.AVSScript, Chr(10), Chr(13))
                End If
                .AVSCrop = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSCrop", "0"))
                .AVS.CropDx = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "CropDx")))
                .AVS.CropSx = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "CropSx")))
                .AVS.CropUp = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "CropUp")))
                .AVS.CropDo = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "CropDo")))
                .AVSVerticalResize = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSVerticalResize", "0"))
                .AVS.VResize = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "VResize")))
                .AVSDeInterlace = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSDeInterlace", "0"))
                .AVS.DeIntThreshold = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "DeIntThreshold", "10")))
                .AVSTrim = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSTrim", "0"))
                .AVS.FrameStart = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "FrameStart")))
                .AVS.FrameEnd = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "FrameEnd")))
                .AVSTweak = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSTweak", "0"))
                .AVS.Hue = Val(Replace(modMain.Load_Str_Object(StrOpenTitle, "Hue"), ",", "."))
                .AVS.Saturation = Val(Replace(modMain.Load_Str_Object(StrOpenTitle, "Saturation"), ",", "."))
                .AVS.Brightness = Val(Replace(modMain.Load_Str_Object(StrOpenTitle, "Brightness"), ",", "."))
                .AVS.Contrast = Val(Replace(modMain.Load_Str_Object(StrOpenTitle, "Contrast"), ",", "."))
                .AVSSharpen = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSSharpen", "0"))
                .AVS.Sharpness = Val(Replace(modMain.Load_Str_Object(StrOpenTitle, "Sharpness"), ",", "."))
                .AVSDelayAudio = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSDelayAudio", "0"))
                .AVS.AudioDelay = Val(Replace(modMain.Load_Str_Object(StrOpenTitle, "AudioDelay"), ",", "."))
                .AVSAmplifyAudio = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSAmplifyAudio", "0"))
                .AVS.AudioAmplify = Val(Replace(modMain.Load_Str_Object(StrOpenTitle, "AudioAmplify"), ",", "."))
                .AVSFadeIO = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSFadeIO", "0"))
                .AVS.FadeIOFrames = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "FadeIOFrames")))
                .AVSColorMatrix = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSColorMatrix", "0"))
                .AVS.ColorMatrixSource = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "ColorMatrixSource")))
                .AVS.ColorMatrixDest = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "ColorMatrixDest")))
                .AVSMSharpen = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSMSharpen", "0"))
                .AVS.MSharpenThreshold = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "MSharpenThreshold")))
                .AVS.MSharpenStrength = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "MSharpenStrength")))
                .AVSHQDN3D = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSHQDN3D", "0"))
                .AVS.HQDN3DStrength = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "HQDN3DStrength")))
                .AVSDeBlock = CBool(modMain.Load_Str_Object(StrOpenTitle, "AVSDeBlock", "0"))
                .AVS.DeBlock = Int(Val(modMain.Load_Str_Object(StrOpenTitle, "DeBlock")))
                ' Chapters
                StrOpenTitle = Mid(StrOpenTitle, InStr(1, StrOpenTitle, "[Chapters]"), Len(StrOpenTitle) - InStr(1, StrOpenTitle, "[Chapters]") + 1)
                .ChaptersAutoSetup = CBool(modMain.Load_Str_Object(StrOpenTitle, "ChaptersAutoSetup", "1"))
                .ChaptersList = modMain.Load_Str_Object(StrOpenTitle, "ChaptersList", .ChaptersList)
            End With
        Else
            Flag = True
        End If
    Loop Until Flag = True
    NumTitles = jj - 1
    modMain.Load_AVStoDVD_DVDMenu StrOpen
    CurrentTitle = NumTitles
    modMain.Change_Settings
    modMain.Define_BitRates_DVDSize
    modMain.Change_Titles
    Screen.MousePointer = vbDefault
    
    Exit Sub
    
Err_Handling:
Select Case Err.Number
Case 13   'Type mismatch
    Resume Next
Case Else
    Screen.MousePointer = vbDefault
    MsgBox "Error " & Err.Number & vbCrLf & vbCrLf & Err.Description, vbCritical, App.Title
    modMain.Save_Log_Video "Warning! Failed to load AVStoDVD Project!"
End Select

End Sub


Public Sub Load_AVStoDVD_DVDMenu(StrOpen As String)

    ' Load DVDMenu Project Settings from <StrJob> string
    
    Dim StrOpenTitle As String
    Dim StrOpenMenu As String
    Dim jj As Integer

    On Error GoTo Err_Handling

    If InStr(1, StrOpen, "[DVD Menu]") <> 0 Then
        StrOpenMenu = Mid(StrOpen, InStr(1, StrOpen, "[DVD Menu]"), InStr(1, StrOpen, "** Title 1 **") - InStr(1, StrOpen, "[DVD Menu]"))
        With DVDMenu
            ' DVD Menu General Settings
            .IsInit = CBool(modMain.Load_Str_Object(StrOpenMenu, "IsInit"))
            .IsFinal = CBool(modMain.Load_Str_Object(StrOpenMenu, "IsFinal"))
            .Style = modMain.Load_Str_Object(StrOpenMenu, "Style", .Style)
            .AR = modMain.Load_Str_Object(StrOpenMenu, "AR", .AR)
            .TitlesFormat = modMain.Load_Str_Object(StrOpenMenu, "TitlesFormat", .TitlesFormat)
            .Template = modMain.Load_Str_Object(StrOpenMenu, "Template", .Template)
            .MaxTitlesPage = modMain.Load_Str_Object(StrOpenMenu, "MaxTitlesPage", .MaxTitlesPage)
            .PlayAllButton = CBool(modMain.Load_Str_Object(StrOpenMenu, "PlayAllButton"))
            .ForcePlayAllSelection = CBool(modMain.Load_Str_Object(StrOpenMenu, "ForcePlayAllSelection", .ForcePlayAllSelection))
            .BackgroundAudio = CBool(modMain.Load_Str_Object(StrOpenMenu, "BackgroundAudio"))
            .MotionMenuDuration = modMain.Load_Str_Object(StrOpenMenu, "MotionMenuDuration", .MotionMenuDuration)
            .VideoBitRate = modMain.Load_Str_Object(StrOpenMenu, "VideoBitRate", .VideoBitRate)
            .MaxThumbsRow = modMain.Load_Str_Object(StrOpenMenu, "MaxThumbsRow", .MaxThumbsRow)
            .ThumbImageSource = modMain.Load_Str_Object(StrOpenMenu, "ThumbImageSource", .ThumbImageSource)
            .ThumbFramePos = modMain.Load_Str_Object(StrOpenMenu, "ThumbFramePos", .ThumbFramePos)
            .HLFormat = modMain.Load_Str_Object(StrOpenMenu, "HLFormat", .HLFormat)
            .HLColorsPlay = modMain.Load_Str_Object(StrOpenMenu, "HLColorsPlay", .HLColorsPlay)
            .HLColorsSel = modMain.Load_Str_Object(StrOpenMenu, "HLColorsSel", .HLColorsSel)
            .ThumbShadow = modMain.Load_Str_Object(StrOpenMenu, "ThumbShadow", .ThumbShadow)
            .PlayAllShadow = modMain.Load_Str_Object(StrOpenMenu, "PlayAllShadow", .PlayAllShadow)
            .ArrowsShadow = modMain.Load_Str_Object(StrOpenMenu, "ArrowsShadow", .ArrowsShadow)
            ' Editor settings
            .NumMenuTitles = CInt(modMain.Load_Str_Object(StrOpenMenu, "NumMenuTitles", "1"))
            .NumMenuPages = CInt(modMain.Load_Str_Object(StrOpenMenu, "NumMenuPages", "1"))
            .BackgroundPicturePath = modMain.Load_Str_Object(StrOpenMenu, "BackgroundPicturePath", .BackgroundPicturePath)
            .BackgroundVideoPath = modMain.Load_Str_Object(StrOpenMenu, "BackgroundVideoPath", .BackgroundVideoPath)
            .BackgroundAudioPath = modMain.Load_Str_Object(StrOpenMenu, "BackgroundAudioPath", .BackgroundAudioPath)
            .TitleText = Replace(modMain.Load_Str_Object(StrOpenMenu, "TitleText", .TitleText), "~~", vbCrLf)
            With .TitleFont
                .Name = modMain.Load_Str_Object(StrOpenMenu, "TitleFontName", .Name)
                .Height = modMain.Load_Str_Object(StrOpenMenu, "TitleFontHeight", "18")
                .Bold = CBool(modMain.Load_Str_Object(StrOpenMenu, "TitleFontBold"))
                .Italic = CBool(modMain.Load_Str_Object(StrOpenMenu, "TitleFontItalic"))
                .Underline = CBool(modMain.Load_Str_Object(StrOpenMenu, "TitleFontUnderline"))
                .Outline = CBool(modMain.Load_Str_Object(StrOpenMenu, "TitleFontOutline"))
                .Shadow = CBool(modMain.Load_Str_Object(StrOpenMenu, "TitleFontShadow"))
                .Color = modMain.Load_Str_Object(StrOpenMenu, "TitleFontColor", CStr(RGB(255, 255, 255)))
            End With
            .TitleAlignment = modMain.Load_Str_Object(StrOpenMenu, "TitleAlignment", vbCenter)
            .TitleLeft = modMain.Load_Str_Object(StrOpenMenu, "TitleLeft")
            .TitleTop = modMain.Load_Str_Object(StrOpenMenu, "TitleTop")
            .TitleWidth = modMain.Load_Str_Object(StrOpenMenu, "TitleWidth")
            .TitleHeight = modMain.Load_Str_Object(StrOpenMenu, "TitleHeight")
            .PlayAllButtonPicturePath = modMain.Load_Str_Object(StrOpenMenu, "PlayAllButtonPicturePath", .PlayAllButtonPicturePath)
            .PlayAllButtonLeft = modMain.Load_Str_Object(StrOpenMenu, "PlayAllButtonLeft")
            .PlayAllButtonTop = modMain.Load_Str_Object(StrOpenMenu, "PlayAllButtonTop")
            .PlayAllButtonWidth = modMain.Load_Str_Object(StrOpenMenu, "PlayAllButtonWidth")
            .PlayAllButtonHeight = modMain.Load_Str_Object(StrOpenMenu, "PlayAllButtonHeight")
            .ArrowLButtonPicturePath = modMain.Load_Str_Object(StrOpenMenu, "ArrowLButtonPicturePath", .ArrowLButtonPicturePath)
            .ArrowLButtonLeft = modMain.Load_Str_Object(StrOpenMenu, "ArrowLButtonLeft")
            .ArrowLButtonTop = modMain.Load_Str_Object(StrOpenMenu, "ArrowLButtonTop")
            .ArrowLButtonWidth = modMain.Load_Str_Object(StrOpenMenu, "ArrowLButtonWidth")
            .ArrowLButtonHeight = modMain.Load_Str_Object(StrOpenMenu, "ArrowLButtonHeight")
            .ArrowRButtonPicturePath = modMain.Load_Str_Object(StrOpenMenu, "ArrowRButtonPicturePath", .ArrowRButtonPicturePath)
            .ArrowRButtonLeft = modMain.Load_Str_Object(StrOpenMenu, "ArrowRButtonLeft")
            .ArrowRButtonTop = modMain.Load_Str_Object(StrOpenMenu, "ArrowRButtonTop")
            .ArrowRButtonWidth = modMain.Load_Str_Object(StrOpenMenu, "ArrowRButtonWidth")
            .ArrowRButtonHeight = modMain.Load_Str_Object(StrOpenMenu, "ArrowRButtonHeight")
        End With
    End If
    For jj = 1 To NumTitles
        If InStr(1, StrOpen, "Title " & jj) <> 0 Then
            StrOpenTitle = Mid(StrOpen, InStr(1, StrOpen, "Title " & jj), IIf(InStr(1, StrOpen, "Title " & jj + 1) <> 0, InStr(1, StrOpen, "Title " & jj + 1) - InStr(1, StrOpen, "Title " & jj), InStr(1, StrOpen, "AVStoDVD Release") - InStr(1, StrOpen, "Title " & jj)))
            ' DVD Menu Titles Settings
            If InStr(1, StrOpenTitle, "[Title Menu]") <> 0 Then
                With DVDMenu
                    .ThumbLeft(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbLeft")
                    .ThumbTop(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbTop")
                    .ThumbWidth(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbWidth")
                    .ThumbHeight(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbHeight")
                    .ThumbFrameStart(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbFrameStart")
                    .ThumbFrameEnd(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbFrameEnd")
                    .ThumbLabelText(jj) = Replace(modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelText"), "~~", vbCrLf)
                    With .ThumbLabelFont(jj)
                        .Name = modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelFontName", "Tahoma")
                        .Height = modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelFontHeight", "9")
                        .Bold = CBool(modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelFontBold"))
                        .Italic = CBool(modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelFontItalic"))
                        .Underline = CBool(modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelFontUnderline"))
                        .Outline = CBool(modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelFontOutline"))
                        .Shadow = CBool(modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelFontShadow"))
                        .Color = modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelFontColor", CStr(RGB(255, 255, 255)))
                    End With
                    .ThumbLabelAlignment(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelAlignment", vbCenter)
                    .ThumbLabelLeft(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelLeft")
                    .ThumbLabelTop(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelTop")
                    .ThumbLabelWidth(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelWidth")
                    .ThumbLabelHeight(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbLabelHeight")
                    .ThumbAVSSCript(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbAVSSCript")
                    .ThumbPicturePath(jj) = modMain.Load_Str_Object(StrOpenTitle, "ThumbPicturePath", , ": " & vbCrLf, "~~")
                End With
            End If
        End If
    Next jj

    Exit Sub
    
Err_Handling:
Select Case Err.Number
Case 13   'Type mismatch
    Resume Next
Case Else
    MsgBox "Error " & Err.Number & vbCrLf & vbCrLf & Err.Description, vbCritical, App.Title
    modMain.Save_Log_Video "Warning! Failed to load AVStoDVD Project!"
End Select

End Sub


Public Function Load_Str_Object(Str As String, Object As String, Optional ByVal Default As String = "", Optional ByVal Separator As String = ": ", Optional ByVal EndString As String = vbCrLf) As String

    ' Get string object (Object) from string (Str). If no Object is found, Default is returned
    
    Dim Inizio As Integer
    Dim Fine As Integer

    On Error GoTo Err_Handling
        
    If InStr(1, Str, Object & Separator, vbTextCompare) <> 0 Then
        Inizio = InStr(1, Str, Object & Separator, vbTextCompare) + Len(Object) + Len(Separator)
        Fine = InStr(Inizio, Str, EndString, vbTextCompare)
        Load_Str_Object = Mid(Str, Inizio, Fine - Inizio)
        Load_Str_Object = modStr.RemoveCharBegEnd(Load_Str_Object, Chr(10), Chr(13))
    End If
    If Load_Str_Object = "" Then
        Load_Str_Object = Default
    End If
    
    Exit Function

Err_Handling:
Load_Str_Object = Default

End Function


Public Sub Load_Preview_Clip(Title As TitleSettings, OwnerForm As Form, Optional AudioNum As Integer = 1, Optional AVSScript As String)

    Dim NumFile As Integer
    Dim StrAdd As String
    Dim StrAVS As String
    Dim VideoStandardStr As String
    Dim MBR As VbMsgBoxResult
    
    On Error GoTo Err_Handling
    
    VideoStandardStr = "pal_video"
    If VideoStandard = NTSC Then
        VideoStandardStr = "ntsc_video"
    End If
    With Title
        If AVSScript <> "" Then
            StrAVS = AVSScript
        Else
            If AudioNum = 1 Then
                StrAVS = .AVSScript
            Else
                StrAVS = modAVS.Create_AVSScript(Title, AudioNum)
            End If
        End If
        If InStr(1, StrAVS, ".Normalize()") <> 0 Then
            MBR = MsgBox("Warning! A <.Normalize()> function has been found in your AVS script." & vbCrLf & vbCrLf & "Do you want to remove it (speed up preview opening)?", vbQuestion + vbYesNoCancel, App.Title)
            Select Case MBR
            Case vbYes
                StrAVS = modStr.RemoveStr(StrAVS, ".Normalize()")
            Case vbCancel
                Exit Sub
            End Select
        End If
        If .VideoAspectRatio = Widescreen Then
            StrAdd = StrAdd & "Lanczos4Resize(720,406)"
        Else
            StrAdd = StrAdd & "Lanczos4Resize(720,540)"
        End If
        StrAVS = StrAVS & IIf(InStr(1, StrAVS, "Return Video") <> 0, ".", vbCrLf) & StrAdd
        NumFile = FreeFile
        Open Preferences.TempPath & "\AviSynthP.avs" For Output As #NumFile
            Print #NumFile, StrAVS
        Close #NumFile
        If FileLen(Preferences.TempPath & "\AviSynthP.avs") > 0 Then
            If Preferences.PreviewerPathName <> "" Then
                modShellEx.Execute Preferences.PreviewerPathName, """" & Preferences.TempPath & "\AviSynthP.avs""", SW_DEFAULT, True
            Else
                Load frmPreview
                frmPreview.Caption = frmPreview.Caption & " [" & Preferences.TempPath & "\AviSynthP.avs" & "]"
                frmPreview.Show 1, OwnerForm
            End If
        End If
    End With
    modFS.DeleteIfExist Preferences.TempPath & "\AviSynthP.avs"

    Exit Sub
    
Err_Handling:
Select Case Err.Number
Case 9999
    Resume
Case Else
    MsgBox "Error " & Err.Number & vbCrLf & vbCrLf & Err.Description, vbCritical, App.Title
    modMain.Save_Log_Video "Warning! Problems encountered in previewing Title " & CurrentTitle & "."
End Select

End Sub


Public Sub Check_Software(Optional LoadedForm As String)

    Dim jj As Integer
    Dim Str As String
    Dim StrA As String
    Dim StrB As String
    Dim Programs_Paths As Variant
    Dim Programs_Names As Variant
    Dim MediaInfo_Sys_Ver As String
    Dim MediaInfo_Lib_Ver As String
    
    On Error GoTo Err_Handling
        
    Programs_Paths = Array(App.Path & "\ac3fix\ac3fix.exe", _
                           App.Path & "\Aften\aften.exe", _
                           App.Path & "\DGIndex\DGIndex.exe", _
                           App.Path & "\DGPulldown\DGPulldown.exe", _
                           App.Path & "\FFmpeg\ffmpeg.exe", _
                           App.Path & "\GraphStudio\GraphStudio0320.exe", _
                           App.Path & "\HCenc\HCenc.exe", _
                           App.Path & "\ImagoMPEG-Muxer\ImagoMPEG-Muxer.exe", _
                           App.Path & "\MKVToolNix\mkvextract.exe", _
                           App.Path & "\MuxMan\BatchMux.exe", _
                           App.Path & "\MuxMan\MuxMan.exe", _
                           App.Path & "\ReJig\ReJig.exe", _
                           App.Path & "\SubtitleCreator\SubtitleCreator.exe", _
                           App.Path & "\Wavi\wavi.exe", _
                           App.Path & "\VobSub\VSConv.exe", _
                           App.Path & "\VobSub\VobSub.dll", _
                           App.Path & "\VobSub\VSFilter.dll", _
                           App.Path & "\Lib\MediaInfo.dll", _
                           App.Path & "\Lib\AuthDVD.dll", _
                           App.Path & "\Lib\ffms2.dll", _
                           App.Path & "\Lib\GetSystemEnv.dll", _
                           SysInfo.PathSystem & "\quartz.dll", _
                           SysInfo.PathSystem & "\mscomctl.ocx")
    Programs_Names = Array("AC3Fix", _
                           "Aften", _
                           "DGIndex", _
                           "DGPulldown", _
                           "FFmpeg", _
                           "GraphStudio", _
                           "HCenc", _
                           "ImagoMPEG-Muxer", _
                           "MKVextract", _
                           "BatchMux", _
                           "MuxMan", _
                           "ReJig", _
                           "SubtitleCreator", _
                           "Wavi", _
                           "VSConv", _
                           "VobSub Lib", _
                           "VobSub Plugin", _
                           "MediaInfo Lib", _
                           "DVD Parsing Lib", _
                           "FFMS2 Plugin", _
                           "GetSystemEnv Plugin", _
                           "DirectShow Lib", _
                           "VB6 Common Controls")
        
    ' Check if MediaInfo.dll is located in Windows\System32
    If Dir(SysInfo.PathSystem & "\MediaInfo.dll") <> "" Then
        MediaInfo_Lib_Ver = modFileVersion.GetFileVersion(App.Path & "\Lib\MediaInfo.dll")
        MediaInfo_Sys_Ver = modFileVersion.GetFileVersion(SysInfo.PathSystem & "\MediaInfo.dll")
        If Val(Replace(MediaInfo_Lib_Ver, ".", "")) > Val(Replace(MediaInfo_Sys_Ver, ".", "")) Then
            If MsgBox("An older release (" & MediaInfo_Sys_Ver & ") of MediaInfo has been found in your system." & vbCrLf & vbCrLf & _
                      "Since " & frmMain.StatusBar.Panels("Release").Text & " requires release " & MediaInfo_Lib_Ver & " or higher, do you want to update it?", vbYesNo + vbQuestion, App.Title) = vbYes Then
                FileCopy App.Path & "\Lib\MediaInfo.dll", SysInfo.PathSystem & "\MediaInfo.dll"
            End If
        End If
    End If
    
    ' Check programs paths
    If LoadedForm = "frmPreferences" Then
        With frmPreferences
            StrA = "AviSynth"
            If InStr(1, modReg.EmiLeggiChiaveStringa("HKEY_LOCAL_MACHINE\SOFTWARE\AviSynth", ""), "AviSynth") = 0 Then
                StrB = "WARNING! " & StrA & " NOT found!"
            Else
                Str = modFileVersion.GetFileVersion(SysInfo.PathSystem & "\avisynth.dll", , True)
                If Val(Replace(Str, ".", "")) < 257 Then
                    StrB = "WARNING! AviSynth release 2.5.7 or higher is required!"
                Else
                    StrA = StrA & " " & Str
                    StrB = modReg.EmiLeggiChiaveStringa("HKEY_LOCAL_MACHINE\SOFTWARE\AviSynth", "")
                End If
            End If
            .Lst_SysInfo.AddItem StrA & String(19 - Len(StrA), " ") & ": " & StrB
            StrA = "ffdshow"
            If ffdshow.PathName = "" Then
                ' No warning: ffdshow is not mandatory
            Else
                StrA = StrA & " " & modFileVersion.GetFileVersion(ffdshow.PathName, , True)
                StrB = ffdshow.PathName
                .Lst_SysInfo.AddItem StrA & String(19 - Len(StrA), " ") & ": " & StrB
            End If
            StrA = "ImgBurn"
            If ImgBurnPathName = "" Then
                ' No warning: ImgBurn is not mandatory
            Else
                StrA = StrA & " " & modFileVersion.GetFileVersion(ImgBurnPathName, , True)
                StrB = ImgBurnPathName
            End If
            .Lst_SysInfo.AddItem StrA & String(19 - Len(StrA), " ") & ": " & StrB
            For jj = LBound(Programs_Paths) To UBound(Programs_Paths)
                If EsisteFile(CStr(Programs_Paths(jj)), False, vbHidden + vbReadOnly + vbSystem) = True Then
                    .Lst_SysInfo.AddItem Programs_Names(jj) & String(19 - Len(Programs_Names(jj)), " ") & ": " & Programs_Paths(jj)
                Else
                    .Lst_SysInfo.AddItem Programs_Names(jj) & String(19 - Len(Programs_Names(jj)), " ") & ": WARNING! " & Programs_Names(jj) & " NOT found!"
                End If
            Next jj
        End With
    ElseIf LoadedForm = "frmSplash" Then
        With frmSplash
            '.Lbl_Check.Caption = "Checking AviSynth..."
            'If InStr(1, modReg.EmiLeggiChiaveStringa("HKEY_LOCAL_MACHINE\SOFTWARE\AviSynth", ""), "AviSynth") <> 0 Then
            '    .Lbl_Check.Caption = "AviSynth found"
            'Else
            '    MsgBox "Warning! AviSynth NOT found!" & vbCrLf & vbCrLf & "Most of encoding routines will not be available!", vbCritical, App.Title
            'End If
            '.Lbl_Check.Caption = "Checking ImgBurn..."
            'If ImgBurnPathName <> "" Then
            '    .Lbl_Check.Caption = "ImgBurn found"
            'Else
            '    MsgBox "Warning! ImgBurn NOT found!" & vbCrLf & vbCrLf & "ISO building and DVD burning are disabled!", vbCritical, App.Title
            'End If
            For jj = LBound(Programs_Paths) To UBound(Programs_Paths)
                .Lbl_Check.Caption = "Checking " & Programs_Names(jj) & "..."
                If EsisteFile(CStr(Programs_Paths(jj)), False, vbHidden + vbReadOnly + vbSystem) = True Then
                    .Lbl_Check.Caption = Programs_Names(jj) & "found"
                Else
                    MsgBox "Warning! " & Programs_Names(jj) & " not found!", vbCritical, App.Title
                End If
            Next jj
            .Lbl_Check.Caption = "Check completed."
        End With
    End If
    
    Exit Sub
    
Err_Handling:
MsgBox "Error " & Err.Number & vbCrLf & vbCrLf & Err.Description, vbCritical, App.Title
Select Case Err.Number
Case 70
    Resume Next
End Select

End Sub


Public Function AviSynth_FrameServing_Check(AVSScript As String, Optional MessageStr As String, Optional DeleteTempFiles As Boolean = True, Optional TrialsNum As Integer = 3) As Boolean

    Dim Str As String
    Dim NumFile As Integer
    Dim CL_Params As String
    Dim AVIInfo As New clsMediaInfo
    Dim jj As Integer
    Dim TimeStart As Single
    Dim TimeOut As Single
    Dim AppPathName As String
    
    On Error GoTo Err_Handling
    
    Screen.MousePointer = vbHourglass
    
    If MessageStr = "" Then MessageStr = "Check in progress"
    TimeOut = 5 * 60  '5 min
    AppPathName = App.Path & "\FFmpeg\ffmpeg.exe"
    Str = modStr.RemoveStr(AVSScript, ".Normalize()")
    Str = Str & IIf(InStr(1, Str, "Return Video") <> 0, ".", vbCrLf) & "Trim(0,1)"
    NumFile = FreeFile
    Open Preferences.TempPath & "\AviSynthV.avs" For Output As #NumFile
        Print #NumFile, Str
    Close #NumFile
    
    Do
        AviSynth_FrameServing_Check = False
        jj = jj + 1
        TimeStart = Timer
        Load frmMessage
        With frmMessage
            .DisableClose = True
            .Caption = "AVStoDVD - FrameServing Check"
            .Lbl_Message.Caption = MessageStr & " (Trial " & jj & "/" & TrialsNum & ")" & vbCrLf & vbCrLf & "Please wait ..."
            .ProgressBar.Visible = False
            .Show 0, frmMain
            CL_Params = "-i " & """" & Preferences.TempPath & "\AviSynthV.avs""" & " -y -an -r 25 -b 200000 -s qvga """ & Preferences.TempPath & "\AviSynthV.avi"""
            modShellEx.Execute AppPathName, CL_Params, SW_HIDE, False
            Do
                DoEvents
                modUtil.Sleep 500
            Loop Until modUtil.FindRunningProcess(AppPathName) = 0 Or Timer - TimeStart > TimeOut
            'DoEvents
            modUtil.Sleep 1000
            Str = MessageStr & " (Trial " & jj & "/" & TrialsNum & ")" & vbCrLf & vbCrLf & "Failed!"
            If Timer - TimeStart > TimeOut Then
                modUtil.KillRunningProcess AppPathName
                Str = Str & " TimeOut reached!"
            Else
                If AVIInfo.ReadMediaInfo(Preferences.TempPath & "\AviSynthV.avi", , False, True, False, False) = True Then
                    If Val(AVIInfo.VideoFrameCount) = 2 Then
                        AviSynth_FrameServing_Check = True
                        Str = vbCrLf & "Check completed successfully!"
                    End If
                End If
                Set AVIInfo = Nothing
            End If
            .Lbl_Message.Caption = Str
            DoEvents
            modUtil.Sleep 1000
        End With
        Unload frmMessage
        modFS.DeleteIfExist Preferences.TempPath & "\AviSynthV.avi"
        modFS.DeleteIfExist Preferences.TempPath & "\A2DVideoInfo.cache"
        modFS.DeleteIfExist Preferences.TempPath & "\A2DAudioInfo.cache"
        modUtil.KillRunningProcess AppPathName
    Loop Until jj = TrialsNum Or AviSynth_FrameServing_Check = True
    
    If DeleteTempFiles = True Then
        modFS.DeleteIfExist Preferences.TempPath & "\AviSynthV.avs"
    End If
    
    Screen.MousePointer = Default

    Exit Function
    
Err_Handling:
If modUtil.FormIsLoad("frmMessage") = True Then Unload frmMessage
modUtil.KillRunningProcess AppPathName
AviSynth_FrameServing_Check = False
Screen.MousePointer = Default

End Function


Public Function Build_SC_Profile_xml(ProfilesPathName As String, SubsFont As MyFont, SubsPos As SubPosOptions) As Boolean

    Dim FontStr As String
    Dim Str As String
    
    On Error GoTo Err_Handling
    
    ' Build string
    With SubsFont
        FontStr = "<Font Name=""" & .Name & """ Size=""" & .Height & """ Style="""
        If .Italic = True Then
            If .Bold = True Then
                FontStr = FontStr & "Bold, Italic"
            Else
                FontStr = FontStr & "Italic"
            End If
        Else
            If .Bold = True Then
                FontStr = FontStr & "Bold"
            Else
                FontStr = FontStr & "Regular"
            End If
        End If
        FontStr = FontStr & """ Outline=""5"" />"
    End With
    With SubsPos
        Str = "<?xml version=""1.0"" encoding=""utf-16""?>" & vbCrLf & vbCrLf & _
              "<Profiles>" & vbCrLf & _
              "<Profile Name=""AVStoDVD PAL 4:3"">" & vbCrLf & _
              FontStr & vbCrLf & _
              "<Window DistanceToLeftBorder=""" & .Left & """ DistanceToTopBorder=""" & 576 - Int(576 / 540 * .Bottom) & """ Width=""" & .Width & """ />" & vbCrLf & _
              "<Stretch Horizontal=""100"" Vertical=""100"" />" & vbCrLf & _
              "<LineHeight Value=""100"" />" & vbCrLf & _
              "<Formatting Lines=""2"" Wrap=""True"" VerticalAlignment=""3"" VerticalFont=""False"" />" & vbCrLf & _
              "</Profile>" & vbCrLf & _
              "<Profile Name=""AVStoDVD PAL 16:9"">" & vbCrLf & _
              FontStr & vbCrLf & _
              "<Window DistanceToLeftBorder=""" & .Left & """ DistanceToTopBorder=""" & 576 - Int(576 / 540 * .Bottom) & """ Width=""" & .Width & """ />" & vbCrLf & _
              "<Stretch Horizontal=""100"" Vertical=""120"" />" & vbCrLf & _
              "<LineHeight Value=""100"" />" & vbCrLf & _
              "<Formatting Lines=""3"" Wrap=""True"" VerticalAlignment=""3"" VerticalFont=""False"" />" & vbCrLf & _
              "</Profile>" & vbCrLf
        Str = Str & _
              "<Profile Name=""AVStoDVD NTSC 4:3"">" & vbCrLf & _
              FontStr & vbCrLf & _
              "<Window DistanceToLeftBorder=""" & .Left & """ DistanceToTopBorder=""" & 480 - Int(480 / 540 * .Bottom) & """ Width=""" & .Width & """ />" & vbCrLf & _
              "<Stretch Horizontal=""100"" Vertical=""90"" />" & vbCrLf & _
              "<LineHeight Value=""100"" />" & vbCrLf & _
              "<Formatting Lines=""2"" Wrap=""True"" VerticalAlignment=""3"" VerticalFont=""False"" />" & vbCrLf & _
              "</Profile>" & vbCrLf & _
              "<Profile Name=""AVStoDVD NTSC 16:9"">" & vbCrLf & _
              FontStr & vbCrLf & _
              "<Window DistanceToLeftBorder=""" & .Left & """ DistanceToTopBorder=""" & 480 - Int(480 / 540 * .Bottom) & """ Width=""" & .Width & """ />" & vbCrLf & _
              "<Stretch Horizontal=""100"" Vertical=""110"" />" & vbCrLf & _
              "<LineHeight Value=""100"" />" & vbCrLf & _
              "<Formatting Lines=""3"" Wrap=""True"" VerticalAlignment=""3"" VerticalFont=""False"" />" & vbCrLf & _
              "</Profile>" & vbCrLf & _
              "</Profiles>"
    End With
    
    ' Save xml file
    Call modStr.sANSItoUTF8File(Str, ProfilesPathName)
    
    Build_SC_Profile_xml = modFS.EsisteFile(ProfilesPathName)

    Exit Function
    
Err_Handling:
Build_SC_Profile_xml = False

End Function


Public Function Load_Language(Optional sLanguage As String = "English") As Collection

    Dim LangPathname As String
    Dim NumFile As Integer
    Dim sLine As String
    Dim vLine
    
    On Error GoTo Err_Handling
    
    LangPathname = App.Path & "\Lang\" & sLanguage & ".lang.ini"
    If modFS.EsisteFile(LangPathname) = False Then
        GoTo Err_Handling
    Else
        Set Load_Language = New Collection
        NumFile = FreeFile
        Open App.Path & "\Lang\" & sLanguage & ".lang.ini" For Input As #NumFile
            Do Until EOF(NumFile) = True
                Line Input #NumFile, sLine
                If sLine <> "" Then
                    If Len(sLine) > 8 Then
                        vLine = Split(sLine, Chr(9))
                        If IsNumeric(vLine(0)) = True Then
                            Load_Language.add modStr.RemoveCharBegEnd(CStr(vLine(1)), " "), vLine(0)
                        End If
                    End If
                End If
            Loop
        Close #NumFile
    End If
    
    Exit Function
    
Err_Handling:
MsgBox "Warning!" & vbCrLf & vbCrLf & "Cannot load '" & sLanguage & "' language." & vbCrLf & vbCrLf & _
       "Check pathname '" & LangPathname & "'.", vbCritical, App.Title
    
End Function

Public Function CQ_Factor_HCenc(AVS_PathName As String, Encoder_PathName As String, Target_FileSize_MB As String, Optional Start_CQ As String, Optional Perc_Analysis As String, Optional Num_Segments As Integer, Optional TempPath As String, Optional MaxBitRate As String, Optional WideScreen_Flag As Boolean, Optional Interlaced_Flag As Boolean, Optional DC_Prec As String, Optional Close_GOP As Boolean, Optional Matrix As String, Optional MaxTrials As Integer, Optional DeleteTemp As Boolean) As String
 
    Dim AVS_Script_Prediction As String
    Dim NumFile As Integer
    Dim CL_Params As String
    Dim HCenc_ini As String
    Dim Result_FileSize_MB As Single
    Dim Corr_CQ As Single
    Dim CQ As Single
    Dim Trials As Integer
    Dim Error As Single
    Dim Flag As Boolean
    
    On Error GoTo Err_Handling
    
    If Start_CQ = "" Then
        CQ = 2.5
    Else
        CQ = Val(Start_CQ)
    End If
    If Perc_Analysis = "" Then Perc_Analysis = "0.05"
    If Num_Segments = 0 Then Num_Segments = 5
    If TempPath = "" Then TempPath = Environ("TEMP")
    If MaxBitRate = "" Then MaxBitRate = "9000"
    If DC_Prec = "" Then DC_Prec = "8"
    If Matrix = "" Then Matrix = "MPEG"
    If MaxTrials = 0 Then MaxTrials = 5
    AVS_Script_Prediction = "AudioVideo = Import(""" & AVS_PathName & """)" & vbCrLf & _
                            "AudioVideoTrim = Trim(AudioVideo, Int(0.00*AudioVideo.FrameCount), Int(1.00*AudioVideo.FrameCount))" & vbCrLf & _
                            "VideoPrediction = SelectRangeEvery(AudioVideoTrim, Int(AudioVideoTrim.FrameCount/" & Num_Segments & "), Int(" & Perc_Analysis & "*AudioVideoTrim.FrameCount/" & Num_Segments & "), audio=false)" & vbCrLf & _
                            "Return VideoPrediction"
    NumFile = FreeFile
    Open TempPath & "\AviSynthCQP.avs" For Output As #NumFile
        Print #NumFile, AVS_Script_Prediction
    Close #NumFile
    
    Do
        HCenc_ini = "*INFILE " & TempPath & "\AviSynthCQP.avs" & vbCrLf & _
                    "*OUTFILE " & TempPath & "\VideoCQP.m2v" & vbCrLf & _
                    "*CQ_MAXBITRATE " & Replace(CStr(CQ), ",", ".") & vbCrLf & _
                    "*MAXBITRATE " & MaxBitRate & vbCrLf & _
                    "*ASPECT " & IIf(WideScreen_Flag = True, "16:9 ", "4:3 ") & vbCrLf & _
                    IIf(Interlaced_Flag = True, "*INTERLACED", "*PROGRESSIVE") & vbCrLf & _
                    "*DC_PREC " & DC_Prec & vbCrLf & _
                    IIf(Close_GOP = True, "*CLOSEDGOPS" & vbCrLf, "") & _
                    "*MATRIX " & Matrix & vbCrLf & _
                    "*SMP" & vbCrLf
        Select Case Preferences.EncodingPriority
        Case 0
            HCenc_ini = HCenc_ini & _
                    "*PRIORITY IDLE" & vbCrLf
        Case 1
            HCenc_ini = HCenc_ini & _
                    "*PRIORITY LOW" & vbCrLf
        Case 2, 3
            HCenc_ini = HCenc_ini & _
                    "*PRIORITY NORMAL" & vbCrLf
        Case 4, 5
            HCenc_ini = HCenc_ini & _
                    "*PRIORITY HIGH" & vbCrLf
        End Select
        HCenc_ini = HCenc_ini & _
                    "*WAIT 2"
        NumFile = FreeFile
        Open TempPath & "\HCencCQP.ini" For Output As #NumFile
        Print #NumFile, HCenc_ini
        Close #NumFile
        CL_Params = "-ini """ & TempPath & "\HCencCQP.ini"""
        modShellEx.Execute Encoder_PathName, CL_Params, SW_DEFAULT, True
        Result_FileSize_MB = Round(Val(modUtil.GetFileSize(TempPath & "\VideoCQP.m2v")) / 1024 / 1024 / Val(Perc_Analysis), 1)
        Corr_CQ = ((CQ / Val(Target_FileSize_MB) * Result_FileSize_MB) - CQ)
        Trials = Trials + 1
        CQ = CQ + Corr_CQ
        Error = (Result_FileSize_MB - Val(Target_FileSize_MB)) / Val(Target_FileSize_MB)
        If DeleteTemp = False Then
            NumFile = FreeFile
            Open TempPath & "\AVStoDVD_CQP_Debug.log" For Append As #NumFile
                Print #NumFile, Now() & ": Trial " & Trials & vbCrLf & _
                                Now() & ": CQ " & Round(CQ - Corr_CQ, 3) & vbCrLf & _
                                Now() & ": Target FileSize " & Val(Target_FileSize_MB) & " MB" & vbCrLf & _
                                Now() & ": Extimated FileSize " & Result_FileSize_MB & " MB" & vbCrLf & _
                                Now() & ": Error " & Format(Error, "0.00%") & vbCrLf
            Close #NumFile
        End If
        If Error < 0.01 And Error > -0.05 Then
            Flag = True
        ElseIf Trials >= MaxTrials Then
            Flag = True
        ElseIf CQ < 1 Then
            Flag = True
        End If
    Loop Until Flag = True
    
    CQ_Factor_HCenc = Replace(CStr(Round(CQ - Corr_CQ, 3)), ",", ".")
    
Err_Handling:
If CQ < 1 Then CQ_Factor_HCenc = 1
If DeleteTemp = True Then
    modFS.DeleteIfExist TempPath & "\HCencCQP.ini"
    modFS.DeleteIfExist TempPath & "\VideoCQP.m2v"
    modFS.DeleteIfExist TempPath & "\AviSynthCQP.m2v"
Else
    NumFile = FreeFile
    Open TempPath & "\AVStoDVD_CQP_Debug.log" For Append As #NumFile
        Print #NumFile, Now() & ": CQ Factor " & CQ_Factor_HCenc & vbCrLf & _
                        Now() & ": End of CQ Prediction routine" & vbCrLf & vbCrLf & _
                        String(10, "-") & vbCrLf & vbCrLf
    Close #NumFile
End If
 
End Function

