Attribute VB_Name = "modStart"
' -------------------------------------------------------------------------------
'
'   AVStoDVD - by MrC
'   File: modStart.bas
'   Purpose: Encoding section
'
' -------------------------------------------------------------------------------


Option Explicit
Option Compare Binary
Option Base 0


Private Enum ButType
    Thumbnail
    Label
    ArrowL
    ArrowR
    PlayAll
End Enum


Public Sub Start()

    ' This is the very core of AVStoDVD
    
    Dim FPS As Single
    Dim FPS_AVS As Single
    Dim NumFile As Integer
    Dim Str_Settings As String
    Dim sLog As String
    Dim Str As String
    Dim VideoEncoderPath As String
    Dim OutputPath As String
    Dim AssetsPath As String
    Dim TempPath As String
    Dim DC_Precision As String
    Dim Bias As String
    Dim Zone
    Dim CL_Params As String
    Dim CL_Params2 As String
    Dim AVSPathName(1 To MaxTitles, 1 To MaxAudioTracks) As String
    Dim AVSScript(1 To MaxTitles, 1 To MaxAudioTracks) As String
    Dim VideoPathName(1 To MaxTitles) As String
    Dim AudioExt(1 To MaxTitles, 1 To MaxAudioTracks) As String
    Dim AudioPathName(1 To MaxTitles, 1 To MaxAudioTracks) As String
    Dim SubsExt(1 To MaxTitles, 1 To MaxSubsTracks) As String
    Dim SubsPathName(1 To MaxTitles, 1 To MaxSubsTracks) As String
    Dim InputSubsPathName As String
    Dim AudioEncoder As AC3AudioEncoderType
    Dim HCenc_ini As String
    Dim Target_Video_FileSize(1 To MaxTitles) As Single
    Dim Output_Video_FileSize(1 To MaxTitles) As Single
    Dim Output_Audio_FileSize(1 To MaxTitles) As Single
    Dim Output_Subs_FileSize(1 To MaxTitles) As Single
    Dim Output_Assets_FileSize As Single
    Dim Output_DVD_FileSize As Single
    Dim BatchMux_ini As String
    Dim BatchMux_hcn As String
    Dim DVD_Label As String
    Dim DVDName As String
    Dim TitleName(1 To MaxTitles) As String
    Dim Tj As Integer
    Dim jj As Integer
    Dim kk As Integer
    Dim MInfo As New clsMediaInfo
    Dim OutputVideoInfo As New clsTitleVideoInfo
    Dim OutputAudioInfo As New clsTitleAudioInfo
    Dim Segment As String
    Dim Flag As Boolean
    Dim Flag_End As Boolean
    Dim Flag_Retry As Boolean
    Dim Flag_DeleteAssets As Boolean
    Dim Flag_Menu As Boolean
    Dim Flag_Exec As Boolean
    Dim MBR As VbMsgBoxResult
    Dim Err_Message As String
    Dim Buttons_mnu As String
    Dim Buttons_Pos(1 To MaxTitles) As ButPos
    Dim Buttons_Adj(1 To MaxTitles) As ButAdj
    Dim Buttons_Type(1 To MaxTitles) As ButType
    Dim Button_Pos_Y As Long
    Dim Button_Pos_H As Long
    Dim Chapters_List_Array() As String
    Dim Chapters_List As String
    Dim MenuVertRes As Integer
    Dim NumButtons(1 To 16) As Integer
    Dim JumpTitle As Integer
    Dim JumpPGC As Integer
    'Dim CQP As Object          -> using CQP_HCenc.dll
    Dim OperationSection As String
    Dim VideoFrameCount As Long
        
    On Error GoTo Err_Handling
    
    ' Initialize variables
    OperationSection = "Initialize variables"
    If VideoStandard = PAL Then
        FPS = 25
    Else
        FPS = 2997 / 100
    End If
    TempPath = Preferences.TempPath
    OutputPath = frmMain.Txt_Path_Output.Text
    AssetsPath = Preferences.AssetsPath
    If OutputSetup = MPEG2_Streams Then
        AssetsPath = OutputPath
    End If
    
    
    ' Verify working folders existence
    OperationSection = "Verify working folders existence"
    If OutputPath = "" Then
        MsgBox "Cannot find 'DVD Output folder'." & vbCrLf & vbCrLf & "Please select a valid 'DVD Output folder' before to start the Job.", vbExclamation, App.Path
        Exit Sub
    ElseIf modFS.CreateDir(OutputPath) = False Then
        MsgBox "Cannot create 'DVD Output folder'." & vbCrLf & vbCrLf & "Please check 'Preferences'/'DVD Output folder' path.", vbExclamation, App.Path
        Exit Sub
    End If
    If AssetsPath = "" Then
        AssetsPath = SysInfo.SpecialPath(CSIDL_USER_VIDEOS)
    ElseIf modFS.CreateDir(AssetsPath) = False Then
        MsgBox "Cannot create 'DVD Assets folder'." & vbCrLf & vbCrLf & "Please check 'Preferences'/'DVD Assets folder' path.", vbExclamation, App.Path
        Exit Sub
    End If
    If TempPath = "" Then
        TempPath = Environ("TEMP")
    ElseIf modFS.CreateDir(TempPath) = False Then
        MsgBox "Cannot create 'Temp folder'." & vbCrLf & vbCrLf & "Please check 'Preferences'/'Temp folder' path.", vbExclamation, App.Path
        Exit Sub
    End If
    
    ' Verify working drives free space
    OperationSection = "Verify working drives free space"
    jj = 0
    Select Case OutputSetup
    Case MPEG2_Streams
        jj = 1
    Case MPEG2_File, DVD_Folder, Burn_DVD
        jj = 1
        If AssetsPath = OutputPath Then jj = jj + 1
    Case ISO_UDF_Image
        jj = 2 - frmMain.intDeleteAssets.value
        If AssetsPath = OutputPath Then jj = jj + 1
    End Select
    If Val(modFS.atDiskFreeSpaceEx(Left(Preferences.AssetsPath, 1))) < Val(frmMain.Txt_Estimated_Output_Size.Text) Then
        MBR = frmQuestion.Display(frmMain, "Warning!" & vbCrLf & vbCrLf & "Non enough free space in Assets Hard Drive (needed " & frmMain.Txt_Estimated_Output_Size.Text & " MB)!" & vbCrLf & vbCrLf & "Do you want to continue at your risk?", vbNo, 30)
    ElseIf Val(frmMain.Txt_Free_Space.Text) < jj * Val(frmMain.Txt_Estimated_Output_Size.Text) Then
        MBR = frmQuestion.Display(frmMain, "Warning!" & vbCrLf & vbCrLf & "Non enough free space in Output Hard Drive (needed " & jj * frmMain.Txt_Estimated_Output_Size.Text & " MB)!" & vbCrLf & vbCrLf & "Do you want to continue at your risk?", vbNo, 30)
    End If
    If MBR = vbNo Then
        modMain.Save_Log_Video "Warning! Project aborted due to low disc space.", , True
        Exit Sub
    End If
    
    ' Erase junk stuff
    OperationSection = "Erase junk stuff"
    If Dir(TempPath & "\A2D*.cache") <> "" Then
        Kill TempPath & "\A2D*.cache"
    End If

    ' Verify Menu Titles number
    OperationSection = "Verify Menu Titles number"
    Flag_Menu = DVDMenu.IsInit
    If NumTitles > MaxMenuTitles And DVDMenu.IsInit = True And frmMain.Menu_Options_MPEG2_1.Checked = False And frmMain.Menu_Options_MPEG2_2.Checked = False Then
        If MsgBox("Warning! AVStoDVD can support maximum " & MaxMenuTitles & " DVD Menu Titles." & vbCrLf & vbCrLf & "Press 'Retry' to continue without DVD Menu or 'Cancel' to quit.", vbRetryCancel + vbExclamation, App.Title) = vbRetry Then
            Flag_Menu = False
        Else
            Exit Sub
        End If
    End If

    ' Defining DVD label
    OperationSection = "Defining DVD label"
    DVD_Label = "DVD"
    If frmMain.Txt_DVD_Label.Text <> "" Then
        DVD_Label = frmMain.Txt_DVD_Label.Text
    End If
        
    ' Building DVDName string
    OperationSection = "Building DVDName string"
    jj = 0
    Flag = False
    Do
        DVDName = DVD_Label & "_" & jj
        If modFS.EsisteFile(OutputPath & "\" & DVDName & ".log") = True Then
            jj = jj + 1
        Else
            Flag = True
        End If
    Loop Until Flag = True
    
    ' Building MsgBox to check settings before start encoding
    OperationSection = "Building MsgBox to check settings before start encoding"
    Str_Settings = "PROJECT SETTINGS" & vbCrLf & vbCrLf & _
                   "DVD Video Standard: " & IIf(VideoStandard = PAL, "PAL", "NTSC") & vbCrLf & _
                   "DVD Titles number: " & NumTitles & vbCrLf & _
                   "DVD Size: " & frmMain.Txt_Estimated_Output_Size.Text & "/" & frmMain.Txt_Output_Size.Text & " MB (" & Format(Val(frmMain.Txt_Estimated_Output_Size.Text) / Val(frmMain.Txt_Output_Size.Text), "0%") & ")" & vbCrLf & _
                   "DVD Output Setup: " & frmMain.StatusBar.Panels("Output_Setup").Text & vbCrLf & _
                   "DVD Label: " & DVD_Label & vbCrLf & _
                   "DVD Menu: " & IIf(Flag_Menu = False, "No Menu", IIf(DVDMenu.Style = 1, "Motion Menu", "Static Menu")) & vbCrLf & _
                   "Output Folder: " & OutputPath & vbCrLf & _
                   "Delete Temp Assets Files: " & IIf(frmMain.intDeleteAssets.value = 0, "No", "Yes") & vbCrLf & _
                   "Delete Temp Working Files: " & IIf(frmMain.intDeleteWorking.value = 0, "No", "Yes") & vbCrLf & _
                   "Edit Command Parameters: " & IIf(frmMain.Int_EditEncoderParams.value = 0, "No", "Yes") & vbCrLf & _
                   "Post Process Task: " & Replace(frmMain.Cmb_PostProcess.Text, " (default)", "") & vbCrLf & vbCrLf
    
    ' Start Operations
    OperationSection = "Start Operations"
    If InStr(1, frmJobsList.Caption, "/") <> 0 Then MBR = vbOK
    If MBR <> vbOK Then
        MBR = MsgBox(Str_Settings & vbCrLf & "Do you want to start?" & vbCrLf, vbQuestion + vbOKCancel + vbMsgBoxHelpButton, App.Title, App.HelpFile, 17)
    End If
    If MBR = vbOK Then
        frmMain.Hide
        frmJobsList.Hide
        Load frmProgress
        Flag_DeleteAssets = CBool(frmMain.intDeleteAssets.value)
        modMain.Save_Log_Video IIf(InStr(1, frmProgress.Caption, "/") = 0, "AVStoDVD Project started.", "AVStoDVD Job" & StrTrimRight(StrTrimLeft(frmProgress.Caption, "-"), "-") & "started.")
        With Preferences
            Str_Settings = Str_Settings & _
                           "PREFERENCES" & vbCrLf & vbCrLf
            Str_Settings = Str_Settings & _
                           "MultiThread: " & -CInt(.MultiThread) & vbCrLf & _
                           "AVS Video Source Filter: " & .AVSVideoInput & vbCrLf & _
                           "AVS Audio Source Filter: " & .AVSAudioInput & vbCrLf & _
                           "AVS UpSize/DownSize Filter: " & .AVSUpSize & "/" & .AVSDownSize & vbCrLf & _
                           "Frame Adjust Strategy: " & .AVSAdjustFrame & vbCrLf & _
                           "PAL SpeedUp: " & -CInt(.PALSpeedUp) & vbCrLf & _
                           "Video Resolution: " & .VideoResolution & vbCrLf & _
                           "Video BitRate Min: " & .VideoMinAvgBitRate & vbCrLf & _
                           "Video BitRate Level 1: " & .VideoProfileLevel1 & vbCrLf & _
                           "Video Profile Level 2: " & .VideoProfileLevel2 & vbCrLf & _
                           "Video BitRate Max: " & .VideoMaxAvgBitRate & vbCrLf & _
                           "Keep DVD Compliant Video: " & -CInt(.KeepOrigVideo) & vbCrLf & _
                           "AC3 Audio Encoder: " & .AC3AudioEncoder & vbCrLf & _
                           "Force FFmpeg for Long Audio: " & -CInt(.ForceFFmpeg4GB) & vbCrLf & _
                           "DVD Audio Format: " & .AudioFormat & vbCrLf & _
                           "DVD Audio BitRate: " & .AudioBitRate & vbCrLf & _
                           "Keep DVD Compliant Audio: " & -CInt(.KeepOrigAudio) & vbCrLf & _
                           "Normalize Audio: " & -CInt(.AudioNormalize) & IIf(.AudioNormalize = True, " (@ " & .AudioNormalizeVal & ")", "") & vbCrLf & _
                           "Auto Delay Audio: " & -CInt(.AudioDelayAuto) & vbCrLf
            Str_Settings = Str_Settings & _
                           "DVD Audio Language (Primary): " & .AudioLanguage & vbCrLf & _
                           "DVD Audio Language (Secondary): " & .AudioLanguage2 & vbCrLf & _
                           "DVD Subs Language (Primary): " & .SubsLanguage & vbCrLf & _
                           "DVD Subs Language (Secondary): " & .SubsLanguage2 & vbCrLf & _
                           "DVD Subs Font: " & .SubsFont.Name & " " & .SubsFont.Height & "pt" & IIf(.SubsFont.Bold = True, " Bold", "") & IIf(.SubsFont.Italic = True, " Italic", "") & " (" & modStr.LongtoRGB(.SubsFont.Color) & ")" & vbCrLf & _
                           "Chapters Interval: " & .ChaptersInterval & vbCrLf & _
                           "Use Source Chapters: " & -CInt(.ChaptersUseSource) & vbCrLf & _
                           "DVD Burning Drive: " & .DVDBurningDrive & vbCrLf & _
                           "DVD Burning Speed: " & .DVDBurningSpeed & vbCrLf & _
                           "Auto Erase DVD RW: " & -CInt(.DVDAutoErase) & vbCrLf & _
                           "Unload ActiveMovie library: " & -CInt(.UnloadDShow) & vbCrLf & _
                           "Adjust ffdshow at runtime: " & -CInt(.ffdshowRuntime) & vbCrLf & _
                           "Save General Settings: " & -CInt(.SaveSettings)
        End With
        modMain.Save_Log OutputPath & "\" & DVDName & ".log", "START PROCESS", False
        modMain.Save_Log OutputPath & "\" & DVDName & ".log", Str_Settings, True
                
        ' Generate filename used throuhgout the process
        OperationSection = "Generate filename used throuhgout the process"
        For Tj = 1 To NumTitles
            TitleName(Tj) = DVDName & "_Title_" & IIf(Tj < 10, "0", "") & Tj & "_" & Title(Tj).TitleName
        Next Tj
        If NumTitles = 1 Then
            TitleName(1) = DVDName & "_" & Title(1).TitleName
        End If
        
        ' Start encoding processes
        For Tj = 1 To NumTitles
            OperationSection = "Title " & Tj & " encoding setup"
            CurrentTitle = Tj
            With Title(Tj)
                frmProgress.Update_Progress 0, True
                
                ' Verify Source Files
                OperationSection = "Title " & Tj & " source files verification"
                Flag = False
                If .InputVideoPathName <> "" Then
                    If modFS.EsisteFile(.InputVideoPathName) = False Then Flag = True
                End If
                For jj = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                    If modFS.EsisteFile(.InputAudioPathName(jj)) = False Then Flag = True
                Next jj
                For jj = 1 To Val(.InputGeneralInfo.SubsTracksCount)
                    If modFS.EsisteFile(.InputSubsPathName(jj)) = False Then Flag = True
                Next jj
                If Flag = True Then
                    modMain.Save_Log_Video "Error! Cannot locate Title " & Tj & " source files. Process aborted.", , True
                    Flag_End = True
                    Exit For
                End If
                
                ' Generate AviSynth script file(s)
                OperationSection = "Title " & Tj & " AviSynth script file generation"
                kk = Val(.InputGeneralInfo.AudioTracksCount)
                If kk = 0 Then kk = 1
                For jj = 1 To kk
                    NumFile = FreeFile
                    AVSPathName(Tj, jj) = TempPath & "\" & TitleName(Tj) & "_" & jj & ".avs"
                    If jj = 1 Then
                        AVSScript(Tj, jj) = .AVSScript
                    Else
                        AVSScript(Tj, jj) = modAVS.Create_AVSScript(Title(Tj), jj)
                    End If
                    Open AVSPathName(Tj, jj) For Output As #NumFile
                        Print #NumFile, AVSScript(Tj, jj)
                    Close #NumFile
                Next jj
                
                ' Misc starting stuff
                OperationSection = "Title " & Tj & " misc starting stuff"
                If InStr(1, AVSScript(Tj, 1), "DGPulldown") <> 0 Then
                    FPS_AVS = Val(.InputVideoInfo.FPS)
                Else
                    FPS_AVS = FPS
                End If
                
                ' Log source files info
                OperationSection = "Title " & Tj & " source file info log"
                sLog = "TITLE " & Tj & " SOURCE FILES" & vbCrLf & _
                       "Video: " & .InputVideoPathName & vbCrLf & _
                       "Info: " & .InputVideoInfo.Summary
                For jj = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                    sLog = sLog & vbCrLf & _
                          "Audio " & jj & ": " & .InputAudioPathName(jj) & vbCrLf & _
                          "Info: " & .InputAudioInfo(jj).Summary
                Next jj
                For jj = 1 To Val(.InputGeneralInfo.SubsTracksCount)
                    sLog = sLog & vbCrLf & _
                           "Subs " & jj & ": " & .InputSubsPathName(jj) & vbCrLf & _
                           "Info: " & .InputSubsInfo(jj).Summary
                Next jj
                sLog = sLog & vbCrLf & "[" & .InputGeneralInfo.MediaInfoVersion & "]"
                modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                modMain.Save_Log OutputPath & "\" & DVDName & ".log", "AVISYNTH SCRIPT" & vbCrLf & AVSScript(Tj, 1), True
                If Val(.InputGeneralInfo.AudioTracksCount) > 1 Then
                    For jj = 2 To Val(.InputGeneralInfo.AudioTracksCount)
                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", "AVISYNTH SCRIPT (Audio Track " & jj & ")" & vbCrLf & AVSScript(Tj, jj), True
                    Next jj
                End If
                
                ' AviSynth FrameServing capability check
                OperationSection = "Title " & Tj & " AviSynth FrameServing check"
                If frmMain.Int_FrameServingCheck.value = 1 Then
                    OperationSection = "Title " & Tj & " AviSynth FrameServing check"
                    If .VideoIsToBeKept = False Then
                        sLog = UCase(OperationSection) & vbCrLf
                        Flag = modMain.AviSynth_FrameServing_Check(.AVSScript, OperationSection & "." & vbCrLf & "Please wait ...", CBool(frmMain.intDeleteWorking.value))
                        If Flag = False Then
                            Str = "Error! Title " & Tj & " cannot be frameserved by AviSynth."
                            sLog = sLog & Str
                            MBR = frmQuestion.Display(frmMain, Str & vbCrLf & vbCrLf & "For more info and troubleshooting, see Help/FAQ/Video/Q3.1" & vbCrLf & vbCrLf & "Do you want to continue anyway? Default 'No'", vbNo, 60)
                            If MBR = vbYes Then
                                sLog = sLog & vbCrLf & "Warning skipped by user."
                            Else
                                modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog & " Process aborted.", True, True
                                Flag_End = True
                                Exit For
                            End If
                        Else
                            sLog = sLog & "Check passed successfully."
                        End If
                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                    End If
                End If
                
                ' Start VIDEO encoding operations
                OperationSection = "Title " & Tj & " VIDEO encoding operations start"
                modMain.Save_Log_Video "Title " & Tj & " video encoding operations started."
                Target_Video_FileSize(Tj) = Val(.VideoBitRate) * 1000 / 8 / 1024 / 1024 * Val(.TimeTrimmed)
                ' Define video file pathname
                VideoPathName(Tj) = AssetsPath & "\" & TitleName(Tj) & ".m2v"
                sLog = ""
                MBR = vbYes
                If modFS.EsisteFile(VideoPathName(Tj)) = True Then
                    MBR = frmQuestion.Display(frmMain, Msgs.FileExistsOverwrite & vbCrLf & vbCrLf & "'" & VideoPathName(Tj) & "'" & vbCrLf & vbCrLf & "Default 'Yes'", , 60)
                End If
                If MBR = vbYes Then
                    If .VideoIsToBeKept = False Then
                        ' Defining variable MPEG2 settings
                        OperationSection = "Title " & Tj & " Defining variable MPEG2 settings"
                        If .VideoHCenc.Bias = "AUTO" Then
                            Bias = CStr(CInt(.VideoBitRate / 1000)) & "0"
                        Else
                            Bias = .VideoHCenc.Bias
                        End If
                        If .VideoHCenc.DCPrec = "AUTO" Then
                            Select Case .VideoBitRate
                            Case Is > 6000
                                DC_Precision = "10"
                            Case Is > 4000
                                DC_Precision = "9"
                            Case Else
                                DC_Precision = "8"
                            End Select
                        Else
                            DC_Precision = .VideoHCenc.DCPrec
                        End If
                        ' Adjust ffdshow mixer
                        If Preferences.ffdshowRuntime = True And ffdshow.PathName <> "" Then
                            Select Case .AudioChannelsMode(1)
                            Case "1.0"
                                Str = "0"      '"1/0/0"
                            Case "5.1"
                                Str = "13"     '"3/0/2 + LFE"
                            Case Else
                                Str = "1"      '"2/0/0"
                            End Select
                            modReg.ScriviChiaveNumero "HKEY_CURRENT_USER\Software\GNU\ffdshow_audio\default", "mixerOut", Val(Str)
                        End If
                        ' Generate command line
                        Select Case .VideoProfile
                        Case "FFmpeg CBR 1-pass"
                            OperationSection = "Title " & Tj & " FFmpeg command line generation"
                            VideoEncoderPath = App.Path & "\FFmpeg\ffmpeg.exe"
                            CL_Params = "-i """ & AVSPathName(Tj, 1) & """ -threads " & SysInfo.ProcessorNumber & " -aspect "
                            Select Case .VideoAspectRatio
                            Case Standard
                                Str = "4:3"
                            Case Widescreen
                                Str = "16:9"
                            End Select
                            CL_Params = CL_Params & Str & " -c:v mpeg2video -b:v " & .VideoBitRate & "k -minrate " & .VideoBitRate & "k -maxrate " & .VideoBitRate & "k -bufsize 2000k -dc " & DC_Precision & " "
                            If .VideoFFmpegHQ = True Then
                                CL_Params = CL_Params & "-bf 2 -mbd rd -trellis 2 -cmp 2 -subcmp 2 "
                            End If
                            If .VideoCloseAllGOPs = True Then
                                CL_Params = CL_Params & "-sc_threshold 1000000000 -flags +cgop "
                            End If
                            If .VideoInterlacedEncoding = True Then
                                CL_Params = CL_Params & "-flags +ilme+ildct -alternate_scan 1 "
                                Select Case .VideoFieldOrder
                                Case "BFF"
                                    CL_Params = CL_Params & "-top 0 "
                                Case "TFF"
                                    CL_Params = CL_Params & "-top 1 "
                                End Select
                            End If
                            CL_Params = CL_Params & "-y """ & VideoPathName(Tj) & """"
                            ' Let user to modify CL_Params
                            If frmMain.Int_EditEncoderParams.value = 1 Then
                                CL_Params = frmTextBox.Display(frmProgress, "AVStoDVD - Edit Command Parameter", "FFmpeg Command Parameters:" & vbCrLf & "(when finished press X)", CL_Params)
                            End If
                        Case "HCenc VBR 1-pass", "HCenc VBR 2-pass"
                            OperationSection = "Title " & Tj & " HCenc command line generation"
                            VideoEncoderPath = App.Path & "\HCenc\HCenc.exe"
                            HCenc_ini = "*INFILE " & AVSPathName(Tj, 1) & vbCrLf & _
                                        "*AVSRELOAD" & vbCrLf & _
                                        "*OUTFILE " & VideoPathName(Tj) & vbCrLf & _
                                        "*LOGFILE " & TempPath & "\" & TitleName(Tj) & ".HCenc.log" & vbCrLf & _
                                        "*MAXBITRATE " & .VideoMaxBitRate & vbCrLf
                            If .VideoProfile = "HCenc VBR 1-pass" Then
                                HCenc_ini = HCenc_ini & _
                                        "*1PASS" & vbCrLf
                            End If
                            HCenc_ini = HCenc_ini & _
                                        "*BITRATE " & .VideoBitRate & vbCrLf & _
                                        "*PROFILE " & .VideoHCenc.Profile & vbCrLf & _
                                        "*ASPECT " & IIf(.VideoAspectRatio = Standard, "4:3", "16:9") & vbCrLf & _
                                        IIf(.VideoInterlacedEncoding = True, "*INTERLACED", "*PROGRESSIVE") & vbCrLf & _
                                        "*" & .VideoFieldOrder & vbCrLf
                            If LCase(.InputVideoInfo.ScanType) = "progressive" And Val(.InputVideoInfo.FPS) = 23.976 And VideoStandard = NTSC Then
                                HCenc_ini = HCenc_ini & "*PULLDOWN" & vbCrLf
                            End If
                            HCenc_ini = HCenc_ini & _
                                        "*BIAS " & Bias & vbCrLf & _
                                        "*DC_PREC " & DC_Precision & vbCrLf & _
                                        IIf(.VideoCloseAllGOPs = True, "*CLOSEDGOPS" & vbCrLf, "") & _
                                        "*MATRIX " & .VideoHCenc.Matrix & vbCrLf & _
                                        "*AQ " & .VideoHCenc.AQ & vbCrLf & _
                                        "*LUMGAIN " & .VideoHCenc.Lumgain & vbCrLf
                            If .VideoHCenc.Zone <> "" Then
                                Zone = Split(.VideoHCenc.Zone)
                                VideoFrameCount = .AVS.FrameEnd - .AVS.FrameStart
                                If Val(Zone(1)) + 1 >= VideoFrameCount Then
                                    HCenc_ini = HCenc_ini & _
                                        "*ZONE 1" & vbCrLf & _
                                        " " & Zone(0) & " " & Zone(2) & vbCrLf
                                Else
                                    HCenc_ini = HCenc_ini & _
                                        "*ZONE 2" & vbCrLf & _
                                        " " & Zone(0) & " " & Zone(2) & vbCrLf & _
                                        " " & Int(Val(Zone(1))) + 1 & " 1" & vbCrLf
                                End If
                            End If
                            HCenc_ini = HCenc_ini & _
                                        IIf(Preferences.MultiThread = True, "*SMP", "*NOSMP") & vbCrLf
                            Select Case Preferences.EncodingPriority
                            Case 0
                                HCenc_ini = HCenc_ini & _
                                        "*PRIORITY IDLE" & vbCrLf
                            Case 1
                                HCenc_ini = HCenc_ini & _
                                        "*PRIORITY LOW" & vbCrLf
                            Case 2, 3
                                HCenc_ini = HCenc_ini & _
                                        "*PRIORITY NORMAL" & vbCrLf
                            Case 4, 5
                                HCenc_ini = HCenc_ini & _
                                        "*PRIORITY HIGH" & vbCrLf
                            End Select
                            HCenc_ini = HCenc_ini & _
                                        "*DBPATH  " & Preferences.TempPath & vbCrLf & _
                                        "*WAIT 2"
                            ' Let user to modify CL_Params
                            If frmMain.Int_EditEncoderParams.value = 1 Then
                                HCenc_ini = frmTextBox.Display(frmProgress, "AVStoDVD - Edit Command Parameter", "HCenc Command INI file:" & vbCrLf & "(when finished press X)", HCenc_ini)
                            End If
                            NumFile = FreeFile
                            Open TempPath & "\" & TitleName(Tj) & ".HCenc.ini" For Output As #NumFile
                                Print #NumFile, HCenc_ini
                            Close #NumFile
                            CL_Params = "-ini """ & TempPath & "\" & TitleName(Tj) & ".HCenc.ini"""
                        Case "FFmpeg (Safe Mode)"
                            OperationSection = "Title " & Tj & " FFmpeg (Safe Mode) command line generation"
                            VideoEncoderPath = App.Path & "\FFmpeg\ffmpeg.exe"
                            CL_Params = "-i """ & .InputVideoPathName & """ -threads " & SysInfo.ProcessorNumber & " "
                            Flag = False
                            If Val(.InputVideoInfo.FPS) <= FPS Then
                                Select Case Val(.InputVideoInfo.FPS)
                                Case 23.976, 24, 25, 29.97, 30, 50, 59.94, 60    'only these fps are mpeg2 compliant
                                    Flag = True   ' do nothing, DGPulldown will upsize framerate
                                End Select
                            End If
                            If Flag = False Then
                                CL_Params = CL_Params & "-r " & Replace(CStr(FPS), ",", ".") & " "
                            End If
                            Str = ""
                            Select Case .VideoAspectRatio
                            Case Standard
                                If Val(.InputVideoInfo.Width) / Val(.InputVideoInfo.Height) > 1.34 Then
                                    Str = CStr(Round(Val(.InputVideoInfo.Width) / 1.333, 0))
                                    Str = "-vf pad=" & .InputVideoInfo.Width & ":" & Str & ":0:" & CStr(Round((Val(Str) - Val(.InputVideoInfo.Height)) / 2, 0))
                                ElseIf Val(.InputVideoInfo.Width) / Val(.InputVideoInfo.Height) < 1.33 Then
                                    Str = CStr(Round(Val(.InputVideoInfo.Height) * 1.333, 0))
                                    Str = "-vf pad=" & Str & ":" & .InputVideoInfo.Height & ":" & CStr(Round((Val(Str) - Val(.InputVideoInfo.Width)) / 2, 0)) & ":0"
                                End If
                            Case Widescreen
                                If Val(.InputVideoInfo.Width) / Val(.InputVideoInfo.Height) > 1.78 Then
                                    Str = CStr(Round(Val(.InputVideoInfo.Width) / 1.778, 0))
                                    Str = "-vf pad=" & .InputVideoInfo.Width & ":" & Str & ":0:" & CStr(Round((Val(Str) - Val(.InputVideoInfo.Height)) / 2, 0))
                                ElseIf Val(.InputVideoInfo.Width) / Val(.InputVideoInfo.Height) < 1.77 Then
                                    Str = CStr(Round(Val(.InputVideoInfo.Height) * 1.778, 0))
                                    Str = "-vf pad=" & Str & ":" & .InputVideoInfo.Height & ":" & CStr(Round((Val(Str) - Val(.InputVideoInfo.Width)) / 2, 0)) & ":0"
                                End If
                            End Select
                            If Str <> "" Then CL_Params = CL_Params & Str & " "
                            CL_Params = CL_Params & "-s "
                            Select Case VideoStandard
                            Case PAL
                                Select Case .VideoResolution
                                Case Full_D1
                                    Str = "720x576"
                                Case Half_D1
                                    Str = "352x576"
                                Case VCD
                                    Str = "352x288"
                                End Select
                            Case NTSC
                                Select Case .VideoResolution
                                Case Full_D1
                                    Str = "720x480"
                                Case Half_D1
                                    Str = "352x480"
                                Case VCD
                                    Str = "352x240"
                                End Select
                            End Select
                            CL_Params = CL_Params & Str & " -aspect "
                            Select Case .VideoAspectRatio
                            Case Standard
                                Str = "4:3"
                            Case Widescreen
                                Str = "16:9"
                            End Select
                            CL_Params = CL_Params & Str & " -c:v mpeg2video -b:v " & .VideoBitRate & "k -minrate " & .VideoBitRate & "k -maxrate " & .VideoBitRate & "k -bufsize 2000k -dc " & DC_Precision & " "
                            If .VideoFFmpegHQ = True Then
                                CL_Params = CL_Params & "-bf 2 -mbd rd -trellis 2 -cmp 2 -subcmp 2 "
                            End If
                            If .VideoCloseAllGOPs = True Then
                                CL_Params = CL_Params & "-sc_threshold 1000000000 -flags +cgop "
                            End If
                            If .VideoInterlacedEncoding = True Then
                                CL_Params = CL_Params & "-flags +ilme " '+ildct
                                Select Case .VideoFieldOrder
                                Case "BFF"
                                    CL_Params = CL_Params & "-top 0 "
                                Case "TFF"
                                    CL_Params = CL_Params & "-top 1 "
                                End Select
                            End If
                            CL_Params = CL_Params & "-y """ & VideoPathName(Tj) & """"
                            ' Let user to modify CL_Params
                            If frmMain.Int_EditEncoderParams.value = 1 Then
                                CL_Params = frmTextBox.Display(frmProgress, "AVStoDVD - Edit Command Parameter", "FFmpeg (Safe Mode) Command Parameters:" & vbCrLf & "(when finished press X)", CL_Params)
                            End If
                        End Select
                        sLog = "START VIDEO ENCODING OPERATIONS" & vbCrLf & _
                               "Encoding Profile: " & .VideoProfile & vbCrLf & _
                               "Target Video FileSize: " & Round(Target_Video_FileSize(Tj), 1) & " MB" & vbCrLf & _
                               "Encoding Parameters: " & CL_Params & IIf(HCenc_ini <> "", vbCrLf & "HCenc ini file:" & vbCrLf & HCenc_ini, "")
                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                        ' Execute VIDEO encoding
                        OperationSection = "Title " & Tj & " VIDEO encoding execution"
                        Execute VideoEncoderPath, CL_Params, Preferences.EncodingWindowStyle, True
                        sLog = ""
                        ' Read A2DVideoInfo.cache file, if it exists
                        If modFS.EsisteFile(TempPath & "\A2DVideoInfo.cache") = True Then
                            If InStr(1, AVSScript(Tj, 1), "A2DVideoSource(") <> 0 Then
                                Str = ""
                                NumFile = FreeFile
                                Open TempPath & "\A2DVideoInfo.cache" For Input As NumFile
                                    Do Until EOF(NumFile)
                                        Str = Str & Input(1, #NumFile)
                                    Loop
                                Close NumFile
                                If InStr(1, Str, .InputVideoPathName) <> 0 Then
                                    sLog = Right(Str, Len(Str) - InStr(1, Str, .InputVideoPathName))
                                    sLog = modMain.Load_Str_Object(sLog, "A2DVideoSource", "")
                                    sLog = "Video Source Filter: A2DSource (" & sLog & ")"
                                End If
                            ElseIf InStr(1, AVSScript(Tj, 1), "DirectShowSource(") <> 0 Then
                                sLog = "Video Source Filter: DirectShowSource"
                            ElseIf InStr(1, AVSScript(Tj, 1), "FFVideoSource") <> 0 Then
                                sLog = "Video Source Filter: FFMpegSource"
                            End If
                        End If
                        sLog = "END VIDEO ENCODING OPERATIONS" & vbCrLf & _
                               IIf(sLog <> "", sLog & vbCrLf, "")
                    Else
                        If LCase(modFS.ExtOf(.InputVideoPathName)) = "m2v" And InStr(1, .InputVideoInfo.Compression, "MPEG-2") <> 0 And OutputSetup <> MPEG2_Streams Then
                            ' Use source MPEG-2 video pathname and skip demux
                            VideoPathName(Tj) = .InputVideoPathName
                            sLog = "SKIP VIDEO ENCODING OPERATIONS" & vbCrLf & "Source video file: '" & VideoPathName(Tj) & "' is already DVD compliant."
                            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                        Else
                            ' Video demux
                            OperationSection = "Title " & Tj & " FFmpeg command line generation (video demux)"
                            VideoEncoderPath = App.Path & "\FFmpeg\ffmpeg.exe"
                            CL_Params = "-i """ & .InputVideoPathName & """ -vcodec copy"
                            ' Handle Trim for Video Direct Stream Copy
                            If .AVSTrim = True Then
                                CL_Params = CL_Params & " -ss " & modStr.VisualTime(.AVS.FrameStart / FPS_AVS, True, True) & " -vframes " & (.AVS.FrameEnd - .AVS.FrameStart)
                            End If
                            CL_Params = CL_Params & " """ & VideoPathName(Tj) & """"
                            sLog = "START VIDEO DEMUXING OPERATIONS" & vbCrLf & _
                                   "Target Video FileSize: " & Round(Target_Video_FileSize(Tj), 1) & " MB" & vbCrLf & _
                                   "FFmpeg Parameters: " & CL_Params
                            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                            ' Execute VIDEO demuxing
                            OperationSection = "Title " & Tj & " VIDEO demuxing execution"
                            Execute VideoEncoderPath, CL_Params, Preferences.EncodingWindowStyle, True
                            sLog = "END VIDEO DEMUXING OPERATIONS" & vbCrLf
                        End If
                    End If
                    ' Check output video filesize
                    Flag_End = False
                    Output_Video_FileSize(Tj) = modUtil.GetFileSize(VideoPathName(Tj)) / 1024 / 1024
                    If Output_Video_FileSize(Tj) > 0 Then
                        sLog = sLog & "Created File: " & VideoPathName(Tj) & " (" & Round(Output_Video_FileSize(Tj), 1) & " MB)"
                        If MInfo.ReadMediaInfo(VideoPathName(Tj), , False, True, False, False) = True Then
                            OutputVideoInfo.Initialize MInfo
                            sLog = sLog & vbCrLf & "OUTPUT VIDEO INFO: " & OutputVideoInfo.Summary
                            If Val(OutputVideoInfo.Time) < 0.9 * Val(.TimeTrimmed) * 1000 Then
                                Flag_End = False
                                MBR = frmQuestion.Display(frmMain, "Warning! Title " & Tj & " Output Video duration (" & modStr.VisualTime(Val(OutputVideoInfo.Time) / 1000, True) & ") is shorter than expected duration (" & modStr.VisualTime(Val(.TimeTrimmed), True) & ")." & vbCrLf & vbCrLf & "Do you want to continue anyway? Default 'Yes'", , 60)
                                If MBR = vbNo Then Flag_End = True
                            End If
                            Set OutputVideoInfo = Nothing
                        End If
                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                        'Execute ReJig to transcode if required
                        If Output_Video_FileSize(Tj) > 1.01 * Target_Video_FileSize(Tj) And Output_Video_FileSize(Tj) - Target_Video_FileSize(Tj) > 1 And .VideoIsToBeKept = False Then
                            OperationSection = "Title " & Tj & " ReJig transcoding (filesize targeting) execution"
                            CL_Params = "-size " & Int(Target_Video_FileSize(Tj)) & " -o """ & AssetsPath & "\" & TitleName(Tj) & ".ReJig.m2v""" & " -i """ & VideoPathName(Tj) & """ -auto -close -quiet"
                        End If
                        If InStr(1, OperationSection, "ReJig") <> 0 Then
                            sLog = "START TRANSCODING OPERATIONS" & vbCrLf & "ReJig Parameters: " & CL_Params
                            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                            Execute App.Path & "\ReJig\ReJig.exe", CL_Params, Preferences.EncodingWindowStyle, True
                            modFS.DeleteIfExist VideoPathName(Tj)
                            Name AssetsPath & "\" & TitleName(Tj) & ".ReJig.m2v" As VideoPathName(Tj)
                            sLog = "END TRANSCODING OPERATIONS" & vbCrLf & "Transcoding executed on File: " & VideoPathName(Tj) & " (" & Round(GetFileSize(VideoPathName(Tj)) / 1024 / 1024, 1) & " MB)"
                            If MInfo.ReadMediaInfo(VideoPathName(Tj), , False, True, False, False) = True Then
                                OutputVideoInfo.Initialize MInfo
                                sLog = sLog & vbCrLf & "OUTPUT VIDEO INFO: " & OutputVideoInfo.Summary
                                Set OutputVideoInfo = Nothing
                            End If
                            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                        End If
                        ' Execute DG Pulldown if required
                        OperationSection = "Title " & Tj & " DG Pulldown execution (if required)"
                        If MInfo.ReadMediaInfo(VideoPathName(Tj), , False, True, False, False) = True Then
                            OutputVideoInfo.Initialize MInfo
                            With OutputVideoInfo
                                If Val(.FPS) > 0 And FPS > Val(.FPS) Then
                                    Flag = True
                                    If VideoStandard = PAL Then
                                        Select Case Val(.FPS)
                                        Case 25
                                            Flag = False
                                        Case 23.976, 24
                                            If LCase(.ScanOrder) = "2:2:2:2:2:2:2:2:2:2:2:3 pulldown" Then Flag = False
                                        End Select
                                    End If
                                    If VideoStandard = NTSC Then
                                        Select Case Val(.FPS)
                                        Case 29.97
                                            Flag = False
                                        Case 23.976
                                            If LCase(.ScanOrder) = "2:3 pulldown" Then Flag = False
                                        End Select
                                    End If
                                End If
                            End With
                            If Flag = True Then
                                CL_Params = """" & VideoPathName(Tj) & """ -srcfps " & OutputVideoInfo.FPS & " -destfps " & Replace(CStr(FPS), ",", ".") & " -inplace -" & LCase(.VideoFieldOrder)
                                sLog = "START PULLDOWN OPERATIONS" & vbCrLf & "DGPulldown Parameters: " & CL_Params
                                modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                Execute App.Path & "\DGPulldown\DGPulldown.exe", CL_Params, Preferences.EncodingWindowStyle, True
                                sLog = "END PULLDOWN OPERATIONS" & vbCrLf & "DGPulldown executed on File: " & VideoPathName(Tj) & " (" & Round(GetFileSize(VideoPathName(Tj)) / 1024 / 1024, 1) & " MB)"
                                If MInfo.ReadMediaInfo(VideoPathName(Tj), , False, True, False, False) = True Then
                                    OutputVideoInfo.Initialize MInfo
                                    sLog = sLog & vbCrLf & "OUTPUT VIDEO INFO: " & OutputVideoInfo.Summary
                                    Set OutputVideoInfo = Nothing
                                End If
                                modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                            End If
                        End If
                        MInfo.Clear
                    Else
                        Flag_End = True
                    End If
                Else
                    sLog = "SKIP VIDEO ENCODING OPERATIONS" & vbCrLf & "Video file: '" & VideoPathName(Tj) & "' already found."
                    modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                End If
                If Flag_End = False Then
                    Output_Assets_FileSize = Output_Assets_FileSize + Output_Video_FileSize(Tj)
                    modMain.Save_Log_Video "Title " & Tj & " video encoding operations have been completed."
                    frmProgress.Update_Progress 0, False
                Else
                    Err_Message = "Process aborted during Title " & Tj & " VIDEO encoding operations." & vbCrLf & vbCrLf & "For Video issues troubleshooting see Help/FAQ/Video section."
                    modMain.Save_Log_Video Err_Message & vbCrLf & vbCrLf & _
                                           "For more info on current project check log file <" & OutputPath & "\" & DVDName & ".log>.", False, True
                    modMain.Save_Log OutputPath & "\" & DVDName & ".log", Err_Message, True
                End If
                
                ' AUDIO encoding operations
                If Flag_End = False And Val(.InputGeneralInfo.AudioTracksCount) > 0 Then
                    OperationSection = "Title " & Tj & " AUDIO encoding operations start"
                    modMain.Save_Log_Video "Title " & Tj & " audio encoding operations started."
                    frmProgress.Update_Progress 1, True
                    For jj = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                        If Flag_End = False Then
                            ' Adjust ffdshow mixer (yes, again!)
                            If Preferences.ffdshowRuntime = True And ffdshow.PathName <> "" Then
                                Select Case .AudioChannelsMode(jj)
                                Case "1.0"
                                    Str = "0"      '"1/0/0"
                                Case "5.1"
                                    Str = "13"     '"3/0/2 + LFE"
                                Case Else
                                    Str = "1"      '"2/0/0"
                                End Select
                                modReg.ScriviChiaveNumero "HKEY_CURRENT_USER\Software\GNU\ffdshow_audio\default", "mixerOut", Val(Str)
                            End If
                            ' Define audio file extension
                            Select Case .AudioFormat(jj)
                            Case AC3
                                AudioExt(Tj, jj) = ".ac3"
                            Case MP2
                                AudioExt(Tj, jj) = ".mp2"
                            Case WAV
                                AudioExt(Tj, jj) = ".wav"
                            Case DTS
                                AudioExt(Tj, jj) = ".dts"
                            End Select
                            ' Define audio file pathname
                            AudioPathName(Tj, jj) = AssetsPath & "\" & TitleName(Tj) & "_" & jj & AudioExt(Tj, jj)
                            MBR = vbYes
                            If modFS.EsisteFile(AudioPathName(Tj, jj)) = True Then
                                MBR = frmQuestion.Display(frmMain, Msgs.FileExistsOverwrite & vbCrLf & vbCrLf & "'" & AudioPathName(Tj, jj) & "'" & vbCrLf & vbCrLf & "Default 'Yes'", , 60)
                            End If
                            If MBR = vbYes Then
                                If .AudioIsToBeKept(jj) = False Then
                                    sLog = "START AUDIO ENCODING OPERATIONS (Track " & jj & ")" & vbCrLf
                                    Select Case .AudioFormat(jj)
                                    Case AC3
                                        AudioEncoder = Preferences.AC3AudioEncoder
                                        If .TimeTrimmed > 7200 And .AudioChannelsMode(jj) = "5.1" And Preferences.ForceFFmpeg4GB = True Then  '7200 seconds = 2 hours
                                            AudioEncoder = FFmpeg_Avisynth
                                        End If
                                        Flag_Exec = False
                                        Select Case AudioEncoder
                                        Case Wavi_Aften
                                            CL_Params = """" & AVSPathName(Tj, jj) & """ - | """ & App.Path & "\Aften\aften.exe""" & " -b " & .AudioBitRate(jj) & " -pad " & .AudioAften(jj).Pad & " -dynrng " & .AudioAften(jj).DRC & " -bwfilter " & .AudioAften(jj).BWFilter & " - """ & AudioPathName(Tj, jj) & """"
                                            sLog = sLog & "Wavi+Aften Parameters: " & CL_Params
                                            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                            Str = "Title " & Tj & " AUDIO ENCODING (Track " & jj & "). Please wait ..."
                                            NumFile = FreeFile
                                            Open TempPath & "\" & TitleName(Tj) & ".Aften.bat" For Output As #NumFile
                                                Print #NumFile, "@echo " & Str & vbCrLf & _
                                                                "@echo " & String(Len(Str), "-") & vbCrLf & _
                                                                """" & App.Path & "\Wavi\Wavi.exe""" & " " & CL_Params
                                            Close #NumFile
                                            Flag_Exec = modShellEx.Execute(TempPath & "\" & TitleName(Tj) & ".Aften.bat", "", Preferences.EncodingWindowStyle, True, , 7200)     ' 2h
                                            If Flag_Exec = False Then
                                                modUtil.KillRunningProcess App.Path & "\Wavi\wavi.exe"
                                            End If
                                        Case FFmpeg_Aften
                                            CL_Params = "-i """ & AVSPathName(Tj, jj) & """ """ & TempPath & "\" & TitleName(Tj) & "_" & jj & ".wav"""
                                            CL_Params2 = "-b " & .AudioBitRate(jj) & " -pad " & .AudioAften(jj).Pad & " -dynrng " & .AudioAften(jj).DRC & " -bwfilter " & .AudioAften(jj).BWFilter & " """ & TempPath & "\" & TitleName(Tj) & "_" & jj & ".wav""" & " """ & AudioPathName(Tj, jj) & """"
                                            sLog = sLog & "FFmpeg (WAV) Parameters: " & CL_Params & vbCrLf & "Aften (AC3) Parameters: " & CL_Params2
                                            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                            modShellEx.Execute App.Path & "\FFmpeg\ffmpeg.exe", CL_Params, Preferences.EncodingWindowStyle, True
                                            modShellEx.Execute App.Path & "\Aften\aften.exe", CL_Params2, Preferences.EncodingWindowStyle, True
                                        Case FFmpeg_Avisynth
                                            CL_Params = "-i """ & AVSPathName(Tj, jj) & """" & _
                                                        IIf(Preferences.MultiThread = True, " -threads " & SysInfo.ProcessorNumber, "") & _
                                                        " -y -vn -acodec ac3"
                                            ' Change channels configuration only if necessary
                                            Select Case .AudioChannelsMode(jj)
                                            Case "1.0"
                                                If Val(.InputAudioInfo(jj).Channels) <> 1 Then
                                                    CL_Params = CL_Params & " -ac 1"
                                                End If
                                            Case "2.0"
                                                If Val(.InputAudioInfo(jj).Channels) <> 2 Then
                                                    CL_Params = CL_Params & " -ac 2"
                                                End If
                                            Case "5.1"
                                                If Val(.InputAudioInfo(jj).Channels) <> 6 Then
                                                    CL_Params = CL_Params & " -ac 6"
                                                End If
                                            End Select
                                            CL_Params = CL_Params & " -ab " & .AudioBitRate(jj) & "k """ & AudioPathName(Tj, jj) & """"
                                            sLog = sLog & "FFmpeg Parameters: " & CL_Params
                                            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                            modShellEx.Execute App.Path & "\FFmpeg\ffmpeg.exe", CL_Params, Preferences.EncodingWindowStyle, True
                                        Case Else
                                            ' FFmpeg Safe Mode
                                        End Select
                                    Case MP2
                                        CL_Params = "-i """ & AVSPathName(Tj, jj) & """" & _
                                                    IIf(Preferences.MultiThread = True, " -threads " & SysInfo.ProcessorNumber, "") & _
                                                    " -y -vn -acodec mp2" & _
                                                    " -ab " & .AudioBitRate(jj) & "k" & _
                                                    " """ & AudioPathName(Tj, jj) & """"
                                        sLog = sLog & "FFmpeg (MP2) Parameters: " & CL_Params
                                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                        modShellEx.Execute App.Path & "\FFmpeg\ffmpeg.exe", CL_Params, Preferences.EncodingWindowStyle, True
                                    Case WAV
                                        CL_Params = IIf(Preferences.MultiThread = True, "-threads " & SysInfo.ProcessorNumber, "") & " -i """ & AVSPathName(Tj, jj) & """ """ & AudioPathName(Tj, jj) & """"
                                        sLog = sLog & "FFmpeg (WAV) Parameters: " & CL_Params
                                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                        modShellEx.Execute App.Path & "\FFmpeg\ffmpeg.exe", CL_Params, Preferences.EncodingWindowStyle, True
                                    End Select
                                Else
                                    ' Audio demux
                                    CL_Params = "-i """ & .InputAudioPathName(jj) & """ -acodec copy"
                                    CL_Params = CL_Params & " -map 0:" & .InputAudioInfo(jj).TrackID
                                    ' Handle Trim for Audio Direct Stream Copy
                                    If .AVSTrim = True Then
                                        CL_Params = CL_Params & " -ss " & modStr.VisualTime(.AVS.FrameStart / FPS_AVS, True) & " -aframes " & Round((.AVS.FrameEnd - .AVS.FrameStart) / FPS_AVS * IIf(.AudioFormat(jj) = AC3, 31.25, IIf(.AudioFormat(jj) = MP2, 125 / 3, IIf(.AudioFormat(jj) = WAV, 46.875, IIf(.AudioFormat(jj) = DTS, 93.75, FPS_AVS)))))
                                    End If
                                    CL_Params = CL_Params & " """ & AssetsPath & "\" & TitleName(Tj) & "_" & jj & ".ToFix" & AudioExt(Tj, jj) & """"
                                    sLog = "START AUDIO DEMUXING OPERATIONS (Track " & jj & ")" & vbCrLf & "FFmpeg Parameters: " & CL_Params
                                    modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                    ' Generate FFmpeg.bat file to redirect FFmpeg echo
                                    Str = "Title " & Tj & " AUDIO DEMUXING (Track " & jj & "). Please wait ..."
                                    NumFile = FreeFile
                                    Open TempPath & "\" & TitleName(Tj) & ".FFmpeg.bat" For Output As #NumFile
                                        Print #NumFile, "@echo " & Str & vbCrLf & _
                                                        "@echo " & String(Len(Str), "-") & vbCrLf & _
                                                        """" & App.Path & "\FFmpeg\ffmpeg.exe""" & " " & CL_Params & " 2>""" & TempPath & "\" & TitleName(Tj) & ".FFmpeg.log"""
                                    Close #NumFile
                                    ' Demux with FFmpeg
                                    Execute TempPath & "\" & TitleName(Tj) & ".FFmpeg.bat", "", Preferences.EncodingWindowStyle, True
                                    ' Check demuxing errors
                                    Flag = False
                                    If modFS.EsisteFile(TempPath & "\" & TitleName(Tj) & ".FFmpeg.log") = True Then
                                        Flag = True
                                        sLog = ""
                                        NumFile = FreeFile
                                        Open TempPath & "\" & TitleName(Tj) & ".FFmpeg.log" For Input As #NumFile
                                            Do Until EOF(NumFile) = True
                                                Line Input #NumFile, Str
                                                If InStr(1, Str, "Press [q] to stop encoding") <> 0 Then
                                                    sLog = ""
                                                Else
                                                    sLog = sLog & Str & vbCrLf
                                                End If
                                            Loop
                                        Close NumFile
                                    End If
                                    If InStr(1, LCase(sLog), "error") <> 0 Then
                                        Flag = False
                                    End If
                                    If Flag = True Then
                                        If .AudioFormat(jj) = AC3 And .AudioFixAC3(jj) = True Then
                                            Execute App.Path & "\ac3fix\ac3fix.exe", """" & AssetsPath & "\" & TitleName(Tj) & "_" & jj & ".ToFix" & AudioExt(Tj, jj) & """ """ & AudioPathName(Tj, jj) & """", Preferences.EncodingWindowStyle, True
                                        Else
                                            modFS.ReName AssetsPath & "\" & TitleName(Tj) & "_" & jj & ".ToFix" & AudioExt(Tj, jj), AudioPathName(Tj, jj)
                                        End If
                                    Else
                                        modFS.DeleteIfExist AssetsPath & "\" & TitleName(Tj) & "_" & jj & ".ToFix" & AudioExt(Tj, jj)
                                    End If
                                End If
                            Else
                                sLog = "SKIP AUDIO ENCODING OPERATIONS (Track " & jj & ")" & vbCrLf & "Audio file: '" & AssetsPath & "\" & TitleName(Tj) & AudioExt(Tj, jj) & "' already found."
                                modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                            End If
                            Flag_End = False
                            MBR = vbNo
                            Str = ""
                            If .AudioFormat(jj) = AC3 And AudioEncoder = FFmpeg_Safe Then
                                MBR = vbYes
                            Else
                                Output_Audio_FileSize(Tj) = modUtil.GetFileSize(AudioPathName(Tj, jj)) / 1024 / 1024
                                If MInfo.ReadMediaInfo(AudioPathName(Tj, jj), , False, False, True, False) = True Then
                                    ' Check audio filesize, samplerate, channels and bitrate
                                    If Output_Audio_FileSize(Tj) < 0.01 Then
                                        Str = "Audio filesize is too low (" & Int(Output_Audio_FileSize(Tj)) & " MB)"
                                    Else
                                        OutputAudioInfo.Initialize MInfo, 0
                                        If Val(OutputAudioInfo.SampleRate) <> 48000 Then
                                            Str = "Audio SampleRate is incorrect (" & OutputAudioInfo.SampleRate & " vs 48000 Hz)"
                                        Else
                                            If Val(OutputAudioInfo.Channels) <> Val(Left(.AudioChannelsMode(jj), 1)) + Val(Right(.AudioChannelsMode(jj), 1)) Then
                                                Str = "Audio Channels are incorrect (" & Int(Val(OutputAudioInfo.Channels)) & " vs " & Int(Val(Left(.AudioChannelsMode(jj), 1))) + Int(Val(Right(.AudioChannelsMode(jj), 1))) & ")"
                                            Else
                                                If Val(OutputAudioInfo.AvgBitRate) / 1000 <> Val(.AudioBitRate(jj)) Then
                                                    Str = "Audio BitRate is incorrect (" & Int(Val(OutputAudioInfo.AvgBitRate) / 1000) & " vs " & Val(.AudioBitRate(jj)) & " kbps)"
                                                End If
                                            End If
                                        End If
                                        Set OutputAudioInfo = Nothing
                                    End If
                                End If
                                MInfo.Clear
                                If Str <> "" And LCase(AudioExt(Tj, jj)) <> ".dts" Then
                                    If .AVSAutoScript = .AVSScript Or jj > 1 Then
                                        sLog = "WARNING! Errors found during Title " & Tj & " Audio Track " & jj & " encoding. " & vbCrLf & Str
                                        MBR = frmQuestion.Display(frmMain, sLog & vbCrLf & vbCrLf & "Do you want to start Backup Audio encoding routine (FFmpeg Safe Mode)?" & vbCrLf & vbCrLf & "Default 'Yes'", , 60)
                                        If MBR = vbYes Then
                                            sLog = sLog & vbCrLf & "Backup Audio encoding routine (FFmpeg Safe Mode) is starting ..."
                                            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                        End If
                                    End If
                                End If
                            End If
                            If MBR = vbYes Then
                                ' FFmpeg safe mode
                                CL_Params = IIf(Preferences.MultiThread = True, "-threads " & SysInfo.ProcessorNumber, "") & " -i """ & .InputAudioPathName(jj) & """"
                                CL_Params = CL_Params & " -map 0:" & .InputAudioInfo(jj).TrackID & " -y -vn"
                                Select Case .AudioFormat(jj)
                                Case AC3
                                    CL_Params = CL_Params & " -acodec ac3"
                                Case MP2
                                    CL_Params = CL_Params & " -acodec mp2"
                                Case WAV
                                    CL_Params = CL_Params & " -acodec pcm_s16le"
                                End Select
                                ' Handle Trim
                                If .AVSTrim = True Then
                                    CL_Params = CL_Params & " -ss " & modStr.VisualTime(.AVS.FrameStart / FPS_AVS, True) & " -t " & modStr.VisualTime((.AVS.FrameEnd - .AVS.FrameStart) / FPS_AVS, True)
                                End If
                                ' Change channels configuration only if necessary
                                Select Case .AudioChannelsMode(jj)
                                Case "1.0"
                                    If Val(.InputAudioInfo(jj).Channels) <> 1 Then
                                        CL_Params = CL_Params & " -ac 1"
                                    End If
                                Case "2.0"
                                    If Val(.InputAudioInfo(jj).Channels) <> 2 Then
                                        CL_Params = CL_Params & " -ac 2"
                                    End If
                                Case "5.1"
                                    If Val(.InputAudioInfo(jj).Channels) <> 6 Then
                                        CL_Params = CL_Params & " -ac 6"
                                    End If
                                End Select
                                CL_Params = CL_Params & " -ar 48000 -ab " & .AudioBitRate(jj) & "k """ & AudioPathName(Tj, jj) & """"
                                sLog = "START FFMPEG (SAFE MODE) AUDIO ENCODING OPERATIONS (Track " & jj & ")" & vbCrLf & "FFmpeg Parameters: " & CL_Params
                                modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                Execute App.Path & "\FFmpeg\ffmpeg.exe", CL_Params, Preferences.EncodingWindowStyle, True
                                Output_Audio_FileSize(Tj) = modUtil.GetFileSize(AudioPathName(Tj, jj)) / 1024 / 1024
                            End If
                            Flag_End = False
                            If Output_Audio_FileSize(Tj) > 0 Then
                                If InStr(1, sLog, "SKIP AUDIO ENCODING OPERATIONS") = 0 Then
                                    sLog = ""
                                    ' Read A2DAudioInfo.cache file, if it exists
                                    If .AudioIsToBeKept(jj) = False And AudioEncoder <> FFmpeg_Safe And modFS.EsisteFile(TempPath & "\A2DAudioInfo.cache") = True Then
                                        If InStr(1, AVSScript(Tj, jj), "A2DAudioSource") <> 0 Then
                                            Str = ""
                                            NumFile = FreeFile
                                            Open TempPath & "\A2DAudioInfo.cache" For Input As NumFile
                                                Do Until EOF(NumFile)
                                                    Str = Str & Input(1, #NumFile)
                                                Loop
                                            Close NumFile
                                            If InStr(1, Str, .InputAudioPathName(jj)) <> 0 Then
                                                sLog = Right(Str, Len(Str) - InStr(1, Str, .InputAudioPathName(jj)))
                                                sLog = modMain.Load_Str_Object(sLog, "A2DAudioSource", "")
                                                sLog = "Audio Source Filter: A2DSource (" & sLog & ")"
                                            End If
                                        ElseIf InStr(1, AVSScript(Tj, jj), "DirectShowSource(") <> 0 Then
                                            sLog = "Audio Source Filter: DirectShowSource"
                                        ElseIf InStr(1, AVSScript(Tj, jj), "FFAudioSource(") <> 0 Then
                                            sLog = "Audio Source Filter: FFMpegSource"
                                        End If
                                    End If
                                    sLog = "END AUDIO " & _
                                           IIf(.AudioIsToBeKept(jj) = True, "DEMUXING ", "ENCODING ") & _
                                           "OPERATIONS (Track " & jj & ")" & vbCrLf & _
                                           IIf(sLog <> "", sLog & vbCrLf, "") & _
                                           "Created File: " & AudioPathName(Tj, jj) & " (" & Round(Output_Audio_FileSize(Tj), 1) & " MB)"
                                    If MInfo.ReadMediaInfo(AudioPathName(Tj, jj), , False, False, True, False) = True Then
                                        OutputAudioInfo.Initialize MInfo, 0
                                        sLog = sLog & vbCrLf & "OUTPUT AUDIO INFO: " & OutputAudioInfo.Summary
                                        If Val(OutputAudioInfo.Time) < 0.9 * Val(.TimeTrimmed) * 1000 Then
                                            MBR = frmQuestion.Display(frmMain, "Warning! Title " & Tj & " Audio Track " & jj & " output Audio duration (" & modStr.VisualTime(Val(OutputAudioInfo.Time) / 1000, True) & ") is shorter than expected duration (" & modStr.VisualTime(Val(.TimeTrimmed), True) & ")." & vbCrLf & vbCrLf & "Do you want to continue anyway? Default 'Yes'", , 60)
                                            If MBR = vbNo Then Flag_End = True
                                        End If
                                        Set OutputAudioInfo = Nothing
                                    End If
                                    MInfo.Clear
                                    modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                End If
                            Else
                                Flag_End = True
                            End If
                        End If
                        If Flag_End = False Then
                            Output_Assets_FileSize = Output_Assets_FileSize + Output_Audio_FileSize(Tj)
                        End If
                        If Flag_DeleteAssets = True Then
                            modFS.DeleteIfExist AssetsPath & "\" & TitleName(Tj) & "_" & jj & ".ToFix.ac3"
                        End If
                        If Flag_End = True Then Exit For
                    Next jj
                    If Flag_End = False Then
                        modMain.Save_Log_Video "Title " & Tj & " audio encoding operations have been completed."
                        frmProgress.Update_Progress 1, False
                    Else
                        Err_Message = "Process aborted during Title " & Tj & " AUDIO (Track " & jj & ") encoding operations." & vbCrLf & vbCrLf & "For Audio issues troubleshooting see Help/FAQ/Audio section."
                        modMain.Save_Log_Video Err_Message & vbCrLf & vbCrLf & _
                                               "For more info on current project check log file <" & OutputPath & "\" & DVDName & ".log>.", False, True
                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", Err_Message, True
                    End If
                End If
                    
                ' Muxing operations
                If Flag_End = False And OutputSetup = MPEG2_File Then
                    OperationSection = "Title " & Tj & " Video and Audio Muxing operations start"
                    modMain.Save_Log_Video "Title " & Tj & " muxing operations started."
                    frmProgress.Update_Progress 2, True
                    sLog = "START MUXING OPERATIONS" & vbCrLf
                    Select Case .AudioFormat(Tj)
                    Case AC3, MP2
                        CL_Params = """" & VideoPathName(Tj) & """ """ & AudioPathName(Tj, 1) & """ -o """ & OutputPath & """"
                        sLog = sLog & "ImagoMPEG-Muxer Parameters: " & CL_Params
                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                        Execute App.Path & "\ImagoMPEG-Muxer\ImagoMPEG-Muxer.exe", CL_Params, Preferences.EncodingWindowStyle, True
                        modFS.ReName LCase(OutputPath & "\" & TitleName(Tj) & ".mpg"), OutputPath & "\" & TitleName(Tj) & ".mpg"
                    Case Else 'WAV, DTS
                        CL_Params = "-i """ & VideoPathName(Tj) & """ -vcodec copy -i """ & AudioPathName(Tj, 1) & """ -acodec copy -f vob """ & OutputPath & "\" & TitleName(Tj) & ".mpg"""
                        sLog = sLog & "FFmpeg Parameters: " & CL_Params
                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                        Err_Message = ""
                        Load frmMessage
                        With frmMessage
                            '.DisableClose = True
                            .Caption = "AVStoDVD - MPEG2 Muxing"
                            .Lbl_Message.Caption = "FFmpeg is starting ..."
                            .ProgressBar.Min = 0
                            .ProgressBar.Max = Round(Output_Video_FileSize(Tj) + Output_Audio_FileSize(Tj))
                            .Show 0, Screen.ActiveForm
                            Execute App.Path & "\FFmpeg\ffmpeg.exe", CL_Params, SW_HIDE, False
                            Do
                                If .FormIsClosedByUser = True Then
                                    modUtil.KillRunningProcess App.Path & "\FFmpeg\ffmpeg.exe"
                                Else
                                    .ProgressBar.Tag = Round(GetFileSize(OutputPath & "\" & TitleName(Tj) & ".mpg") / 1024 / 1024)
                                    If Val(.ProgressBar.Tag) > .ProgressBar.Max Then
                                        .ProgressBar.value = .ProgressBar.Max
                                    Else
                                        .ProgressBar.value = Val(.ProgressBar.Tag)
                                    End If
                                    .Lbl_Message.Caption = "FFmpeg is running ..." & vbCrLf & vbCrLf & _
                                                           .ProgressBar.value & " / " & .ProgressBar.Max & " MB completed."
                                    .Caption = "AVStoDVD - MPEG2 Muxing (" & Format(.ProgressBar.value / .ProgressBar.Max, "0%") & ")"
                                    DoEvents
                                End If
                                modUtil.Sleep 500
                            Loop Until modUtil.FindRunningProcess(App.Path & "\FFmpeg\ffmpeg.exe") = 0
                            If .FormIsClosedByUser = True Then
                                Err_Message = "Process aborted by user during Title " & Tj & " muxing operations."
                            Else
                                .ProgressBar.value = .ProgressBar.Max
                                .Caption = "AVStoDVD - MPEG2 Muxing (100%)"
                                .Lbl_Message.Caption = "FFmpeg has finished!"
                                DoEvents
                                modUtil.WaitForFile OutputPath & "\" & TitleName(Tj) & ".mpg", 5
                            End If
                        End With
                        Unload frmMessage
                    End Select
                    If Err_Message = "" Then
                        If modUtil.GetFileSize(OutputPath & "\" & TitleName(Tj) & ".mpg") > modUtil.GetFileSize(OutputPath & "\" & TitleName(Tj) & ".m2v") Then
                            modMain.Save_Log_Video "Title " & Tj & " muxing operations have been completed."
                            sLog = "END MUXING OPERATIONS" & vbCrLf & "Created File: " & OutputPath & "\" & TitleName(Tj) & ".mpg (" & Round(GetFileSize(OutputPath & "\" & TitleName(Tj) & ".mpg") / 1024 / 1024, 1) & " MB)"
                            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                            frmProgress.Update_Progress 2, False
                        Else
                            Err_Message = "Process aborted during Title " & Tj & " muxing operations."
                        End If
                    End If
                    If Err_Message <> "" Then
                        modMain.Save_Log_Video Err_Message & vbCrLf & vbCrLf & "For more info on current project check log file <" & OutputPath & "\" & DVDName & ".log>.", False, True
                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", Str, True
                        Flag_End = True
                        If Flag_DeleteAssets = True Then
                            MBR = frmQuestion.Display(frmMain, "Do you want to keep the MPEG2 elementary files?" & vbCrLf & vbCrLf & "Default 'Yes'", , 30)
                            If MBR = vbYes Then Flag_DeleteAssets = False
                        End If
                    End If
                    If Flag_DeleteAssets = True Then
                        modFS.DeleteIfExist VideoPathName(Tj)
                        For jj = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                            modFS.DeleteIfExist AudioPathName(Tj, jj)
                        Next jj
                    End If
                End If
                
                ' SUBS encoding operations
                If Flag_End = False And Val(.InputGeneralInfo.SubsTracksCount) > 0 Then
                    OperationSection = "Title " & Tj & " SUBS encoding operations start"
                    modMain.Save_Log_Video "Title " & Tj & " subs encoding operations started."
                    frmProgress.Update_Progress 3, True
                    For jj = 1 To Val(.InputGeneralInfo.SubsTracksCount)
                        sLog = ""
                        If .SubsHardEncode(jj) = True Then
                            sLog = "SKIP SUBS ENCODING OPERATIONS (Track " & jj & ")" & vbCrLf & "Hard Encoded Subs"
                            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                        Else
                            ' Define input subs file pathname
                            If .InputSubsPathName(jj) = .InputVideoPathName Then
                                InputSubsPathName = TempPath & "\" & TitleName(Tj) & "." & .InputSubsInfo(jj).Extension
                                ' Extract Subtitles track from Matroska
                                If .InputSubsPathName(jj) = .InputVideoPathName Then
                                    CL_Params = "tracks """ & .InputSubsPathName(jj) & """ " & .InputSubsInfo(jj).TrackID & ":""" & InputSubsPathName & """"
                                    sLog = "START SUBS EXTRACTING OPERATIONS (Track " & jj & ")" & vbCrLf & "MKVExtract Parameters: " & CL_Params
                                    modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                    modShellEx.Execute App.Path & "\MKVtoolNix\mkvextract.exe", CL_Params, SW_DEFAULT, True, False
                                    If modUtil.GetFileSize(InputSubsPathName) > 0 Then
                                        sLog = "END SUBS EXTRACTING OPERATIONS (Track " & jj & ")" & vbCrLf & "Created File: " & InputSubsPathName & " (" & Round(modUtil.GetFileSize(InputSubsPathName) / 1024, 1) & " KB)"
                                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                    Else
                                        'Err_Message = "Error extracting subs (Track " & jj & ") from Title " & Tj & "."
                                        'modMain.Save_Log_Video Err_Message, False, False
                                        'modMain.Save_Log OutputPath & "\" & DVDName & ".log", UCase(Err_Message), True
                                        'InputSubsPathName = ""
                                        Flag_End = True
                                    End If
                                End If
                            Else
                                InputSubsPathName = .InputSubsPathName(jj)
                            End If
                            If Flag_End = False Then
                                sLog = "START SUBS ENCODING OPERATIONS (Track " & jj & ")" & vbCrLf
                                ' Define output subs file extension
                                Select Case UCase(.InputSubsInfo(jj).Extension)
                                Case "SRT", "SUP", "IDX", "SSA", "ASS"
                                    SubsExt(Tj, jj) = ".sup"
                                Case "SST"
                                    SubsExt(Tj, jj) = ".sst"
                                End Select
                                ' Define output subs file pathname
                                SubsPathName(Tj, jj) = AssetsPath & "\" & TitleName(Tj) & "_" & jj & SubsExt(Tj, jj)
                                ' Create SUP/SST file
                                Select Case UCase(.InputSubsInfo(jj).Extension)
                                Case "SRT", "SSA", "ASS"
                                    ' Build new Profile.xml
                                    kk = 1
                                    If .VideoAspectRatio = Widescreen Then kk = kk + 1
                                    If VideoStandard = NTSC Then kk = kk + 2
                                    modMain.Build_SC_Profile_xml App.Path & "\SubtitleCreator\Data\Profiles.xml", Preferences.SubsFont, Preferences.SubsPos
                                    ' Build command line
                                    CL_Params = """" & TempPath & "\" & TitleName(Tj) & ".srt"" -p" & kk & " -i""" & App.Path & "\SubtitleCreator\Examples\VTS_01_1.IFO"""
                                    If UCase(.InputSubsInfo(jj).Extension) = "SRT" Then
                                        ' Check if srt is in ANSI format, if not UTF-8 is assumed and converted to ANSI
                                        Str = ""
                                        NumFile = FreeFile
                                        Open InputSubsPathName For Input As #NumFile
                                            Do Until EOF(NumFile) = True Or Len(Str) = 3
                                                Str = Str & Input(1, #NumFile)
                                            Loop
                                        Close #NumFile
                                        If IsNumeric(Val(Left(Str, 1))) = True And Right(Str, 2) = vbCrLf Then
                                            FileCopy InputSubsPathName, TempPath & "\" & TitleName(Tj) & ".ToFix.srt"
                                        Else
                                            modStr.UTF8FiletoANSIFile InputSubsPathName, TempPath & "\" & TitleName(Tj) & ".ToFix.srt", True
                                            If modFS.EsisteFile(TempPath & "\" & TitleName(Tj) & ".ToFix.srt") = True Then
                                                sLog = sLog & "ANSI format conversion routine applied" & vbCrLf
                                            Else
                                                sLog = sLog & "ANSI format conversion routine NOT applied" & vbCrLf
                                            End If
                                        End If
                                    Else 'ASS
                                        kk = modSubs.Convert_ASS_to_SRT(InputSubsPathName, TempPath & "\" & TitleName(Tj) & ".ToFix.srt")
                                        If kk > -1 And modFS.EsisteFile(TempPath & "\" & TitleName(Tj) & ".ToFix.srt") = True Then
                                            sLog = sLog & "SSA/ASS to SRT conversion routine applied (" & kk & " subtitles converted)" & vbCrLf
                                        Else
                                            sLog = sLog & "SSA/ASS to SRT conversion routine failed" & vbCrLf
                                        End If
                                    End If
                                    ' Fix SRT
                                    kk = modSubs.Fix_SRT(TempPath & "\" & TitleName(Tj) & ".ToFix.srt", TempPath & "\" & TitleName(Tj) & ".srt")
                                    If kk > -1 And modFS.EsisteFile(TempPath & "\" & TitleName(Tj) & ".srt") = True Then
                                        sLog = sLog & "SRT fixing routine applied (" & kk & " lines fixed)." & vbCrLf
                                    Else
                                        sLog = sLog & "SRT fixing routine NOT applied." & vbCrLf
                                    End If
                                    sLog = sLog & "SubtitleCreator Parameters: " & CL_Params
                                    modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                    modShellEx.Execute App.Path & "\SubtitleCreator\SubtitleCreator.exe", CL_Params, Preferences.EncodingWindowStyle, True
                                    If TempPath <> AssetsPath Then
                                        FileCopy TempPath & "\" & TitleName(Tj) & ".sup", SubsPathName(Tj, jj)
                                        modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".sup"
                                    Else
                                        modFS.ReName TempPath & "\" & TitleName(Tj) & ".sup", SubsPathName(Tj, jj)
                                    End If
                                Case "IDX"
                                    ' Fix IDX
                                    FileCopy InputSubsPathName, TempPath & "\" & TitleName(Tj) & ".ToFix.idx"
                                    FileCopy modFS.PathOf(InputSubsPathName) & modFS.NameOf(InputSubsPathName) & ".sub", TempPath & "\" & TitleName(Tj) & ".sub"
                                    kk = modSubs.Fix_IDX(TempPath & "\" & TitleName(Tj) & ".ToFix.idx", TempPath & "\" & TitleName(Tj) & ".idx")
                                    If kk > -1 Then
                                        sLog = sLog & "IDX fixing routine applied (" & kk & " errors fixed)." & vbCrLf
                                    Else
                                        sLog = sLog & "IDX fixing routine NOT applied." & vbCrLf
                                        MBR = frmQuestion.Display(frmMain, sLog & "Do you want to continue anyway?" & vbCrLf & vbCrLf & "Default 'Yes'", , 30)
                                        If MBR = vbYes Then
                                            modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".ToFix.idx"
                                            FileCopy TempPath & "\" & TitleName(Tj) & ".ToFix.idx", TempPath & "\" & TitleName(Tj) & ".ToFix.idx"
                                        End If
                                    End If
                                    If modFS.EsisteFile(TempPath & "\" & TitleName(Tj) & ".idx") = True Then
                                        CL_Params = "-f sup -i """ & TempPath & "\" & TitleName(Tj) & ".idx" & """ -o """ & modFS.PathOf(SubsPathName(Tj, jj)) & modFS.NameOf(SubsPathName(Tj, jj)) & """" & " -id 0"
                                        sLog = sLog & "VSConv Parameters: " & CL_Params
                                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                        modShellEx.Execute App.Path & "\VobSub\VSConv.exe", CL_Params, Preferences.EncodingWindowStyle, True, False
                                    End If
                                Case Else
                                    sLog = sLog & "Copy Source SUP file"
                                    modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                    FileCopy InputSubsPathName, SubsPathName(Tj, jj)
                                End Select
                                Output_Subs_FileSize(Tj) = modUtil.GetFileSize(SubsPathName(Tj, jj)) / 1024 / 1024
                                If Output_Subs_FileSize(Tj) > 0 Then
                                    Output_Assets_FileSize = Output_Assets_FileSize + Output_Subs_FileSize(Tj)
                                    sLog = "END SUBS ENCODING OPERATIONS (Track " & jj & ")" & vbCrLf & "Created File: " & SubsPathName(Tj, jj) & " (" & Round(Output_Subs_FileSize(Tj), 2) & " MB)"
                                    modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                                Else
                                    Flag_End = True
                                End If
                            End If
                        End If
                        If Flag_End = True Then Exit For
                    Next jj
                    If Flag_End = False Then
                        modMain.Save_Log_Video "Title " & Tj & " subs encoding operations have been completed."
                        frmProgress.Update_Progress 3, False
                    Else
                        Err_Message = "Process aborted during Title " & Tj & " SUBS (Track " & jj & ") encoding operations." & vbCrLf & vbCrLf & "For Subtitles issues troubleshooting see Help/FAQ/Subtitles section."
                        modMain.Save_Log_Video Err_Message & vbCrLf & vbCrLf & _
                                               "For more info on current project check log file <" & OutputPath & "\" & DVDName & ".log>.", False, True
                        modMain.Save_Log OutputPath & "\" & DVDName & ".log", Err_Message, True
                    End If
                End If
                
                ' Restore ffdshow mixer
                If Preferences.ffdshowRuntime = True And modReg.EmiLeggiChiaveNumero("HKEY_CURRENT_USER\Software\GNU\ffdshow_audio\default", "mixerOut", 999) <> 999 Then
                    modReg.ScriviChiaveNumero "HKEY_CURRENT_USER\Software\GNU\ffdshow_audio\default", "mixerOut", ffdshow.MixerBackup
                End If
                
                ' Cleanup encoding working files
                OperationSection = "Title " & Tj & " cleanup encoding working files"
                If frmMain.intDeleteWorking.value = 1 Then
                    modFS.DeleteIfExist TempPath & "\AviSynthCQP.avs"
                    For jj = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                        modFS.DeleteIfExist AVSPathName(Tj, jj)
                        modFS.DeleteIfExist AVSPathName(Tj, jj) & ".bat"
                        modFS.DeleteIfExist AVSPathName(Tj, jj) & ".log"
                        modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & "_" & jj & ".wav"
                    Next jj
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".FFmpeg.bat"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".FFmpeg.log"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".Aften.bat"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".HCenc.ini"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".HCenc.log"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".vcf"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".srt"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".ToFix.srt"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".ssa"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".ass"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".sub"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".idx"
                    modFS.DeleteIfExist TempPath & "\" & TitleName(Tj) & ".ToFix.idx"
                End If
                If Dir(TempPath & "\A2D*.cache") <> "" Then
                    Kill TempPath & "\A2D*.cache"
                End If
                modFS.DeleteIfExist .InputVideoPathName & ".ffindex"
                
            End With
            ' Verify Progress Status combo box
            If frmProgress.Cmb_PostProcess.ListIndex = 3 Then
                Err_Message = "Process aborted by user after Title " & Tj & "."
                modMain.Save_Log_Video Err_Message & vbCrLf & vbCrLf & _
                                       "For more info on current project check log file <" & OutputPath & "\" & DVDName & ".log>.", False, True
                modMain.Save_Log OutputPath & "\" & DVDName & ".log", Err_Message, True
                Flag_End = True
            End If
            ' If any error is encountered, abort encoding loop
            If Flag_End = True Then Exit For
        Next Tj
        
        If OutputSetup < DVD_Folder Then Flag_End = True
        
        ' Start AUTHORING operations
        If Flag_End = False Then
            OperationSection = "Start AUTHORING operations"
            modMain.Save_Log_Video "DVD authoring operations started."
            frmProgress.Update_Progress 4, True
            If EsisteFile(OutputPath & "\" & DVDName & "\VIDEO_TS\VIDEO_TS.IFO") = True Then
                Kill OutputPath & "\" & DVDName & "\VIDEO_TS\*.*"
            End If
            modFS.CreateDir OutputPath & "\" & DVDName & "\VIDEO_TS"
            modFS.CreateDir OutputPath & "\" & DVDName & "\AUDIO_TS"
            NumFile = FreeFile
            ' Building ini file for BatchMux
            OperationSection = "Building ini file for BatchMux"
            ' General
            BatchMux_ini = "-d """ & OutputPath & "\" & DVDName & "\VIDEO_TS""" & vbCrLf & _
                           "-mxp """ & TempPath & "\" & DVDName & "_MuxMan.mxp""" & vbCrLf & _
                           "-l """ & TempPath & "\" & DVDName & "_MuxMan.log""" & vbCrLf & _
                           "-muxman """ & App.Path & "\MuxMan""" & vbCrLf
            Select Case Preferences.EncodingPriority
            Case 0
                BatchMux_ini = BatchMux_ini & _
                           "-prio LOW" & vbCrLf
            Case 1
                BatchMux_ini = BatchMux_ini & _
                           "-prio BELOWNORMAL" & vbCrLf
            Case 2
                BatchMux_ini = BatchMux_ini & _
                           "-prio NORMAL" & vbCrLf
            Case 3
                BatchMux_ini = BatchMux_ini & _
                           "-prio ABOVENORMAL" & vbCrLf
            Case 4
                BatchMux_ini = BatchMux_ini & _
                           "-prio HIGH" & vbCrLf
            Case 5
                BatchMux_ini = BatchMux_ini & _
                           "-prio REALTIME" & vbCrLf
            End Select
            ' Subtitles Palette
            NumFile = FreeFile
            Open TempPath & "\" & DVDName & "_Palette.txt" For Output As #NumFile
                Print #NumFile, Chr(9) & Chr(9) & "Color 0=0, 0, 255" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 1=255, 0, 0" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 2=0, 0, 0" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 3=" & Replace(modStr.LongtoRGB(Preferences.SubsFont.Color), ",", ", ") & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 4=0, 255, 0" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 5=255, 0, 255" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 6=255, 255, 0" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 7=0, 125, 125" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 8=125, 125, 125" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 9=225, 225, 225" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 10=125, 0, 0" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 11=0, 125, 0" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 12=0, 0, 125" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 13=222, 0, 255" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 14=222, 125, 0" & vbCrLf & _
                                Chr(9) & Chr(9) & "Color 15=125, 0, 125"
                ' Color 2: Outline (Black)
                ' Color 3: Text (default -> White)
                ' Color 8: Anti-Alias (Grey)
                ' Color 9: Background (Light Grey)
            Close #NumFile
            BatchMux_ini = BatchMux_ini & "-palette """ & TempPath & "\" & DVDName & "_Palette.txt""" & vbCrLf
            For Tj = 1 To NumTitles
                With Title(Tj)
                    Segment = ""
                    If Tj > 1 Then Segment = "SEG" & Tj
                    ' Video
                    BatchMux_ini = BatchMux_ini & "-" & Segment & "v """ & VideoPathName(Tj) & """" & vbCrLf & _
                                                  "-" & Segment & "vidmode " & IIf(.VideoAspectRatio = Widescreen, "LB", "4:3") & vbCrLf
                    ' Audio
                    For jj = 1 To Val(.InputGeneralInfo.AudioTracksCount)
                        BatchMux_ini = BatchMux_ini & "-" & Segment & "a" & jj & " """ & AudioPathName(Tj, jj) & """" & vbCrLf & _
                                                      "-" & Segment & "a" & jj & "lang " & Left(LCase(.AudioLanguage(jj)), 2) & vbCrLf
                    Next jj
                    ' Subs
                    For jj = 1 To Val(.InputGeneralInfo.SubsTracksCount)
                        If .SubsHardEncode(jj) = False Then
                            BatchMux_ini = BatchMux_ini & "-" & Segment & "s" & jj & " """ & SubsPathName(Tj, jj) & """" & vbCrLf & _
                                                          "-" & Segment & "s" & jj & "lang " & Left(LCase(.SubsLanguage(jj)), 2) & vbCrLf & _
                                                          "-" & Segment & "s" & jj & "ext " & .SubsExtension(jj) & vbCrLf
                        End If
                    Next jj
                    ' Chapters
                    Chapters_List = ""
                    If MInfo.ReadMediaInfo(VideoPathName(Tj), , False) = True Then
                        Chapters_List_Array = Split(Title(Tj).ChaptersList, " ")
                        VideoFrameCount = Int(Val(MInfo.VideoFrameCount))
                        ' Handle pulldown flag
                        If InStr(1, .AVSScript, "#Using DGPulldown/HCenc to upsize FPS") <> 0 And FPS <> Val(MInfo.VideoFPS) Then
                            VideoFrameCount = VideoFrameCount * FPS / Val(MInfo.VideoFPS)
                        End If
                        For jj = 0 To UBound(Chapters_List_Array)
                            If Val(Chapters_List_Array(jj)) > 0 And Val(Chapters_List_Array(jj)) < (VideoFrameCount - 5 * FPS) Then    ' 5 seconds safeguard
                                Chapters_List = Chapters_List & Chapters_List_Array(jj) & vbCrLf
                            End If
                        Next jj
                    Else
                        Chapters_List = Replace(.ChaptersList, " ", vbCrLf)
                    End If
                    If Chapters_List <> "" Then
                        NumFile = FreeFile
                        Open AssetsPath & "\" & TitleName(Tj) & "_Chapters.txt" For Output As #NumFile
                            Print #NumFile, Chapters_List
                        Close #NumFile
                        If modUtil.GetFileSize(AssetsPath & "\" & TitleName(Tj) & "_Chapters.txt") > 0 Then
                            BatchMux_ini = BatchMux_ini & "-" & Segment & "cellfr """ & AssetsPath & "\" & TitleName(Tj) & "_Chapters.txt""" & vbCrLf
                            BatchMux_ini = BatchMux_ini & "-" & Segment & "progfr """ & AssetsPath & "\" & TitleName(Tj) & "_Chapters.txt""" & vbCrLf
                            BatchMux_ini = BatchMux_ini & "-" & Segment & "chapfr """ & AssetsPath & "\" & TitleName(Tj) & "_Chapters.txt""" & vbCrLf
                        End If
                    End If
                End With
            Next Tj
            ' Building DVD Menu
            OperationSection = "Building DVD Menu"
            If Flag_Menu = True Then
                ' Generate DVD Menu Items parameters if they do not exist
                With DVDMenu
                    ' Generate Menu bmp/m2v/ac3 files
                    sLog = "START DVD MENU BUILDING OPERATIONS" & vbCrLf & _
                           "DVD Menu settings:" & vbCrLf & _
                           "Style: " & .Style & vbCrLf & _
                           "Aspect Ratio: " & .AR & vbCrLf & _
                           "Titles Format: " & .TitlesFormat & vbCrLf & _
                           "Template: " & .Template & vbCrLf & _
                           "Max Titles Page: " & .MaxTitlesPage & vbCrLf & _
                           "Enable Play All: " & -CInt(.PlayAllButton) & vbCrLf & _
                           "Force Play All: " & -CInt(.ForcePlayAllSelection) & vbCrLf & _
                           "Background Audio: " & -CInt(.BackgroundAudio) & vbCrLf & _
                           "Max Thumbs Row: " & .MaxThumbsRow & vbCrLf & _
                           "Thumb Image Source: " & .ThumbImageSource & vbCrLf & _
                           "Thumb Frame Position: " & .ThumbFramePos & vbCrLf & _
                           "HL Frame Format: " & .HLFormat & vbCrLf & _
                           "HL Selection Color: " & .HLColorsSel & vbCrLf & _
                           "HL Play Color: " & .HLColorsPlay & vbCrLf & _
                           "Menu Video BitRate: " & .VideoBitRate & " kbps" & vbCrLf & _
                           "Motion Menu Duration: " & .MotionMenuDuration & " seconds" & vbCrLf & _
                           "Thumb Drop Shadow: " & .ThumbShadow & vbCrLf & _
                           "Play All Shadow: " & .PlayAllShadow & vbCrLf & _
                           "Arrows Shadow: " & .ArrowsShadow
                    modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                    If NumTitles <> .NumMenuTitles Then
                        Load frmDVDMenu
                        Unload frmDVDMenu
                    End If
                    modDVDMenu.Generate_DVD_Menu DVDName, , True
                    sLog = "END DVD MENU BUILDING OPERATIONS"
                    For jj = 1 To .NumMenuPages
                        Output_Assets_FileSize = Output_Assets_FileSize + GetFileSize(AssetsPath & "\" & DVDName & "_MenuPage" & jj & "." & IIf(.Style = MotionMenu, "m2v", "bmp")) / 1024 / 1024
                        sLog = sLog & vbCrLf & "Created File (Menu Page " & jj & "): " & AssetsPath & "\" & DVDName & "_MenuPage" & jj & "." & IIf(.Style = MotionMenu, "m2v", "bmp") & " (" & Round(GetFileSize(AssetsPath & "\" & DVDName & "_MenuPage" & jj & "." & IIf(.Style = MotionMenu, "m2v", "bmp")) / 1024 / 1024, 1) & " MB)"
                    Next jj
                    If modFS.EsisteFile(AssetsPath & "\" & DVDName & "_Menu.ac3") = True Then
                        Output_Assets_FileSize = Output_Assets_FileSize + GetFileSize(AssetsPath & "\" & DVDName & "_Menu.ac3") / 1024 / 1024
                        sLog = sLog & vbCrLf & "Created File: " & AssetsPath & "\" & DVDName & "_Menu.ac3 (" & Round(GetFileSize(AssetsPath & "\" & DVDName & "_Menu.ac3") / 1024 / 1024, 1) & " MB)"
                    End If
                    modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                    If .AR = Standard Then
                        MenuVertRes = 540
                    Else
                        MenuVertRes = 406
                    End If
                    ' Generate HighlightScheme.csm
                    NumFile = FreeFile
                    Open TempPath & "\" & DVDName & "_HighlightScheme.csm" For Output As #NumFile
                        Print #NumFile, "# Color scheme 1:" & vbCrLf & _
                                        "set ::menued::color(1,sel_color_3) " & .HLColorsSel & vbCrLf & _
                                        "set ::menued::color(1,sel_color_2) " & .HLColorsSel & vbCrLf & _
                                        "set ::menued::color(1,sel_color_1) " & .HLColorsSel & vbCrLf & _
                                        "set ::menued::color(1,sel_color_0) " & .HLColorsSel & vbCrLf & _
                                        vbCrLf & vbCrLf & _
                                        "set ::menued::color(1,sel_opacity_3) 8" & vbCrLf & _
                                        "set ::menued::color(1,sel_opacity_2) 4" & vbCrLf & _
                                        "set ::menued::color(1,sel_opacity_1) 2" & vbCrLf & _
                                        "set ::menued::color(1,sel_opacity_0) 0" & vbCrLf & _
                                        vbCrLf & vbCrLf & _
                                        "set ::menued::color(1,act_color_3) " & .HLColorsPlay & vbCrLf & _
                                        "set ::menued::color(1,act_color_2) " & .HLColorsPlay & vbCrLf & _
                                        "set ::menued::color(1,act_color_1) " & .HLColorsPlay & vbCrLf & _
                                        "set ::menued::color(1,act_color_0) " & .HLColorsPlay & vbCrLf & _
                                        vbCrLf & vbCrLf & _
                                        "set ::menued::color(1,act_opacity_3) 12" & vbCrLf & _
                                        "set ::menued::color(1,act_opacity_2) 6" & vbCrLf & _
                                        "set ::menued::color(1,act_opacity_1) 3" & vbCrLf & _
                                        "set ::menued::color(1,act_opacity_0) 0" & vbCrLf & _
                                        ""
                    Close #NumFile
                    ' Generate Menu.sst file
                    NumFile = FreeFile
                    Open AssetsPath & "\" & DVDName & "_Menu.sst" For Output As #NumFile
                        Print #NumFile, "st_format" & Chr(9) & "2" & vbCrLf & _
                                        "TV_Type" & Chr(9) & Chr(9) & IIf(VideoStandard = PAL, "PAL", "NTSC") & vbCrLf & _
                                        "Tape_Type" & Chr(9) & "NON_DROP" & vbCrLf & _
                                        "Display_Start" & Chr(9) & "forced" & vbCrLf & _
                                        "Pixel_Area" & Chr(9) & "(2 " & IIf(VideoStandard = NTSC, "478", "574") & ")" & vbCrLf & _
                                        "Display_Area" & Chr(9) & "(0 2 719 " & IIf(VideoStandard = NTSC, "478", "574") & ")" & vbCrLf & _
                                        "BG" & Chr(9) & Chr(9) & "(0 0 0 = = =)" & vbCrLf & _
                                        "PA" & Chr(9) & Chr(9) & "(100 100 100 = = =)" & vbCrLf & _
                                        "E1" & Chr(9) & Chr(9) & "(180 180 180 = = =)" & vbCrLf & _
                                        "E2" & Chr(9) & Chr(9) & "(255 255 255 = = =)" & vbCrLf & _
                                        "Directory" & Chr(9) & App.Path & "\Menu" & vbCrLf & _
                                        "Color" & Chr(9) & Chr(9) & "(1 1 1 1)" & vbCrLf & _
                                        "Contrast" & Chr(9) & "(0 0 0 0)" & vbCrLf & _
                                        "1" & Chr(9) & Chr(9) & "00:00:00:00" & Chr(9) & "00:00:00:00" & Chr(9) & "Highlights_" & IIf(VideoStandard = PAL, "PAL", "NTSC") & ".bmp"
                    Close #NumFile
                    ' Define BatchMux Hard Code Navigation file
                    BatchMux_hcn = "# Number of VMG menu pages" & vbCrLf & _
                                   "set ::vmg::menupages " & .NumMenuPages & vbCrLf & vbCrLf
                    ' Define Buttons assets
                    For jj = 1 To .NumMenuPages
                        ' Define Buttons highlight movements
                        For Tj = (jj - 1) * .MaxTitlesPage + 1 To jj * .MaxTitlesPage
                            If Tj <= .NumMenuTitles Then
                                NumButtons(jj) = NumButtons(jj) + 1
                                If .TitlesFormat = Thumbs Then
                                    Buttons_Type(NumButtons(jj)) = Thumbnail
                                    Buttons_Pos(NumButtons(jj)).X = .ThumbLeft(Tj)
                                    Buttons_Pos(NumButtons(jj)).w = .ThumbWidth(Tj)
                                    Buttons_Pos(NumButtons(jj)).Y = .ThumbTop(Tj)
                                    Buttons_Pos(NumButtons(jj)).h = .ThumbHeight(Tj)
                                Else
                                    Buttons_Type(NumButtons(jj)) = Label
                                    Buttons_Pos(NumButtons(jj)).X = .ThumbLabelLeft(Tj)
                                    Buttons_Pos(NumButtons(jj)).w = .ThumbLabelWidth(Tj)
                                    Buttons_Pos(NumButtons(jj)).Y = .ThumbLabelTop(Tj)
                                    Buttons_Pos(NumButtons(jj)).h = .ThumbLabelHeight(Tj)
                                End If
                            End If
                        Next Tj
                        If jj > 1 Then
                            NumButtons(jj) = NumButtons(jj) + 1
                            Buttons_Type(NumButtons(jj)) = ArrowL
                            Buttons_Pos(NumButtons(jj)).X = .ArrowLButtonLeft
                            Buttons_Pos(NumButtons(jj)).w = .ArrowLButtonWidth
                            Buttons_Pos(NumButtons(jj)).Y = .ArrowLButtonTop
                            Buttons_Pos(NumButtons(jj)).h = .ArrowLButtonHeight
                        End If
                        If jj < .NumMenuPages Then
                            NumButtons(jj) = NumButtons(jj) + 1
                            Buttons_Type(NumButtons(jj)) = ArrowR
                            Buttons_Pos(NumButtons(jj)).X = .ArrowRButtonLeft
                            Buttons_Pos(NumButtons(jj)).w = .ArrowRButtonWidth
                            Buttons_Pos(NumButtons(jj)).Y = .ArrowRButtonTop
                            Buttons_Pos(NumButtons(jj)).h = .ArrowRButtonHeight
                        End If
                        If .PlayAllButton = True Then
                            NumButtons(jj) = NumButtons(jj) + 1
                            Buttons_Type(NumButtons(jj)) = PlayAll
                            Buttons_Pos(NumButtons(jj)).X = .PlayAllButtonLeft
                            Buttons_Pos(NumButtons(jj)).w = .PlayAllButtonWidth
                            Buttons_Pos(NumButtons(jj)).Y = .PlayAllButtonTop
                            Buttons_Pos(NumButtons(jj)).h = .PlayAllButtonHeight
                        End If
                        modDVDMenu.DVD_Adj_But NumButtons(jj), Buttons_Pos, Buttons_Adj, , MenuVertRes
                        ' Generate Buttons.mnu file
                        Buttons_mnu = "# Page " & jj & " Buttons" & vbCrLf & vbCrLf & _
                                      "# Number of buttons and groups:" & vbCrLf & _
                                      "set ::menued::numbuts " & NumButtons(jj) & vbCrLf & _
                                      "set ::menued::numgroups " & IIf(.AR = Standard, "1", "2") & vbCrLf & vbCrLf & _
                                      "# Group types (0=undefined, 1=normal, 2=letterbox, 4=pan&scan):" & vbCrLf & _
                                      "set ::menued::grouptype(1) 1" & vbCrLf
                        If .AR = Standard Then
                            Buttons_mnu = Buttons_mnu & vbCrLf
                        Else
                            Buttons_mnu = Buttons_mnu & _
                                      "set ::menued::grouptype(2) 2" & vbCrLf & vbCrLf
                        End If
                        For Tj = 1 To NumButtons(jj)
                            Button_Pos_Y = Round(Buttons_Pos(Tj).Y * IIf(VideoStandard = NTSC, 480, 576) / MenuVertRes, 0)
                            Button_Pos_H = Round(Buttons_Pos(Tj).h * IIf(VideoStandard = NTSC, 480, 576) / MenuVertRes, 0)
                            If .HLFormat = Underline Then
                                Button_Pos_Y = Button_Pos_Y + Button_Pos_H - 3
                                Button_Pos_H = 6
                            End If
                            Buttons_mnu = Buttons_mnu & _
                                          "# Button " & Tj & ":" & vbCrLf & _
                                          "# Group 1" & vbCrLf & _
                                          "set ::menued::but(posx,1," & Tj & ") " & Buttons_Pos(Tj).X & vbCrLf & _
                                          "set ::menued::but(posw,1," & Tj & ") " & Buttons_Pos(Tj).w & vbCrLf & _
                                          "set ::menued::but(posy,1," & Tj & ") " & Button_Pos_Y & vbCrLf & _
                                          "set ::menued::but(posh,1," & Tj & ") " & Button_Pos_H & vbCrLf & _
                                          "set ::menued::but(adj_but_up,1," & Tj & ") " & Buttons_Adj(Tj).Up & vbCrLf & _
                                          "set ::menued::but(adj_but_left,1," & Tj & ") " & Buttons_Adj(Tj).Left & vbCrLf & _
                                          "set ::menued::but(adj_but_right,1," & Tj & ") " & Buttons_Adj(Tj).Right & vbCrLf & _
                                          "set ::menued::but(adj_but_down,1," & Tj & ") " & Buttons_Adj(Tj).Down & vbCrLf & _
                                          "set ::menued::but(color_scheme,1," & Tj & ") 1" & vbCrLf & _
                                          "set ::menued::but(auto_activate,1," & Tj & ") 0" & vbCrLf
                            Select Case Buttons_Type(Tj)
                            Case Thumbnail, Label
                                JumpTitle = (jj - 1) * .MaxTitlesPage + Tj
                                JumpPGC = .NumMenuPages + jj
                            Case ArrowL
                                JumpTitle = (jj - 2) * .MaxTitlesPage + 1
                                JumpPGC = jj - 1
                            Case ArrowR
                                JumpTitle = jj * .MaxTitlesPage + 1
                                JumpPGC = jj + 1
                            Case PlayAll
                                JumpTitle = (jj - 1) * .MaxTitlesPage + 1
                                JumpPGC = .NumMenuPages + jj
                            End Select
                            Buttons_mnu = Buttons_mnu & _
                                          "set ::menued::but(command,1," & Tj & ") {[71 04 00 00 00 " & modStr.PadLeft(Hex(JumpTitle), "0", 2) & " 00 " & modStr.PadLeft(Hex(JumpPGC), "0", 2) & "]}" & vbCrLf & _
                                          "# Set gprm(0) =(mov) " & JumpTitle & " ; LinkPGCN PGC " & JumpPGC & vbCrLf & vbCrLf
                            
                            If .AR = Widescreen Then
                                Button_Pos_Y = Round((67 + Buttons_Pos(Tj).Y) * IIf(VideoStandard = NTSC, 480, 576) / 540, 0)
                                Button_Pos_H = Round(Buttons_Pos(Tj).h * IIf(VideoStandard = NTSC, 480, 576) / 540, 0)
                                If .HLFormat = Underline Then
                                    Button_Pos_Y = Button_Pos_Y + Button_Pos_H - 3
                                    Button_Pos_H = 6
                                End If
                                Buttons_mnu = Buttons_mnu & _
                                          "# Group 2" & vbCrLf & _
                                          "set ::menued::but(posx,2," & Tj & ") " & Buttons_Pos(Tj).X & vbCrLf & _
                                          "set ::menued::but(posw,2," & Tj & ") " & Buttons_Pos(Tj).w & vbCrLf & _
                                          "set ::menued::but(posy,2," & Tj & ") " & Button_Pos_Y & vbCrLf & _
                                          "set ::menued::but(posh,2," & Tj & ") " & Button_Pos_H & vbCrLf & _
                                          "set ::menued::but(adj_but_up,2," & Tj & ") " & Buttons_Adj(Tj).Up & vbCrLf & _
                                          "set ::menued::but(adj_but_left,2," & Tj & ") " & Buttons_Adj(Tj).Left & vbCrLf & _
                                          "set ::menued::but(adj_but_right,2," & Tj & ") " & Buttons_Adj(Tj).Right & vbCrLf & _
                                          "set ::menued::but(adj_but_down,2," & Tj & ") " & Buttons_Adj(Tj).Down & vbCrLf & _
                                          "set ::menued::but(color_scheme,2," & Tj & ") 1" & vbCrLf & _
                                          "set ::menued::but(auto_activate,2," & Tj & ") 0" & vbCrLf
                                Buttons_mnu = Buttons_mnu & _
                                          "set ::menued::but(command,1," & Tj & ") {[71 04 00 00 00 " & modStr.PadLeft(Hex(JumpTitle), "0", 2) & " 00 " & modStr.PadLeft(Hex(JumpPGC), "0", 2) & "]}" & vbCrLf & _
                                          "# Set gprm(0) =(mov) " & JumpTitle & " ; LinkPGCN PGC " & JumpPGC & vbCrLf & vbCrLf
                            End If
                        Next Tj
                        Buttons_mnu = Buttons_mnu & vbCrLf & _
                                      "# Global parameters:" & vbCrLf & _
                                      "set ::menued::force_select_but " & -CInt(.ForcePlayAllSelection) * NumButtons(jj) & vbCrLf & _
                                      "set ::menued::force_action_but 0" & vbCrLf & _
                                      "set ::menued::selendtime -1" & vbCrLf & _
                                      "set ::menued::numselectablebuts " & NumButtons(jj)
                        NumFile = FreeFile
                        Open TempPath & "\" & DVDName & "_MenuPage" & jj & "_Buttons.mnu" For Output As #NumFile
                            Print #NumFile, Buttons_mnu
                        Close #NumFile
                        BatchMux_hcn = BatchMux_hcn & _
                                       "# Page" & jj & ":" & vbCrLf & _
                                       "set ::vmg::menutype(" & jj & ") " & .Style & vbCrLf & vbCrLf & _
                                       "# Number of buttons leading to 'Titles'" & vbCrLf & _
                                       "set ::vmg::titlebut(" & jj & ") " & NumButtons(jj) - IIf(.PlayAllButton = True, 1, 0) - IIf(.NumMenuPages = 1, 0, IIf(jj = 1, 1, IIf(jj = .NumMenuPages, 1, 2))) & vbCrLf & vbCrLf & _
                                       "'Play All' button number (0 --> 'Play All' button not present)" & vbCrLf & _
                                       "set ::vmg::playallbut(" & jj & ") " & IIf(.PlayAllButton = True, NumButtons(jj), "0")
                        BatchMux_ini = BatchMux_ini & _
                                       "-SEG" & .NumMenuTitles + jj & "v """ & AssetsPath & "\" & DVDName & "_MenuPage" & jj & IIf(.Style = MotionMenu, ".m2v""", ".bmp""") & vbCrLf & _
                                       "-SEG" & .NumMenuTitles + jj & "vidmode " & IIf(.AR = Standard, "4:3", "LB") & vbCrLf
                        If modFS.EsisteFile(AssetsPath & "\" & DVDName & "_Menu.ac3") = True Then
                            BatchMux_ini = BatchMux_ini & "-SEG" & .NumMenuTitles + jj & "a1 """ & AssetsPath & "\" & DVDName & "_Menu.ac3""" & vbCrLf
                        End If
                        BatchMux_ini = BatchMux_ini & _
                                       "-SEG" & .NumMenuTitles + jj & "s1 """ & AssetsPath & "\" & DVDName & "_Menu.sst""" & vbCrLf & _
                                       "-SEG" & .NumMenuTitles + jj & "s1dmode " & IIf(.AR = Standard, "LB", "WIDE_LB") & vbCrLf & _
                                       "-SEG" & .NumMenuTitles + jj & "hlmnu """ & TempPath & "\" & DVDName & "_MenuPage" & jj & "_Buttons.mnu""" & vbCrLf & _
                                       "-SEG" & .NumMenuTitles + jj & "hlcsm """ & TempPath & "\" & DVDName & "_HighlightScheme.csm" & vbCrLf  ' App.Path & "\Menu\Highlight_Scheme.csm""" & vbCrLf
                    Next jj
                    ' Output BatchMux hcn (Navigation configuration) file
                    NumFile = FreeFile
                    Open TempPath & "\" & DVDName & "_BatchMux.hcn" For Output As #NumFile
                        Print #NumFile, BatchMux_hcn
                    Close #NumFile
                    BatchMux_ini = BatchMux_ini & "-hcn """ & TempPath & "\" & DVDName & "_BatchMux.hcn"""
                End With
            End If
            ' Let user to modify Batchmux.ini
            If frmMain.Int_EditEncoderParams.value = 1 Then
                BatchMux_ini = frmTextBox.Display(frmProgress, "AVStoDVD - Edit Command Parameter", "BatchMux Command INI file:" & vbCrLf & "(when finished press X)", BatchMux_ini)
            End If
            ' Write Batchmux.ini file
            NumFile = FreeFile
            Open TempPath & "\" & DVDName & "_BatchMux.ini" For Output As #NumFile
                Print #NumFile, BatchMux_ini
            Close #NumFile
            ' Building cli parameters for BatchMux
            OperationSection = "Building cli parameters for BatchMux"
            CL_Params = "-arglist """ & TempPath & "\" & DVDName & "_BatchMux.ini"""
            sLog = "START DVD AUTHORING OPERATIONS" & vbCrLf & "BatchMux Parameters: " & CL_Params & vbCrLf & "BatchMux ini file:" & vbCrLf & BatchMux_ini
            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
            OperationSection = "DVD Authoring operations"
            Err_Message = ""
            Load frmMessage
            With frmMessage
                .Caption = "AVStoDVD - DVD Authoring"
                .Lbl_Message.Caption = "MuxMan is starting ..."
                .ProgressBar.Min = 0
                .ProgressBar.Max = Int(frmMain.Txt_Estimated_Output_Size.Text)
                .Show 0, Screen.ActiveForm
                Execute App.Path & "\MuxMan\BatchMux.exe", CL_Params, SW_HIDE, False
                modUtil.Sleep 1000
                Do
                    If .FormIsClosedByUser = True Then
                        modUtil.KillRunningProcess App.Path & "\MuxMan\MuxMan.exe"
                    Else
                        .ProgressBar.Tag = Round(GetDirSize(OutputPath & "\" & DVDName & "\VIDEO_TS") / 1024 / 1024, 0)
                        If Val(.ProgressBar.Tag) > .ProgressBar.Max Then
                            .ProgressBar.value = .ProgressBar.Max
                        Else
                            .ProgressBar.value = Val(.ProgressBar.Tag)
                        End If
                        If .ProgressBar.value / .ProgressBar.Max < 0.98 Then
                            .Lbl_Message.Caption = "MuxMan is running ..." & vbCrLf & vbCrLf
                        Else
                            .Lbl_Message.Caption = "MuxMan is finalizing DVD." & vbCrLf & "Please wait ..." & vbCrLf
                        End If
                        .Lbl_Message.Caption = .Lbl_Message.Caption & .ProgressBar.value & " / " & .ProgressBar.Max & " MB completed."
                        .Caption = "AVStoDVD - DVD Authoring (" & Format(.ProgressBar.value / .ProgressBar.Max, "0%") & ")"
                        DoEvents
                    End If
                    modUtil.Sleep 500
                Loop Until modUtil.FindRunningProcess(App.Path & "\MuxMan\BatchMux.exe") = 0
                If .FormIsClosedByUser = True Then
                    Err_Message = "DVD AUTHORING operations aborted by user."
                Else
                    .ProgressBar.value = .ProgressBar.Max
                    .Caption = "AVStoDVD - DVD Authoring (100%)"
                    .Lbl_Message.Caption = "MuxMan has finished!"
                    DoEvents
                    modUtil.WaitForFile OutputPath & "\" & DVDName & "\VIDEO_TS\VIDEO_TS.IFO", 5
                End If
            End With
            Unload frmMessage
            If Err_Message = "" Then
                If GetFileSize(OutputPath & "\" & DVDName & "\VIDEO_TS\VTS_" & Format(NumTitles, "00") & "_0.IFO") > 0 Then
                    If GetFileSize(OutputPath & "\" & DVDName & "\VIDEO_TS\VIDEO_TS.IFO") > 0 Then
                        Flag_Retry = False
                    Else
                        Flag_Retry = True
                        Err_Message = "Process aborted during DVD AUTHORING finalization! " & vbCrLf & vbCrLf
                    End If
                Else
                    Flag_Retry = True
                    Err_Message = "Process aborted during DVD AUTHORING operations! " & vbCrLf & vbCrLf
                End If
                If Flag_Retry = True Then
                    ' Try to launch BatchMux with a batch file. Echo BatchMux output as log file.
                    CL_Params = "-arglist """ & TempPath & "\" & DVDName & "_BatchMux.ini""" & " > """ & TempPath & "\" & DVDName & "_BatchMux.log"""
                    NumFile = FreeFile
                    Open TempPath & "\" & DVDName & "_BatchMux.bat" For Output As #NumFile
                        Print #NumFile, "@echo DVD AUTHORING. Please wait ..." & vbCrLf & _
                                        "@echo " & String(30, "-") & vbCrLf & _
                                        """" & App.Path & "\MuxMan\BatchMux.exe""" & " " & CL_Params
                    Close #NumFile
                    Execute TempPath & "\" & DVDName & "_BatchMux.bat", "", Preferences.EncodingWindowStyle, True
                    modUtil.Sleep 1000
                End If
            End If
            If GetFileSize(OutputPath & "\" & DVDName & "\VIDEO_TS\VIDEO_TS.IFO") > 0 Then
                Flag_End = False
                Err_Message = ""
            Else
                Flag_End = True
                If InStr(1, Err_Message, "user") = 0 Then
                    NumFile = FreeFile
                    Str = ""
                    Open TempPath & "\" & DVDName & "_BatchMux.log" For Input As #NumFile
                        Do Until EOF(NumFile) = True
                            Line Input #NumFile, Str
                            If InStr(1, LCase(Str), "excessive bitrate") <> 0 Or InStr(1, LCase(Str), "video decoder buffer underflowed") <> 0 Then
                                Err_Message = Err_Message & "DVD Authoring operation failed, probably caused by excessive bitrate." & vbCrLf & _
                                                            "Decrease video and/or audio bitrates and then retry the project." & vbCrLf & vbCrLf
                                Exit Do
                            End If
                        Loop
                    Close NumFile
                    Err_Message = Err_Message & _
                                  "Check following files for more details: " & vbCrLf & vbCrLf & _
                                  "AVStoDVD log file <" & OutputPath & "\" & DVDName & ".log> " & vbCrLf & _
                                  "BatchMux log file <" & OutputPath & "\" & DVDName & "_BatchMux.log>" & vbCrLf & vbCrLf & _
                                  "For more troubleshooting on Authoring issues, see Help/FAQ/Authoring."
                    If OutputPath <> TempPath Then
                        modFS.DeleteIfExist OutputPath & "\" & DVDName & "_BatchMux.log"
                        modUtil.Sleep 1000
                        FileCopy TempPath & "\" & DVDName & "_BatchMux.log", OutputPath & "\" & DVDName & "_BatchMux.log"
                    End If
                End If
                modMain.Save_Log_Video Err_Message, False, True
                modMain.Save_Log OutputPath & "\" & DVDName & ".log", Err_Message, True
                If Flag_DeleteAssets = True Then
                    MBR = frmQuestion.Display(frmMain, "Do you want to keep the temporary DVD assets files?" & vbCrLf & vbCrLf & "Default 'Yes'", , 30)
                    If MBR = vbYes Then Flag_DeleteAssets = False
                End If
            End If
            If Flag_End = False Then
                ' Check DVD Size
                Output_DVD_FileSize = Round(modUtil.GetDirSize(OutputPath & "\" & DVDName & "\VIDEO_TS") / 1024 / 1024, 1)
                Output_Assets_FileSize = Round(Output_Assets_FileSize, 1)
                Flag = False
                If Output_DVD_FileSize < 0.9 * Output_Assets_FileSize Then Flag = True
                If Flag = True Then
                    modMain.Save_Log_Video "Warning! DVD Folder filesize (" & Output_DVD_FileSize & " MB) is much lower than the total Assets filesize (" & Output_Assets_FileSize & " MB).", , True
                End If
                ' Log Authoring
                modMain.Save_Log_Video "DVD authoring operations have been completed."
                sLog = "END DVD AUTHORING OPERATIONS" & vbCrLf & "Created Folder: " & OutputPath & "\" & DVDName & " (" & Output_DVD_FileSize & " MB)" & vbCrLf & vbCrLf & _
                       "CHECK DVD SIZE" & vbCrLf & _
                       "DVD Folder (actual) Size: " & Output_DVD_FileSize & " MB" & vbCrLf & _
                       "vs Estimated Size: " & frmMain.Txt_Estimated_Output_Size.Text & " MB -> " & Format(Abs((Output_DVD_FileSize - Val(frmMain.Txt_Estimated_Output_Size.Text))) / Val(frmMain.Txt_Estimated_Output_Size.Text), "0.0%") & IIf(Val(frmMain.Txt_Estimated_Output_Size.Text) > Output_DVD_FileSize, " undersize", " oversize") & vbCrLf & _
                       "vs Assets Size: " & Output_Assets_FileSize & " MB -> " & IIf(Flag = True, "Warning!", "OK")
                modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                frmProgress.Update_Progress 4, False
            End If
            ' Delete temporary files
            If Flag_DeleteAssets = True Then
                For Tj = 1 To NumTitles
                    If VideoPathName(Tj) = AssetsPath & "\" & TitleName(Tj) & ".m2v" Then
                        modFS.DeleteIfExist VideoPathName(Tj)
                        modFS.DeleteIfExist LCase(VideoPathName(Tj))
                    End If
                    For jj = 1 To Val(Title(Tj).InputGeneralInfo.AudioTracksCount)
                        modFS.DeleteIfExist AudioPathName(Tj, jj)
                    Next jj
                    For jj = 1 To Val(Title(Tj).InputGeneralInfo.SubsTracksCount)
                        modFS.DeleteIfExist SubsPathName(Tj, jj)
                    Next jj
                    modFS.DeleteIfExist AssetsPath & "\" & TitleName(Tj) & "_Chapters.txt"
                Next Tj
                For jj = 1 To DVDMenu.NumMenuPages
                    modFS.DeleteIfExist AssetsPath & "\" & DVDName & "_MenuPage" & jj & ".m2v"
                    modFS.DeleteIfExist AssetsPath & "\" & DVDName & "_MenuPage" & jj & ".bmp"
                Next jj
                modFS.DeleteIfExist AssetsPath & "\" & DVDName & "_Menu.ac3"
                modFS.DeleteIfExist AssetsPath & "\" & DVDName & "_Menu.sst"
            End If
        End If
        If OutputSetup = DVD_Folder Then Flag_End = True
        
        ' ISO building operations
        If Flag_End = False And OutputSetup = ISO_UDF_Image Then
            OperationSection = "ISO building operations"
            modMain.Save_Log_Video "ISO Image building operations started."
            frmProgress.Update_Progress 5, True
            CL_Params = "/mode isobuild /buildmode imagefile /src """ & OutputPath & "\" & DVDName & "\VIDEO_TS""" & " /dest """ & OutputPath & "\" & DVDName & ".iso""" & " /volumelabel """ & DVD_Label & """ /overwrite yes /noimagedetails /start /close"
            sLog = "START ISO IMAGE BUILDING OPERATIONS" & vbCrLf & "ImgBurn (ISO) Parameters: " & CL_Params
            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
            Execute ImgBurnPathName, CL_Params, SW_DEFAULT, True
            If GetFileSize(OutputPath & "\" & DVDName & ".iso") > 0 Then
                sLog = "END ISO IMAGE BUILDING OPERATIONS" & vbCrLf & "Created File: " & OutputPath & "\" & DVDName & ".iso (" & Round(GetFileSize(OutputPath & "\" & DVDName & ".iso") / 1024 / 1024, 1) & " MB)"
                modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
                modMain.Save_Log_Video "ISO Image building operations have been completed."
                frmProgress.Update_Progress 5, False
            Else
                Err_Message = "Process aborted during ISO Image building operations."
                modMain.Save_Log_Video Err_Message & vbCrLf & vbCrLf & _
                                       "For more info on current project check log file <" & OutputPath & "\" & DVDName & ".log>.", False, True
                modMain.Save_Log OutputPath & "\" & DVDName & ".log", Err_Message, True
                Flag_End = True
                If Flag_DeleteAssets = True Then
                    MBR = frmQuestion.Display(frmMain, "Do you want to keep the temporary DVD Assets files?" & vbCrLf & vbCrLf & "Default 'Yes'", , 30)
                    If MBR = vbYes Then Flag_DeleteAssets = False
                End If
            End If
            If Flag_DeleteAssets = True Then
                Kill OutputPath & "\" & DVDName & "\VIDEO_TS\*.*"
                DeleteIfExist OutputPath & "\" & DVDName & "\VIDEO_TS", True
                DeleteIfExist OutputPath & "\" & DVDName & "\AUDIO_TS", True
                DeleteIfExist OutputPath & "\" & DVDName, True
            End If
        End If
        If OutputSetup = ISO_UDF_Image Then Flag_End = True
        
        ' DVD burning operations
        If Flag_End = False Then
            OperationSection = "DVD burning operations"
            modMain.Save_Log_Video "DVD burning operations started."
            frmProgress.Update_Progress 6, True
            Err_Message = ""
            CL_Params = "/mode isobuild /buildmode device /src """ & OutputPath & "\" & DVDName & "\VIDEO_TS""" & " /dest " & Left(Preferences.DVDBurningDrive, 2) & " /volumelabel """ & DVD_Label & """ /speed " & Preferences.DVDBurningSpeed & " " & IIf(Preferences.DVDAutoErase = True, "/erase", "") & " /testmode no /verify no /noimagedetails /start /waitformedia /close /log """ & TempPath & "\" & DVDName & "_ImgBurn.log"""
            sLog = "START DVD BURNING OPERATIONS" & vbCrLf & "ImgBurn (DVD) Parameters: " & CL_Params
            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
            Execute ImgBurnPathName, CL_Params, SW_DEFAULT, True
            ' Read ImgBurn log
            NumFile = FreeFile
            Flag = False
            Str = ""
            sLog = ""
            Open TempPath & "\" & DVDName & "_ImgBurn.log" For Input As #NumFile
            Do Until EOF(NumFile) = True
                Line Input #NumFile, Str
                If InStr(1, Str, "Operation Started!") <> 0 Then
                    Flag = True
                    Exit Do
                End If
            Loop
            If Flag = True Then
                Flag = False
                Do Until EOF(NumFile) = True
                    Line Input #NumFile, Str
                    If InStr(1, Str, "Operation Successfully Completed!") <> 0 Then
                        Flag = True
                    End If
                    If InStr(1, Str, "Average Write Rate:") <> 0 Then
                        sLog = "A" & modStr.StrTrimRight(Str, "A")
                    End If
                Loop
            End If
            Close #NumFile
            If Flag = True Then
                modMain.Save_Log_Video "DVD burning operations have been completed."
                frmProgress.Update_Progress 6, False
                sLog = "END DVD BURNING OPERATIONS" & vbCrLf & _
                       "Created DVD: '" & DVD_Label & "' in drive " & Preferences.DVDBurningDrive & vbCrLf & _
                       sLog
            Else
                sLog = "Process aborted during DVD BURNING operations."
                modMain.Save_Log_Video sLog & vbCrLf & vbCrLf & _
                                       "For more info on current project check log file <" & OutputPath & "\" & DVDName & ".log>.", False, True
            End If
            modMain.Save_Log OutputPath & "\" & DVDName & ".log", sLog, True
        End If
        
        ' End log and clean up
        OperationSection = "End log and clean up"
        Set MInfo = Nothing
        Set OutputVideoInfo = Nothing
        Set OutputAudioInfo = Nothing
        With Preferences
            modMain.Save_Log OutputPath & "\" & DVDName & ".log", "Log file created by " & frmMain.StatusBar.Panels("Release").Text, True
            If frmMain.intDeleteWorking.value = 1 Then
                modFS.DeleteIfExist TempPath & "\" & DVDName & "_HighlightScheme.csm"
                modFS.DeleteIfExist TempPath & "\" & DVDName & "_TitleText.ass"
                modFS.DeleteIfExist TempPath & "\" & DVDName & "_BatchMux.ini"
                modFS.DeleteIfExist TempPath & "\" & DVDName & "_BatchMux.hcn"
                modFS.DeleteIfExist TempPath & "\" & DVDName & "_BatchMux.bat"
                modFS.DeleteIfExist TempPath & "\" & DVDName & "_BatchMux.log"
                modFS.DeleteIfExist TempPath & "\" & DVDName & "_MuxMan.mxp"
                modFS.DeleteIfExist TempPath & "\" & DVDName & "_MuxMan.log"
                modFS.DeleteIfExist TempPath & "\" & DVDName & "_Palette.txt"
                modFS.DeleteIfExist TempPath & "\" & DVDName & "_ImgBurn.log"
                modFS.DeleteIfExist TempPath & "\Picture.avs"
                modFS.DeleteIfExist TempPath & "\Picture.bmp"
                For jj = 1 To DVDMenu.NumMenuPages
                    modFS.DeleteIfExist TempPath & "\" & DVDName & "_MenuPage" & jj & ".avs"
                    modFS.DeleteIfExist TempPath & "\" & DVDName & "_MenuPage" & jj & "_Buttons.mnu"
                Next jj
                For Tj = 1 To NumTitles
                    modFS.DeleteIfExist TempPath & "\" & DVDName & "_Thumb_" & Tj & "_AviSynthT.avs"
                    modFS.DeleteIfExist TempPath & "\" & DVDName & "_Thumb_" & Tj & ".bmp"
                    modFS.DeleteIfExist TempPath & "\" & DVDName & "_Thumb_" & Tj & "_Video.avs"
                    modFS.DeleteIfExist TempPath & "\" & DVDName & "_ThumbLabelText" & Tj & ".ass"
                Next Tj
            End If
        End With
        If frmMain.ListView.ListItems.Item(frmMain.ListView.ListItems.Count).SmallIcon <> 7 Then   ' 7 -> error icon
            modMain.Save_Log_Video IIf(InStr(1, frmProgress.Caption, "/") = 0, "AVStoDVD Project ended successfully.", "AVStoDVD Job" & StrTrimRight(StrTrimLeft(frmProgress.Caption, "-"), "-") & "ended successfully.")
        End If
        frmProgress.Finish
    End If
    
    Exit Sub
    
Err_Handling:
Select Case Err.Number
Case 70 'Autorizzazione negata
    Resume Next
Case Else
    Set MInfo = Nothing
    Set OutputVideoInfo = Nothing
    Set OutputAudioInfo = Nothing
    ' Restore ffdshow mixer
    If Preferences.ffdshowRuntime = True And modReg.EmiLeggiChiaveNumero("HKEY_CURRENT_USER\Software\GNU\ffdshow_audio\default", "mixerOut", 999) <> 999 Then
        modReg.ScriviChiaveNumero "HKEY_CURRENT_USER\Software\GNU\ffdshow_audio\default", "mixerOut", ffdshow.MixerBackup
    End If
    ' Save error log
    If modFS.EsisteDir(OutputPath) = True Then
        modMain.Save_Log OutputPath & "\" & DVDName & ".log", "ERROR DURING OPERATIONS ('" & OperationSection & "' Section): " & Err.Number & " - " & Err.Description, True
        modMain.Save_Log OutputPath & "\" & DVDName & ".log", "PROCESS ABORTED.", True
        modMain.Save_Log OutputPath & "\" & DVDName & ".log", "Log file created by " & frmMain.StatusBar.Panels("Release").Text, True
    Else
        MsgBox "Process aborted during '" & OperationSection & "' Section." & vbCrLf & vbCrLf & "Error code: " & Err.Number & " - " & Err.Description, vbCritical, App.Title
    End If
    modMain.Save_Log_Video "Process aborted during '" & OperationSection & "' Section. Error code: " & Err.Number & " " & Err.Description
    ' Unload forms
    Unload frmMessage
    Unload frmTextBox
    If modUtil.FormIsLoad("frmProgress") = True Then frmProgress.Finish
    Screen.MousePointer = vbDefault
End Select

End Sub

