Attribute VB_Name = "modStrings"
' -------------------------------------------------------------------------------
'
'   AVStoDVD - by MrC
'   File: modStrings.bas
'   Purpose: General utility string-related function
'
' -------------------------------------------------------------------------------


Option Explicit
Option Compare Binary
Option Base 0


Declare Function MultiByteToWideChar Lib "kernel32" ( _
    ByVal CodePage As Long, ByVal dwFlags As Long, _
    ByVal lpMultiByteStr As Long, ByVal cchMultiByte As Long, _
    ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long
Declare Function lstrlenW Lib "kernel32" (ByVal pStr As Long) As Long
Declare Sub RtlMoveMemory Lib "kernel32" (pDst As Any, pSrc As Any, ByVal bLen As Long)


' Remove a char from beginning and end of a string
Public Function RemoveCharBegEnd(Str As String, Char As String, Optional Char2 As String) As String

    Dim Flag As Boolean
    
    On Error GoTo Err_Handling
    
    RemoveCharBegEnd = Str
    If RemoveCharBegEnd <> "" Then
        Do Until Flag = True
            If Left(RemoveCharBegEnd, 1) = Char Then
                RemoveCharBegEnd = Right(RemoveCharBegEnd, Len(RemoveCharBegEnd) - 1)
            End If
            If RemoveCharBegEnd = "" Then Exit Function
            If Left(RemoveCharBegEnd, 1) = Char2 Then
                RemoveCharBegEnd = Right(RemoveCharBegEnd, Len(RemoveCharBegEnd) - 1)
            End If
            If RemoveCharBegEnd = "" Then Exit Function
            If Right(RemoveCharBegEnd, 1) = Char Then
                RemoveCharBegEnd = Left(RemoveCharBegEnd, Len(RemoveCharBegEnd) - 1)
            End If
            If RemoveCharBegEnd = "" Then Exit Function
            If Right(RemoveCharBegEnd, 1) = Char2 Then
                RemoveCharBegEnd = Left(RemoveCharBegEnd, Len(RemoveCharBegEnd) - 1)
            End If
            If RemoveCharBegEnd = "" Then Exit Function
            If Left(RemoveCharBegEnd, 1) <> Char And Left(RemoveCharBegEnd, 1) <> Char2 And Right(RemoveCharBegEnd, 1) <> Char And Right(RemoveCharBegEnd, 1) <> Char2 Then
                Flag = True
            End If
        Loop
    End If
    
    Exit Function
    
Err_Handling:
RemoveCharBegEnd = Str

End Function


' Remove part (Str) of a string
Public Function RemoveStr(FullStr As String, Str As String) As String

    On Error GoTo Err_Handling
        
    If InStr(1, FullStr, Str) <> 0 Then
        RemoveStr = Mid(FullStr, 1, InStr(1, FullStr, Str) - 1) & _
                    Mid(FullStr, InStr(1, FullStr, Str) + Len(Str), Len(FullStr) - InStr(1, FullStr, Str) + Len(Str))
    End If
    If RemoveStr = "" Then
        RemoveStr = FullStr
    End If
    
    Exit Function
    
Err_Handling:
RemoveStr = FullStr

End Function


' Remove NULL characters from a string
Public Function StripNull(ByRef FixedString As String) As String
     
    Dim NullPos As Long
     
    ' Remove null terminator
    NullPos = InStr(1, FixedString, Chr(0) & Chr(0))
    If NullPos > 0 Then
        StripNull = Mid(FixedString, 1, NullPos - 1)
    Else
        StripNull = FixedString
    End If
    
End Function


' Return a time in seconds in hours:minutes:seconds.milliseconds format
Public Function VisualTime(ByVal DurationSeconds As Single, Optional ShortFormat As Boolean, Optional Add_ms As Boolean) As String

    Dim TimeSplit() As String
    Dim ms As Integer
    
    VisualTime = Format(Int(DurationSeconds) / 24 / 3600, "hh.nn.ss")
    TimeSplit = Split(VisualTime, ".")
    If Round(DurationSeconds - Int(DurationSeconds), 3) = 1 Then
        TimeSplit(2) = TimeSplit(2) + 1
        ms = 0
    Else
        ms = Round(DurationSeconds - Int(DurationSeconds), 3) * 1000
    End If
    If ShortFormat = False Then
        If Val(TimeSplit(0)) > 0 Then
            VisualTime = Val(TimeSplit(0)) & ":" & TimeSplit(1) & ":" & TimeSplit(2) & " hours"
        ElseIf Val(TimeSplit(1)) > 0 Then
            VisualTime = Val(TimeSplit(1)) & ":" & TimeSplit(2) & " minutes"
        Else
            VisualTime = Val(TimeSplit(2)) & " seconds"
        End If
    Else
        VisualTime = TimeSplit(0) & ":" & TimeSplit(1) & ":" & TimeSplit(2)
        If Add_ms = True Then
            VisualTime = VisualTime & "." & PadLeft(ms, "0", 3)
        End If
    End If
   
End Function


' Pad the left side of a string with a character
Public Function PadLeft(ByVal InString As String, ByVal PadChar As String, TargetLength As Long) As String

    On Error GoTo Err_Handling
    
    If Len(InString) < TargetLength Then
        PadLeft = String(TargetLength - Len(InString), PadChar) & InString
    Else
        PadLeft = InString
    End If
    
    Exit Function
    
Err_Handling:
PadLeft = InString

End Function


' Left Trim a string until TrimChar is found
Public Function StrTrimLeft(StrOrig As String, TrimChar As String)
    
    On Error GoTo Err_Handling
    
    If StrOrig <> "" And TrimChar <> "" And InStr(1, StrOrig, TrimChar) <> 0 Then
        StrTrimLeft = StrOrig
        Do Until Right(StrTrimLeft, 1) = TrimChar
            StrTrimLeft = Left(StrTrimLeft, Len(StrTrimLeft) - 1)
        Loop
        StrTrimLeft = Left(StrTrimLeft, Len(StrTrimLeft) - 1)
    End If
    Exit Function
    
Err_Handling:
StrTrimLeft = ""

End Function


' Right Trim a string until TrimChar is found
Function StrTrimRight(StrOrig As String, TrimChar As String) As String

    On Error GoTo Err_Handling
    
    If StrOrig <> "" And TrimChar <> "" And InStr(1, StrOrig, TrimChar) <> 0 Then
        StrTrimRight = StrOrig
        Do Until Left(StrTrimRight, 1) = TrimChar
            StrTrimRight = Right(StrTrimRight, Len(StrTrimRight) - 1)
        Loop
        StrTrimRight = Right(StrTrimRight, Len(StrTrimRight) - 1)
    End If
    
    Exit Function
    
Err_Handling:
StrTrimRight = ""

End Function


' Returns a 6 chars String representing the hexadecimal value of a number
Public Function CHex(ByVal Number As Long) As String

    Dim SixCharString As String
    
    SixCharString = String(6 - Len(Hex(Number)), "0") & Hex(Number)
    CHex = Right(SixCharString, 2) & Mid(SixCharString, 3, 2) & Left(SixCharString, 2)
    
End Function


' Remove reserved/special chars from string
'   \  -> chr(92)
'   /  -> chr(47)
'   :  -> chr(58)
'   *  -> chr(42)
'   ?  -> chr(63)
'   "  -> chr(34)
'   <  -> chr(60)
'   >  -> chr(62)
'   |  -> chr(124)
'   CR -> chr(13)
'   LF -> chr(10)
Public Function RemoveSpecialChars(StrOrig As String) As String

    Dim jj As Integer
  
    On Error GoTo Err_Handling
    
    For jj = 1 To Len(StrOrig)
        Select Case Asc(Mid(StrOrig, jj, 1))
        Case 10, 13, 34, 42, 47, 58, 60, 62, 63, 92, 124
            RemoveSpecialChars = RemoveSpecialChars & ""
        Case Else
            RemoveSpecialChars = RemoveSpecialChars & Mid(StrOrig, jj, 1)
        End Select
    Next jj
    
    Exit Function

Err_Handling:
RemoveSpecialChars = ""

End Function
 
 
' Return true if Extended ASCII chars are found
Public Function HasExtendedChars(StrOrig As String) As Boolean

    Dim jj As Integer
    
    On Error GoTo Err_Handling
    
    For jj = 1 To Len(StrOrig)
        If Asc(Mid(StrOrig, jj, 1)) > 127 Then
            HasExtendedChars = True
            Exit For
        End If
    Next jj

    Exit Function

Err_Handling:
HasExtendedChars = False

End Function

 
 ' Convert a C wchar* to a Visual Basic string
Public Function bstr(ptr As Long) As String
  
  Dim l As Long

  l = lstrlenW(ptr)
  bstr = String$(l, vbNullChar)

  RtlMoveMemory ByVal StrPtr(bstr), ByVal ptr, l * 2

End Function


' Converts a UTF-8 byte array to a Unicode string
Public Function sUTF8toUni(bySrc() As Byte) As String

    Const CP_UTF8 = 65001

    Dim lBytes As Long, lNC As Long, lRet As Long

    lBytes = UBound(bySrc) - LBound(bySrc) + 1
    lNC = lBytes
    sUTF8toUni = String$(lNC, Chr(0))
    lRet = MultiByteToWideChar(CP_UTF8, 0, VarPtr(bySrc(LBound(bySrc))), lBytes, StrPtr(sUTF8toUni), lNC)
    sUTF8toUni = Left$(sUTF8toUni, lRet)

End Function


' Convert a UTF8 text file into a ANSI text file
Public Sub UTF8FiletoANSIFile(sUTF8File As String, sANSIFile As String, Optional bSRT As Boolean)

    Dim iFile As Integer
    Dim bData() As Byte
    Dim sData As String
    Dim lSize As Long
    Dim jj As Long

    ' Get the incoming data size
    lSize = FileLen(sUTF8File)
    If lSize > 0 Then
        ReDim bData(0 To lSize - 1)

        ' Read the existing UTF-8 file
        iFile = FreeFile()
        Open sUTF8File For Binary As #iFile
            Get #iFile, , bData
        Close #iFile

        ' Convert all the data to Unicode (all VB Strings are Unicode)
        sData = sUTF8toUni(bData)
        
        ' Handle SRT subs output
        If bSRT = True Then
            For jj = 1 To Len(sData)
                If Mid(sData, jj, 1) = "1" Then
                    Exit For
                End If
            Next jj
            sData = Right(sData, Len(sData) - jj + 1)
        End If
    Else
        sData = ""
    End If

    ' Now write it all out to the ANSI file
    iFile = FreeFile()
    Open sANSIFile For Output As #iFile
        Print #iFile, sData
    Close iFile
    
End Sub


' Output a ANSI string to a UTF8 text file
Public Sub sANSItoUTF8File(Str As String, PathNameSave As String)
   
   Dim fso, MyFile
   
   Set fso = CreateObject("Scripting.FileSystemObject")
   Set MyFile = fso.CreateTextFile(PathNameSave, True, True)
   MyFile.WriteLine (Str)
   MyFile.Close

End Sub


' Convert a long digit representing a color into RGB string
Public Function LongtoRGB(lColor As Long) As String

    LongtoRGB = (lColor And 255) & "," & (Int(lColor / 256) And 255) & "," & (Int(lColor / 65536) And 255)
    
End Function
