Attribute VB_Name = "modSubs"
' -------------------------------------------------------------------------------
'
'   AVStoDVD - by MrC
'   File: modSubs.bas
'   Purpose: Subtitles related functions
'
' -------------------------------------------------------------------------------


Option Explicit
Option Compare Binary
Option Base 0



Public Function Parse_Subs_SRT(InputPathName As String) As Collection

    ' Input file must be in ANSI format
    
    Dim sLine As String
    Dim sSub As String
    Dim NumFile As Integer
    Dim jj As Integer
    Dim bStartSub As Boolean
    Dim bEndSub As Boolean
    
    On Error GoTo Err_Handling
    
    ' Initialize
    Set Parse_Subs_SRT = New Collection
    sSub = ""
    bStartSub = False
    
    ' Open srt file
    NumFile = FreeFile
    Open InputPathName For Input As #NumFile
        Do Until EOF(NumFile) = True
            ' Grab sub #1
            Do Until bStartSub = True
                Line Input #NumFile, sLine
                If IsNumeric(sLine) = True Then
                    bStartSub = True
                End If
            Loop
            jj = Int(Val(sLine))
            ' Grab time
            Do
                Line Input #NumFile, sLine
            Loop Until InStr(1, sLine, "-->") <> 0
            sSub = jj & vbCrLf & sLine
            ' Grap sub text
            bEndSub = False
            Do
                Line Input #NumFile, sLine
                If IsNumeric(sLine) = True Then
                    If Val(sLine) = jj + 1 Then
                        bEndSub = True
                        bStartSub = True
                    End If
                End If
                If bEndSub = False Then
                    If sLine <> "" Then
                        sSub = sSub & vbCrLf & sLine
                    End If
                    bEndSub = EOF(NumFile)
                End If
            Loop Until bEndSub = True
            If Right(sSub, 2) = vbCrLf Then
                sSub = Left(sSub, Len(sSub) - 2)
            End If
            ' Fill collection
            Parse_Subs_SRT.add sSub, Str(jj)
        Loop
    Close #NumFile
    
    Exit Function
    
Err_Handling:
Set Parse_Subs_SRT = Nothing
    
End Function


Public Function Fix_SRT(InputPathName As String, OutputPathName As String) As Long

    ' Function returns # subs fixed
    ' 0 means no fixed subs (no errors)
    ' -1 means general runtme error
        
    Dim SRT_Subs As New Collection
    Dim SRT_Subs_Fixed As New Collection
    Dim NumFile As Integer
    Dim jj As Integer
    Dim kk As Integer
    Dim ii As Integer
    Dim bCheck As Boolean
    Dim sSub As String
    Dim InputSub
    Dim bFixed As Boolean
    
    On Error GoTo Err_Handling
        
    Screen.MousePointer = vbHourglass

    ' Fix SRT
    Set SRT_Subs = Parse_Subs_SRT(InputPathName)
    With SRT_Subs
        For jj = 1 To .Count
            bFixed = False
            sSub = ""
            InputSub = Split(.Item(jj), vbCrLf)
            For kk = 2 To UBound(InputSub)
                sSub = sSub & InputSub(kk) & vbCrLf
            Next kk
            sSub = Left(sSub, Len(sSub) - 2)
            ' Remove CR+LF at the end of the line
            If Len(sSub) > 2 And Right(sSub, 2) = vbCrLf Then
                bFixed = True
                sSub = Left(sSub, Len(sSub) - 2)
            End If
            ' Remove CR+LF at the beginning of the line
            bCheck = False
            Do
                If Len(sSub) > 2 And Left(sSub, 2) = vbCrLf Then
                    bFixed = True
                    sSub = Right(sSub, Len(sSub) - 2)
                Else
                    bCheck = True
                End If
            Loop Until bCheck = True
            ' Remove </> at the beginning of the line
            If Len(sSub) > 3 And Left(sSub, 3) = "</>" Then
                bFixed = True
                sSub = Right(sSub, Len(sSub) - 3)
            End If
            ' Replace "< " with "- " at the beginning of line
            If Left(sSub, 2) = "< " Then
                bFixed = True
                sSub = Replace(sSub, "< ", "- ")
            End If
            ' Replace "> " with "- " at the beginning of line
            If Left(sSub, 2) = "> " Then
                bFixed = True
                sSub = Replace(sSub, "> ", "- ")
            End If
            ' Replace "(" with ""
            If InStr(1, sSub, "(") <> 0 Then
                bFixed = True
                sSub = Replace(sSub, "(", Chr(171))
            End If
            ' Replace "[" with ""
            If InStr(1, sSub, "[") <> 0 Then
                bFixed = True
                sSub = Replace(sSub, "[", Chr(171))
            End If
            ' Replace ")" with ""
            If InStr(1, sSub, ")") <> 0 Then
                bFixed = True
                sSub = Replace(sSub, ")", Chr(187))
            End If
            ' Replace "]" with ""
            If InStr(1, sSub, "]") <> 0 Then
                bFixed = True
                sSub = Replace(sSub, "]", Chr(187))
            End If
            ' Replace "''" with """
            If InStr(1, sSub, "''") <> 0 Then
                bFixed = True
                sSub = Replace(sSub, "''", Chr(34))
            End If
            ' Remove "spaces" at the end of timestamps line
            Do Until Right(InputSub(1), 1) <> " "
                bFixed = True
                InputSub(1) = Left(InputSub(1), Len(InputSub(1)) - 1)
            Loop
            ' Skip hh:mm:ss,mmm --> 00:00:00,000 timestamp
            bCheck = False
            If InStr(1, InputSub(1), "--> 00:00:00,000") <> 0 Then
                bCheck = True
            End If
            ' Skip duplicate timestamps
            If bCheck = False Then
                For kk = 1 To SRT_Subs_Fixed.Count
                    If InStr(1, SRT_Subs_Fixed.Item(kk), InputSub(1)) <> 0 Then
                        bCheck = True
                    End If
                Next kk
            End If
            If bCheck = False Then
                ii = ii + 1
                SRT_Subs_Fixed.add ii & vbCrLf & InputSub(1) & vbCrLf & sSub, Str(ii)
            Else
                bFixed = True
            End If
            Fix_SRT = Fix_SRT - CInt(bFixed)
        Next jj
    End With
    
    ' Output SRT
    With SRT_Subs_Fixed
        NumFile = FreeFile
        Open OutputPathName For Output As #NumFile
            For ii = 1 To .Count
                Print #NumFile, .Item(ii) & vbCrLf
            Next ii
        Close #NumFile
    End With
    
    If Dir(OutputPathName) = "" Then
        GoTo Err_Handling
    Else
        GoTo Exit_Function
    End If
    
Err_Handling:
Fix_SRT = -1

Exit_Function:
Set SRT_Subs = Nothing
Set SRT_Subs_Fixed = Nothing
Screen.MousePointer = Default
    
End Function


Public Function Parse_Subs_ASS(InputPathName As String) As Collection

    Dim sLine As String
    Dim aLine
    Dim NumFile As Integer
    Dim bStartSub As Boolean
    Dim jj As Integer
    Dim kk As Integer
    Dim Temp_Sub_ASS As Collection
    Dim iLayer As Integer
    Dim sSub As String
    
    On Error GoTo Err_Handling
    
    ' Initialize
    Set Parse_Subs_ASS = New Collection
    Set Temp_Sub_ASS = New Collection
    bStartSub = False
 
    ' Open ass file
    NumFile = FreeFile
    Open InputPathName For Input As #NumFile
        Do Until EOF(NumFile) = True
            ' Identify subs start
            Do Until bStartSub = True
                Line Input #NumFile, sLine
                If sLine = "[Events]" Then
                    Line Input #NumFile, sLine
                    bStartSub = True
                End If
            Loop
            Line Input #NumFile, sLine
            aLine = Split(sLine, ",")
            ' Fill temp collection
            If UBound(aLine) >= 9 Then
                If IsNumeric(Right(aLine(0), 1)) = True Then
                    If InStr(1, LCase(aLine(0)), "dialogue") <> 0 Then
                        sSub = ""
                        For kk = 9 To UBound(aLine)
                            sSub = sSub & aLine(kk)
                            If kk < UBound(aLine) Then sSub = sSub & ","
                        Next kk
                        If sSub <> "" Then
                            jj = jj + 1
                            Temp_Sub_ASS.add sLine, CStr(jj)
                        End If
                    End If
                End If
            End If
        Loop
    Close #NumFile
    ' Find lowest layer
    iLayer = 32767
    For jj = 1 To Temp_Sub_ASS.Count
        aLine = Split(Temp_Sub_ASS.Item(jj), ",")
        If Val(Right(aLine(0), 1)) < iLayer Then
            iLayer = Val(Right(aLine(0), 1))
        End If
    Next jj
    ' Fill collection with lowest layer only
    kk = 0
    For jj = 1 To Temp_Sub_ASS.Count
        aLine = Split(Temp_Sub_ASS.Item(jj), ",")
        If Val(Right(aLine(0), 1)) = iLayer Then
            kk = kk + 1
            Parse_Subs_ASS.add Temp_Sub_ASS.Item(jj), CStr(kk)
        End If
    Next jj
 
    Exit Function
    
Err_Handling:
Resume
Set Parse_Subs_ASS = Nothing
    
End Function


Public Function Convert_ASS_to_SRT(InputPathName As String, OutputPathName As String) As Long

    Dim ASS_Subs As New Collection
    Dim SRT_Subs As New Collection
    Dim aASS
    Dim jj As Integer
    Dim kk As Integer
    Dim ii As Integer
    Dim TimeStart As String
    Dim TimeEnd As String
    Dim sSub As String
    Dim NumFile As Integer
    Dim bFlag As Boolean
    Dim lStart As Long
    Dim lEnd As Long
    
    On Error GoTo Err_Handling
        
    Screen.MousePointer = vbHourglass

    Set ASS_Subs = Parse_Subs_ASS(InputPathName)
    ' Convert collections
    With ASS_Subs
        If .Count > 0 Then
            For jj = 1 To .Count
                aASS = Split(.Item(jj), ",")
                TimeStart = aASS(1)
                TimeStart = "0" & Replace(TimeStart, ".", ",") & "0"
                TimeEnd = aASS(2)
                TimeEnd = "0" & Replace(TimeEnd, ".", ",") & "0"
                sSub = aASS(9)
                ' Handle subs with a comma inside
                If UBound(aASS) > 9 Then
                    For kk = 10 To UBound(aASS)
                        sSub = sSub & "," & aASS(kk)
                    Next kk
                End If
                ' Convert CR+LF
                sSub = Replace(sSub, "\N", vbCrLf)
                sSub = Replace(sSub, "\n", vbCrLf)
                ' Convert italic formatting
                sSub = Replace(sSub, "{\i1}", "<i>")
                sSub = Replace(sSub, "{\i0}", "</i>")
                ' Convert bold formatting
                sSub = Replace(sSub, "{\b1}", "<b>")
                sSub = Replace(sSub, "{\b0}", "</b>")
                ' Convert underline formatting
                sSub = Replace(sSub, "{\u1}", "<u>")
                sSub = Replace(sSub, "{\u0}", "</u>")
                ' Remove strikeout formatting
                sSub = Replace(sSub, "{\s1}", "")
                sSub = Replace(sSub, "{\s0}", "")
                ' Remove other formatting
                bFlag = False
                Do
                    lStart = InStr(1, sSub, "{\")
                    lEnd = InStr(1, sSub, "}")
                    If lStart > 0 And lEnd > 0 Then
                        sSub = Mid(sSub, 1, lStart - 1) & Mid(sSub, lEnd + 1, Len(sSub) - lEnd)
                    End If
                    bFlag = CBool(lStart * lEnd)
                Loop Until bFlag = False
                ' Populate collection
                If sSub <> "" Then
                    ii = ii + 1
                    SRT_Subs.add ii & vbCrLf & TimeStart & " --> " & TimeEnd & vbCrLf & sSub
                End If
            Next jj
        End If
    End With
     ' Output SRT
    With SRT_Subs
        NumFile = FreeFile
        Open OutputPathName For Output As #NumFile
            For jj = 1 To .Count
                Print #NumFile, .Item(jj) & vbCrLf
            Next jj
        Close #NumFile
    End With
    Convert_ASS_to_SRT = ii

    GoTo Exit_Function
    
Err_Handling:
Convert_ASS_to_SRT = -1

Exit_Function:
Set SRT_Subs = Nothing
Set ASS_Subs = Nothing
Screen.MousePointer = Default

End Function

Public Function Fix_IDX(InputPathName As String, OutputPathName As String) As Long

    ' Function returns # subs fixed
    ' 0 means no fixed subs (no errors)
    ' -1 means general runtme error
        
    Dim NumFile As Integer
    Dim sInputIDX As String
    Dim sBin As String * 1

    On Error GoTo Err_Handling
        
    Screen.MousePointer = vbHourglass
    
    NumFile = FreeFile
    Open InputPathName For Binary As #NumFile
        Do Until EOF(NumFile) = True
            Get #NumFile, , sBin
            If EOF(NumFile) = False Then
                If sBin = Chr(0) Then
                    Fix_IDX = Fix_IDX + 1
                    sInputIDX = sInputIDX & ""
                Else
                    sInputIDX = sInputIDX & sBin
                End If
            End If
        Loop
    Close #NumFile
    If sInputIDX <> "" Then
        NumFile = FreeFile
        Open OutputPathName For Output As #NumFile
            Print #NumFile, sInputIDX
        Close #NumFile
    End If

    GoTo Exit_Function
    
Err_Handling:
Fix_IDX = -1

Exit_Function:
Screen.MousePointer = Default

End Function
